<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Home extends MX_Controller {

    public $data;
	
	function __construct() {
		parent::__construct();
		$this->load->model('videos/videos_model');
		$this->load->helper('datetime');
	}
	
	public function index($kaltura_video_id = NULL)
    {
		$this->template->set_title('Home');
		
		$this->template->add_js('modules/videos.js');
		
		if($kaltura_video_id == NULL) {
			$video = $this->videos_model->get_latest_video();
			$kaltura_video_id = $video->kaltura_video_id;
		} 
		
		$this->data['player'] = Modules::run('videos/player', $kaltura_video_id);
		$this->data['videos'] = Modules::run('videos/listing');
		
		$this->template->load_view('index', $this->data);
	}
	
	public function search(){
		$keyword = $this->input->get_post('keyword'); 
		$this->load->library('kaltura/kaltura');
		$videos = $this->videos_model->search_events($keyword);
		$search_list= array();
		if($videos){
			foreach($videos as $row){
				$search_list[] = $this->kaltura->kvideo($row->kaltura_video_id);
			}
		}
		$this->data['search_list']=$search_list;
		$this->template->load_view('videos/search_listing', $this->data);
		
	}
	
	public function termsOfService(){
		$this->template->set_title('Terms Of Service');
		$this->template->load_view('term_of_service', $this->data);
	}
	public function viewerPrivacy(){
		$this->template->set_title('Viewer Privacy');
		$this->template->load_view('viewer_privacy', $this->data);
	}
}