<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

if ( ! function_exists('dateDiff'))
{
    function dateDiff($time1, $time2, $precision = 6) {
		// If not numeric then convert texts to unix timestamps
		if (!is_int($time1)) {
		  $time1 = strtotime($time1);
		}
		if (!is_int($time2)) {
		  $time2 = strtotime($time2);
		}
	 
		// If time1 is bigger than time2
		// Then swap time1 and time2
		if ($time1 > $time2) {
		  $ttime = $time1;
		  $time1 = $time2;
		  $time2 = $ttime;
		}
	 
		// Set up intervals and diffs arrays
		$intervals = array('year','month','day','hour','minute','second');
		$diffs = array();
	 
		// Loop thru all intervals
		foreach ($intervals as $interval) {
		  // Create temp time from time1 and interval
		  $ttime = strtotime('+1 ' . $interval, $time1);
		  // Set initial values
		  $add = 1;
		  $looped = 0;
		  // Loop until temp time is smaller than time2
		  while ($time2 >= $ttime) {
			// Create new temp time from time1 and interval
			$add++;
			$ttime = strtotime("+" . $add . " " . $interval, $time1);
			$looped++;
		  }
	 
		  $time1 = strtotime("+" . $looped . " " . $interval, $time1);
		  $diffs[$interval] = $looped;
		}
		
		$count = 0;
		$times = array();
		// Loop thru all diffs
		foreach ($diffs as $interval => $value) {
		  // Break if we have needed precission
		  if ($count >= $precision) {
			break;
		  }
		  // Add value and interval 
		  // if value is bigger than 0
		  if ($value > 0) {
	 // Add s if value is not 1
	 if ($value != 1) {
	   $interval .= "s";
	 }
	 // Add value and interval to times array
	 $times[] = $value . " " . $interval;
	 $count++;
		  }
		}
	 
		// Return string with times
		return implode(", ", $times);
	}
}

if( ! function_exists('humanTiming')) {
	function humanTiming ($time)
	{
		$time = time() - $time; // to get the time since that moment
		$time = ($time<1)? 1 : $time;
		$tokens = array (
			31536000 => 'year',
			2592000 => 'month',
			604800 => 'week',
			86400 => 'day',
			3600 => 'hour',
			60 => 'minute',
			1 => 'second'
		);

		foreach ($tokens as $unit => $text) {
			if ($time < $unit) continue;
			$numberOfUnits = floor($time / $unit);
			return $numberOfUnits.' '.$text.(($numberOfUnits>1)?'s':'');
		}
	}
}


	if( !function_exists('frameTimeFormat')){
		function frameTimeFormat($startTime, $endTime){
				/* $s1 = intval($startTime/1000);
				
				hours = parseInt( $s1 / 3600 );
				
				$frameStartTime = sprintf('%02d:%02d:%02d', ($s1 / 3600), ($s1 / 60 % 60), $s1 % 60);
				
				$s2 = intval($endTime/1000);
				$frameEndTime = $s2 / 60 % 60;
				
				$frameEndTime = sprintf('%02d:%02d:%02d', ($s2 / 3600), ($s2 / 60 % 60), $s2 % 60);
				 */
				$frameStartTime= timeChange($startTime); 
				$frameEndTime= timeChange($endTime);
				
				return "$frameStartTime - $frameEndTime";
				
				
		 
		}
	}
	
	function timeChange($ms){
		
        $seconds = intval($ms / 1000);
		// 2- Extract hours:
		$hours = intval( $seconds / 3600 ); // 3,600 seconds in 1 hour
		$seconds = $seconds % 3600; // seconds remaining after extracting hours
		// 3- Extract minutes:
		$minutes = intval( $seconds / 60 ); // 60 seconds in 1 minute
		// 4- Keep only seconds not extracted to minutes:
		$seconds = $seconds % 60;
		//alert( hours+" hours and "+minutes+" minutes and "+seconds+" seconds!" );
		
		if($hours >0 && $hours < 10){
			$hours= "0$hours:"; 
		}
		else if($hours >0 && $hours >= 10){
			$hours= "$hours:"; 
		}
		else {
			if($minutes > 0){
				$hours="0:";
			}
			else{
				$hours="";
			}
			
		}
		
		if($minutes >0 && $minutes < 10){
			$minutes= "0$minutes:"; 
		}
		else if($minutes >0 && $minutes >= 10){
			$minutes= "$minutes:"; 
		}
		else {
			if($seconds > 0){
				$minutes="0:";
			}
			else {
				$minutes="0:00";
			}
			
		}
		
		if($seconds >0 && $seconds < 10){
			$seconds= "0$seconds"; 
		}
		else if($seconds >0 && $seconds >= 10){
			$seconds= "$seconds"; 
		}
		else {
			$seconds="";
		}
		
		
		return "$hours$minutes$seconds";
		
	}
