<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Bwt_magento {

	var $ci;
	
	public function __construct() {
	
		require_once ("../tagframemagento/app/Mage.php");
		
		umask(0);
		Mage::app('default');
		Mage::getSingleton('core/session', array('name' => 'frontend'));
		$session = Mage::getSingleton('customer/session', array('name'=>'frontend'));
	}
	
	public function login($email) {
		//https://magento.stackexchange.com/questions/8720/how-to-call-a-controller-action-outside-magento
		// Init a Magento session. This is super ultra important
		//Mage::getSingleton('core/session', array('name' => 'frontend'));
		//Mage::getSingleton('customer/session')->start();

		// $customer Mage_Customer_Model_Customer
		// We get an instance of the customer model for the actual website
		$customer = Mage::getModel('customer/customer')->setWebsiteId(Mage::app()->getStore()->getWebsiteId());

		$customer->loadByEmail($email);

		$session = Mage::getSingleton('customer/session')->start();
		
		$session->loginById($customer->getId());
		$session->setCustomerAsLoggedIn($session->getCustomer());
	}
	
	public function logout() {
		Mage::getSingleton('customer/session')->logout();
	}
	
	public function mage_url() {
	
		$url = array();
		
		$url['mage_baseUrl'] = Mage::getBaseUrl();
		$url['mage_skinUrl'] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_SKIN);
		$url['mediaUrl'] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_MEDIA);
		$url['storeUrl'] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB);
		
		return $url;
	}
	
	public function signup($fields = array()) 
	{
		$email = $fields['email'];
		$username = $fields['username'];
		$password = $fields['password'];
		$firstname = $fields['first_name'];
		$lastname = $fields['last_name'];
		
		// Website and Store details
		$websiteId = Mage::app()->getWebsite()->getId();
		$store = Mage::app()->getStore();

		$customer = Mage::getModel("customer/customer");
		$customer->website_id = $websiteId;
		$customer->setStore($store);
		
		/*$customer->firstname = $firstname;
		$customer->lastname = $lastname;
		$customer->email = $email;
		$customer->password_hash = md5($password);
		$customer->save();*/

		try {
			// If new, save customer information
			$customer->firstname = $firstname;
			$customer->lastname = $lastname;
			$customer->email = $email;
			$customer->password_hash = md5($password);
			$customer->save();
			
			// Become a seller
			$status = 1;
			$assinstatus = "Seller";
			$customerid = $customer->getId();
			$profileurl = $username;
			
			$collection=Mage::getModel('marketplace/userprofile');
			$collection->setwantpartner($status);
			$collection->setpartnerstatus($assinstatus);
			$collection->setmageuserid($customerid);
			$collection->setProfileurl($profileurl);
			$collection->save();
			
		}catch(Exception $e){
			// If customer already exists, initiate login
			if(preg_match('/Customer email already exists/', $e)){
			
				$this->login($email);
			}
		}
	}
	
	public function product_search($keyword,$page_number) {
		$collection = Mage::getModel('catalog/product')
						->getCollection()
						->setPageSize(10)
						->setCurPage($page_number)
						->addAttributeToSelect('*')
						->addAttributeToFilter('status', array('eq' => Mage_Catalog_Model_Product_Status::STATUS_ENABLED))
						->addAttributeToFilter('name', array('like' => "%$keyword%"));
		return $collection;
	}
	public function product_search_all($page_number) {
		$collection = Mage::getModel('catalog/product')
						->getCollection()
						->setPageSize(10)
						->setCurPage($page_number)
						->addAttributeToSelect('*')
						->addAttributeToFilter('status', array('eq' => Mage_Catalog_Model_Product_Status::STATUS_ENABLED));
						
		return $collection;
	}


    public function product_count() {
		$collection = Mage::getModel('catalog/product')
						->getCollection()
                        ->setPageSize(10)
						->addAttributeToSelect('*')
						->addAttributeToFilter('status', array('eq' => Mage_Catalog_Model_Product_Status::STATUS_ENABLED));
						
		return $collection->getLastPageNumber();
	}

    public function product_count_for_search() {
		$collection = Mage::getModel('catalog/product')
						->getCollection()
                        ->setPageSize(10)
						->addAttributeToSelect('*')
						->addAttributeToFilter('status', array('eq' => Mage_Catalog_Model_Product_Status::STATUS_ENABLED))
                        ->addAttributeToFilter('name', array('like' => "%$keyword%"));
						
		return $collection->getLastPageNumber();
	}

	public function get_product($product_id) {
		$obj = Mage::getModel('catalog/product');
		$_product = $obj->load($product_id);
		
		/*echo $_product->getName();
		echo $_product->getShortDescription();
		echo $_product->getDescription();
		echo $_product->getPrice();
		echo $_product->getSpecialPrice();
		echo $_product->getProductUrl();
		echo $_product->getImageUrl(); 
		*/
		
		return $_product;
	}
	
	public function get_seller($product_id) {
	
		$helper = Mage::helper('marketplace');
		$productowner = Mage::getModel('marketplace/product')->isCustomerProduct($product_id);
		
		if($productowner['userid']!=""){
			$captchenable = Mage::getStoreConfig('marketplace/marketplace_options/captcha',Mage::app()->getStore());
			$rowsocial=Mage::getModel('marketplace/userprofile')->getPartnerProfileById($productowner['userid']);
			$seller_id = $productowner['userid'];
			$shoptitle = $rowsocial['shoptitle'];
			$seller = Mage::getModel('customer/customer')->load($seller_id);	
			if(!$shoptitle){
				$shoptitle = $seller->getName();
			}
			$feeds=$helper->getFeed($seller_id);
		} 
		else {
			$shoptitle = FALSE;
		}
		
		return $shoptitle;
	}
	
	public function get_seller_products($email) {
		$filter = '';
		$filter_prostatus = '';
		$filter_data_frm = '';
		$filter_data_to = '';
		$from = null;
		$to = null;
		
    	//$userId=Mage::getSingleton('customer/session')->getCustomer()->getId();
		$userId = $this->getCustomerId($email);
		
		$collection = Mage::getModel('marketplace/product')->getCollection()->addFieldToFilter('userid',array('eq'=>$userId));
		$products=array();
		foreach($collection as $data){
			array_push($products,$data->getMageproductid());
		}
		if(isset($_GET['s'])){
            $filter = $_GET['s'] != ""?$_GET['s']:"";
		}
		if(isset($_GET['prostatus'])){
            $filter_prostatus = $_GET['prostatus'] != ""?$_GET['prostatus']:"";
		}
		if(isset($_GET['from_date'])){
            $filter_data_frm = $_GET['from_date'] != ""?$_GET['from_date']:"";
		}
		if(isset($_GET['to_date'])){
            $filter_data_to = $_GET['to_date'] != ""?$_GET['to_date']:"";
		}
		if($filter_data_to){
			$todate = date_create($filter_data_to);
			$to = date_format($todate, 'Y-m-d 23:59:59');
		}
		if($filter_data_frm){
			$fromdate = date_create($filter_data_frm);
			$from = date_format($fromdate, 'Y-m-d H:i:s');
		}

		$collection = Mage::getModel('catalog/product')->getCollection()
						   ->addAttributeToSelect('*')
						   ->addFieldToFilter('name',array('like'=>"%".$filter."%"));
		if($filter_prostatus){
			$collection->addFieldToFilter('status',array('like'=>"%".$filter_prostatus."%"));
		}
						  
		$collection->addFieldToFilter('created_at', array('datetime' => true,'from' => $from,'to' =>  $to))
				   ->addFieldToFilter('entity_id',array('in'=>$products))
				   ->setOrder('entity_id','AESC');
				   
		return $collection;
	}
	
	public function getCustomerId($email = false) {
		if( ! $email) {
			if(Mage::getSingleton('customer/session')->isLoggedIn()) {
				$customerData = Mage::getSingleton('customer/session')->getCustomer();
				return $customerData->getId();
			}
		} 
		else {
			$customer = Mage::getModel('customer/customer');
			$customer->setWebsiteId(Mage::app()->getWebsite()->getId());
			$customer->loadByEmail($email);
			
			return $customer->getId();
		}
	}
	
	/*public function products($category_id){
	
		$json = array('success' => true, 'products' => array());
		$category = Mage::getModel ('catalog/category')->load($category_id);
		$products = Mage::getResourceModel('catalog/product_collection')
					  // ->addAttributeToSelect('*')
					  ->AddAttributeToSelect('name')
					  ->addAttributeToSelect('price')
					  ->addFinalPrice()
					  ->addAttributeToSelect('small_image')
					  ->addAttributeToSelect('image')
					  ->addAttributeToSelect('thumbnail')
					  ->addAttributeToSelect('short_description')
					  ->addUrlRewrite()
					  ->AddCategoryFilter($category);
		Mage::getSingleton('catalog/product_visibility')->addVisibleInCatalogFilterToCollection($products);
		$currencyCode = Mage::app()->getStore()->getBaseCurrencyCode();
		foreach($products as $product){ 
			$json['products'][] = array(
					'id'                    => $product->getId(),
					'name'                  => $product->getName(),
					'description'           => $product->getShortDescription(),
					'price'                 => Mage::helper('core')->currency($product->getPrice(), true, false), //." ".$currencyCode,
					'href'                  => $product->getProductUrl(),
					'thumb'                 => (string)Mage::helper('catalog/image')->init($product, 'thumbnail')
				);
		}
		return $json;
	}*/
}
