<?php
defined('BASEPATH') OR exit('No direct script access allowed');

    class Common_lib {
	    
		
		protected $CI;
		public function __construct()
        {
			$this->CI =& get_instance();
			$this->CI->load->model('ws_model');
			$this->CI->load->model('videos/videos_model');
			$this->CI->load->library('ion_auth');
            $this->CI->load->model('common_model');		 
			
		}
		
		function frame_permission($video_id){
		
			if ( ! $this->CI->ion_auth->logged_in()) {
				return 'not_logged_in';
			} 
			else {
				$user_id = $this->CI->ion_auth->get_user_id();
				$video_id = $video_id;
				
				$video = $this->CI->videos_model->get_video('id', $video_id, $kaltura_user_id='');
				$friend_id = $video->user_id;
				
				$this->CI->load->model('friends/friends_model');
				$check_friend = $this->CI->friends_model->get_friend($user_id, $friend_id);
				
				if($video->type == 'public') {
					return 'true';
				} 
				else if(!empty($check_friend) /*&& $video->type =='friends'*/ ) {
					return 'true';
				} 
				else if($user_id == $video->user_id) {
					return 'true';
				} 
				else {
					return 'false';
				}
			}
		}
		
		
		function humanTiming($user_id,$created_on)
		{
			
			$currentTime= $this->currentTime($user_id);
			$createdTime= $created_on;
			$time = $currentTime - $createdTime; // to get the time since that moment
			$time = ($time<1)? 1 : $time;
			$tokens = array (
				31536000 => 'year',
				2592000 => 'month',
				604800 => 'week',
				86400 => 'day',
				3600 => 'hour',
				60 => 'minute',
				1 => 'second'
			);

			foreach ($tokens as $unit => $text) {
				if ($time < $unit) continue;
				$numberOfUnits = floor($time / $unit);
				return $numberOfUnits.' '.$text.(($numberOfUnits>1)?'s':'');
			}

		}
		public function dateTime($user_id){
			$get_time_zone= $this->CI->ws_model->get_time_zone($user_id);
			if($get_time_zone){
				 $time_zone=$get_time_zone->time_zone;
				date_default_timezone_set($time_zone);
			}
			
			$date= date('Y-m-d H:i:s');
			return $date;
		}
		
		public function setTimeZone($user_id,$time){
			$get_time_zone= $this->CI->ws_model->get_time_zone($user_id);
			if($get_time_zone){
				 $time_zone=$get_time_zone->time_zone;
				date_default_timezone_set($time_zone);
			}
			
			//$datetime= date('F d, Y G:i A', $time);
			$datetime= date('F d, Y g:i A', $time);
			return $datetime;
		}
		
		function currentTime($user_id){
			$currentTime= strtotime($this->dateTime($user_id));
			return $currentTime;
		}
		
		function date_to_time($user_id,$date){
			$get_time_zone= $this->CI->ws_model->get_time_zone($user_id);
			if($get_time_zone){
				 $time_zone=$get_time_zone->time_zone;
				date_default_timezone_set($time_zone);
			}
			
			$date_to_time= strtotime($date);
			return $date_to_time;
			
		}
		
		/* Notification sending */ 
		
		public function notification($from_user_id,$to_user_id,$action_type,$event_id){
			
			$notificationData= array(
			'from_user_id'=>$from_user_id,
			'to_user_id'=>$to_user_id,
			'action_type'=>$action_type,
			'event_id'=>$event_id,
			'is_view'=>0,
			'created_on'=>$this->dateTime($from_user_id)
			);
			
			$user = $this->CI->ion_auth->user($from_user_id)->row();
			$user_name = $user->first_name;	
			
			$this->CI->common_model->insert_notification($notificationData);
			$device_session= $this->CI->common_model->get_user_session($to_user_id);
			
			if(!empty($device_session)){
				foreach($device_session as $session){
					$reg_id= $session->reg_token;
					$user_id=$session->user_id;
					$notifyMessage=$this->push_notification_message($event_id,$action_type);
					
					if(!empty($notifyMessage)){
					$message=$notifyMessage['message'];
					$sub_action_id=$notifyMessage['sub_action_id'];
					$sub_action_type=$notifyMessage['sub_action_type'];
					$title= $user_name;	
					$this->send_fcm_notify($reg_id, $message,$sub_action_id,$sub_action_type,$title,$user_id);
						
					}
					
				}
			}
			
		}
		
		function push_notification_message($event_id,$action_type){
			$notifyMessage=array();
			if(!empty($event_id)){
				if($action_type==1){
					$table= 'videos';	
					$action= "has added an event";	
					$sub_action_type="watch_event";
				}
				else if($action_type==2){
					$table= 'ads_frame';
					$action='has added a frame';
					$sub_action_type="watch_frame";					
				}
				else if($action_type==3){
					$table= 'ads_frame';
					$action='has edited a frame';	
					$sub_action_type="watch_frame";					
				}
				else if($action_type==4){
					$table1= 'friend_requests';
					$action='followed';
					$sub_action_type="watch_profile";
				}
				else if($action_type==5){
					$table1= 'friend_requests';
					$action='unfollowed';
					$sub_action_type="watch_profile";
				}
				else if($action_type==6){
					$comment_id= strstr("$event_id",",",true);
					$event_id= substr("$event_id", strpos("$event_id", ",") + 1);
					$table= 'videos';
					$action='has commented on an event';
					$sub_action_type="watch_comment";
				}
				else if($action_type==7){
					$comment_id= strstr("$event_id",",",true);
					$event_id= substr("$event_id", strpos("$event_id", ",") + 1);
					$table= 'videos';
					$action='has replyed on a comment';
					$sub_action_type="watch_comment";
				}
				else if($action_type==8){
					$table= 'videos';
					$action='has liked an event ';
					$sub_action_type="watch_event";
				}
				else if($action_type==9){
							
					$table2= 'product';
					$action='has endorsed a product to you';
					$sub_action_type="watch_product";
				}
				else if($action_type==10){
					$table= 'videos';
					$action='has tagged you in an event';
					$sub_action_type="watch_event";
				}
				else{
					$table4= 'Unknown';
					$action='Unknown';
				}
				
				if($table){
					$eventName= $this->CI->common_model->eventName($table,$event_id);
					$event_name=$eventName->title;
					$table="";
				}
				if($table1){
					$eventName= $this->CI->common_model->followUser($event_id);
					$event_name=$eventName->first_name;
					$table1="";
				}
				
				if($table2){
					$magento_product = $this->CI->bwt_magento->get_product($event_id);
					$event_name=$magento_product->getName();
					$table2="";
				}
				if($table3){
					$eventName= $this->CI->common_model->eventName($table3,$event_id);
					$event_name=$eventName->comment;
					$table3="";
				}
				if($table4){
					$table4="";
				}	
				
				$notifyMsg= $action." ".$event_name;
				$notifyMessage=array(
				'message'=>$notifyMsg,
				'sub_action_id'=>$event_id,
				'sub_action_type'=>$sub_action_type
				);
				
			}
			  
				return $notifyMessage;
		}
		
		function send_fcm_notify($reg_id, $message,$sub_action_id,$sub_action_type,$title,$user_id) {
		
			define("GOOGLE_API_KEY", "AIzaSyDZUBjZfX9vxRZHZguJIWCZH8LEXtqCfcs");
			define("GOOGLE_GCM_URL", "https://fcm.googleapis.com/fcm/send");
		
			$fields = array(
				'to'  			=> $reg_id ,
				'priority'		=> "high",
				'notification'  => array( 
				"title"         =>$title, 
				"body"          =>$message
				),
				'data'			=> array("message" =>$message,"sub_action_id" =>$sub_action_id,"sub_action_type" =>$sub_action_type,"user_id" =>$user_id,),
			);
			
			$headers = array(
				GOOGLE_GCM_URL,
				'Content-Type: application/json',
				'Authorization: key=' . GOOGLE_API_KEY 
			);
			
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, GOOGLE_GCM_URL);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
			
			$result = curl_exec($ch);
			if ($result === FALSE) {
				die('Problem occurred: ' . curl_error($ch));
			}
			
			curl_close($ch);
			$decode_result= json_decode($result);
			if(!empty($decode_result)){
				if($decode_result->failure==1){
				  foreach($decode_result->results as $res){
				  $err=$res->error;
				  }
				  if($err=="InvalidRegistration"){
					$this->CI->ws_model->remove_session($user_id,$reg_id);
				  }
				}
			}
		}
    }	