<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Common_model extends CI_Model {

    function __construct() {
		parent::__construct();
	}
	
	function state()
	{
		$query = $this->db->get('states');
		return $query->result();
	}
	
	function country()
	{
		$query = $this->db->get('countries');
		return $query->result();
	}
	
	function insert_tag_stream($streams_data) {
		$this->db->insert('tag_streams', $streams_data);
	}
	
	public function get_tag_streams($user_id, $limit, $offset) {
		$this->db->select('v.*, u.first_name, u.last_name, u.profile_image, ts.product_id, ts.created_on, ts.action_type');
		$this->db->from('tag_streams ts');
		$this->db->join('videos v', 'v.id=ts.event_id', 'left');
		$this->db->join('users u', 'u.id=ts.user_id');
		$this->db->join('friend_requests fr', 'fr.user_to=ts.user_id');
		$this->db->where('fr.user_from', $user_id);
		$this->db->where('fr.request', 1);
		$this->db->order_by('ts.created_on', 'desc');
		$this->db->limit($limit, $offset);
		$query = $this->db->get();
		return $query->result();
	}
	
	public function count_tag_streams($user_id) {
		$this->db->select('v.*');
		$this->db->from('tag_streams ts');
		$this->db->join('videos v', 'v.id=ts.event_id', 'left');
		$this->db->join('users u', 'u.id=ts.user_id');
		$this->db->join('friends_list f', 'f.friend_id=ts.user_id', 'left');
		$this->db->where('f.user_id', $user_id);
		return $this->db->count_all_results();
	}
	
	public function insert_notification($notificationData){
		$this->db->insert('notifications',$notificationData);
		
	}
	public function update_notification($notificationData,$notification_id){
		$this->db->where('id',$notification_id);
		$this->db->update('notifications',$notificationData);
		
	}
	
	/* public function get_notification($user_id, $limit, $offset) {
	$this->db->select('notify.*, u.first_name,u.id as user_id,u.profile_image');
	$this->db->from('notifications notify');
	$this->db->join('users u', 'u.id=notify.from_user_id');
	$this->db->join('friend_requests fr', 'fr.user_to=notify.from_user_id');
	$this->db->where('fr.user_from', $user_id);
	$this->db->where('fr.request', 1);
	$this->db->order_by('notify.created_on', 'desc');
	$this->db->limit($limit, $offset);
	$query = $this->db->get();
	return $query->result();	
	}  */
	
	public function notification_info($notification_id){
		
		$this->db->select('notify.event_id, u.first_name');
		$this->db->from('notifications notify');
		$this->db->join('users u', 'u.id=notify.from_user_id');
		$this->db->where('notify.id', $notification_id);
		$query= $this->db->get();
		return $query->row();
	}
	
	public function get_notification($user_id, $limit, $offset) {
	$this->db->select('notify.*, u.first_name,u.id as user_id,u.profile_image');
	$this->db->from('notifications notify');
	$this->db->join('users u', 'u.id=notify.from_user_id');
	$this->db->where('notify.to_user_id', $user_id);
	$this->db->order_by('notify.created_on', 'desc');
	$this->db->limit($limit, $offset);
	$query = $this->db->get();
	return $query->result();	
	} 
	
	function count_unread_notification($user_id){
		$this->db->where('to_user_id', $user_id);
		$this->db->where('is_view', 0);
		return $this->db->count_all_results('notifications');
	} 
	
	public function followUser($event_id=null){
		$this->db->where('id', $event_id);
		$query= $this->db->get('users');
		return $query->row();
	}
	
	public function eventName($table=null,$event_id=null){
		$this->db->where('id',$event_id);
		$query= $this->db->get("$table");
		return $query->row();
	} 
	
	public function videoName($event_id=null){
		$this->db->where('id', $event_id);
		$query= $this->db->get('videos');
		return $query->row();
	}
	
	function get_friends($user_id=null){
		$this->db->where('user_to',$user_id);
		//$this->db->or_where('user_to',$user_id);
		$this->db->where('request', 1);
		$query= $this->db->get('friend_requests');
		return $query->result();
	}

	function check_device_session($user_id=null,$device_id=null){
		$this->db->where('user_id',$user_id);
		$this->db->where('device_id',$device_id);
		$query= $this->db->get('user_session');
		if($query->num_rows() == 1){
			return TRUE;
		} else {
			return FALSE;
		}
	}
	
	function insert_device_session($deviceSession=null){
		$this->db->insert('user_session',$deviceSession);
		
	}
	
	function update_device_session($user_id=null,$device_id=null,$deviceSession=null){
		$this->db->where('user_id',$user_id);
		$this->db->where('device_id',$device_id);
		$this->db->update('user_session',$deviceSession);
		
	}
	
	function get_user_session($user_id=null){
		$this->db->where('user_id', $user_id);
		$query=$this->db->get('user_session');
		return $query->result();
	}
	
	function remove_device_session($user_id=null,$device_id=null){
		$this->db->where('user_id',$user_id);
		$this->db->where('device_id',$device_id);
		$this->db->delete('user_session');
		
	}
	
	public function get_user($video_id=null){
		$this->db->where('id',$video_id);
		$query= $this->db->get('videos');
		return $query->row();
	}	
	
	
	function check_timeZone($user_id=null){
		$this->db->where('user_id',$user_id);
		$query= $this->db->get('users_time_zone');
		if($query->num_rows() == 1){
			return TRUE;
		} else {
			return FALSE;
		}
	}
	
	function update_timeZone($user_id=null,$timeZoneData=null){
		$this->db->where('user_id',$user_id);
		$this->db->update('users_time_zone',$timeZoneData);
		
	}
	
	function insert_timeZone($timeZoneData=null){
		$this->db->insert('users_time_zone',$timeZoneData);
		
	}
	
	
	
}