<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Marketplace extends MY_Controller {
    public $data;
	
	function __construct() 
	{
		parent::__construct();
		$this->load->library('authentication', NULL, 'ion_auth');
       	$this->load->library('form_validation');
        $this->load->helper('url');
        $this->load->database();
        $this->lang->load('auth');
        $this->load->helper('language');
		$this->load->model('marketplace_model');
		$this->load->model('ws_model');
	}
  
	public function index() {
		
	}
    function search(){
		$this->template->set_title('Friends Search');
        $this->load->model('friends/friends_model');
		
		$email = $this->input->get_post('search');
		$this->data['headsearch']= $headsearch = $this->input->get_post('headsearch');
		$user_id = $this->session->userdata('user_id');
		$this->data['user_id'] = $user_id;
	
		if($email) { 
			
			if(strlen(strrchr($this->input->post('search'), '@')) > 0){
				$this->data['searchs'] = $this->friends_model->get_search_users($user_id, $email);
			} else { 
				$this->data['searchs'] = $this->friends_model->get_search_users_byusername($user_id, $email);
			}
			
			foreach($this->data['searchs'] as $k => $search_user){
				
				$check_request = $this->friends_model->get_request_value($user_id, $search_user->id);
				
				if(!empty($check_request)){
					if($check_request->user_from == $search_user->id and $check_request->user_to == $user_id and $check_request->request == 0){
						
						$this->data['searchs'][$k]->action = 'Accept';
					
					} elseif($check_request->user_from == $user_id and $check_request->user_to == $search_user->id and $check_request->request == 0) {
						$this->data['searchs'][$k]->action = 'Pending';
					} elseif($check_request->request == 1) {
						$this->data['searchs'][$k]->action = 'Friend';
					} else {
						$this->data['searchs'][$k]->action = 'Add';
					}
				} else {
					$this->data['searchs'][$k]->action = 'Add';
				}
			}
		} else { 
			$this->data['searchs'] = '';
		}
		
		// get friends pending request
		$this->data['pending_request'] = $this->friends_model->get_friend_pending_lists($user_id);
		
		// get friends waiting request
		$this->data['waiting_request'] = $this->friends_model->get_friend_waiting_lists($user_id);
		
		$this->template->load_view('friends/friend_search', $this->data);
	}
	
	//Mahesh
	
	public function product_details($notification_id, $product_id)
	{
		$response=array();
        if($product_id){
			$productInfo= $this->common_model->notification_info($notification_id);
			
			$this->load->library('bwt_magento');
			$products = $this->bwt_magento->get_product($product_id);
			$mess= stristr($productInfo->event_id,":");
			$message= substr($mess,1);
			if(!empty($products)){
				$response= array(
					'product_id' => $products->getId(),
					'product_name' => $products->getName(),
					'product_url' => $products->getProductUrl(),
					'product_image' => $products->getImageUrl(),
					'message' => $message,
					'username'=>$productInfo->first_name,
					'product_price'=>number_format($products->getPrice(),2)
				);
				
			}
		}
		//echo "<pre>";print_r($response);die;
		$this->data['response']=$response;
		 $this->template->load_view('marketplace/product_details', $this->data);
	}
	
	public function products()
	{
		$keyword = $this->input->get_post('product_title', true);
        $page_number = $this->input->get_post('page_number', true);
        if(!$page_number){
           $page_number=1;                
        }    
		$this->load->library('bwt_magento');
		if($keyword){
			$products = $this->bwt_magento->product_search($keyword,$page_number);
            $last_page_number = $this->bwt_magento->product_count_for_search();
		}
		else{
		    $products = $this->bwt_magento->product_search_all($page_number);
            $last_page_number = $this->bwt_magento->product_count();
		}
		  
		$records = array();
		if( count($products) > 0){
			foreach($products as $product){
				$records[] = array(
					'product_id' => $product->getId(),
					'product_name' => $product->getName(),
					'product_url' => $product->getProductUrl(),
					'product_image' => $product->getImageUrl(),
					'product_price'=>number_format($product->getPrice(),2)
				);  
			}
		}
		
		//echo "<pre>";print_r($records);	die;
		$this->data['listing']=$records;
		$this->template->load_view('marketplace/listing', $this->data);
	}
	
	public function direct_endorse(){
		
		
		$to_user_id= $this->input->get_post('to_user_id',true);
		$product_id= $this->input->get_post('product_id',true);
		$message= $this->input->get_post('message',true);
		
		$from_user_id = $this->session->userdata('user_id');
		
		if(!$this->ion_auth->logged_in() OR !$from_user_id OR !$to_user_id OR !$product_id){
			$response = array(
				'status' => 'error',
			);
		}
		else{
			
			
			$direct_endorse_data=array(
			'from_user_id' => $from_user_id,
			'to_user_id' => $to_user_id,
			'product_id' => $product_id,
			'message' => $message,
			'date' => $this->dateTime($from_user_id)
			);
			$id= $this->ws_model->insert_direct_endorse($direct_endorse_data);
			
			if($id){
				$response = array(
					'status' => 'success',
				);
				$to_user =$to_user_id;
			}
			
		}
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
		
		if($response['status']=="success"){
			
			$from_user_id=$from_user_id;
			$to_user_id=$to_user;
			$action_type =9;
			$event_id =$product_id.':'.$message;
			
            if($from_user_id !=$to_user_id){
				$this->notification($from_user_id,$to_user_id,$action_type,$event_id);
			}			
		}		
		
	}
	
	
	public function endorsement(){
		$from_user_id = $user_id=  $this->ion_auth->get_user_id();
		if(!$this->ion_auth->logged_in()){
			redirect('auth/login');
		}
		$this->data['followers'] = Modules::run('tagstream/followers');
		$this->data['following'] = Modules::run('tagstream/following');
		
		$endorsedata=array();
		$endorse_data=$this->ws_model->get_direct_endorse($from_user_id);
		if(!empty($endorse_data)){
			foreach($endorse_data as $endors){
				
				$magento_product = $this->bwt_magento->get_product($endors->product_id);
				$user = $this->ion_auth->user($endors->to_user_id)->row();
				$profile_image="";
				if($user->profile_image){
					$profile_image =base_url().$user->profile_image;
				}
				$newDate = date("m-d-Y", strtotime($endors->date));
				$endorsedata[]=array(
				'from_user_id' =>$endors->from_user_id,
				'to_user_id' => $endors->to_user_id,
				'product_id' => $endors->product_id,
				'message' => $endors->message,
				'endorse_date' => $newDate,
				'user_name' =>$user->first_name,
				'user_image' =>$profile_image,
				'product_name' => $magento_product->getName(),
				'product_image' => $magento_product->getImageUrl()
				);
				
			}
		}
		//echo "<pre>";print_r($endorsedata);	die;
		$this->data['endorsements']=$endorsedata;
		$this->template->load_view('my_endorsements', $this->data);
	}
	
	/*Time Format */
	
	function humanTiming($user_id,$created_on)
	{
		
		$currentTime= $this->currentTime($user_id);
		$createdTime= $created_on;
		$time = $currentTime - $createdTime; // to get the time since that moment
		$time = ($time<1)? 1 : $time;
		$tokens = array (
			31536000 => 'year',
			2592000 => 'month',
			604800 => 'week',
			86400 => 'day',
			3600 => 'hour',
			60 => 'minute',
			1 => 'second'
		);
		foreach ($tokens as $unit => $text) {
			if ($time < $unit) continue;
			$numberOfUnits = floor($time / $unit);
			return $numberOfUnits.' '.$text.(($numberOfUnits>1)?'s':'');
		}
    }
	public function dateTime($user_id){
		$get_time_zone= $this->ws_model->get_time_zone($user_id);
		if($get_time_zone){
			 $time_zone=$get_time_zone->time_zone;
			date_default_timezone_set($time_zone);
		}
		
		$date= date('Y-m-d H:i:s');
		return $date;
	}
	
	public function setTimeZone($user_id,$time){
		$get_time_zone= $this->ws_model->get_time_zone($user_id);
		if($get_time_zone){
			 $time_zone=$get_time_zone->time_zone;
			date_default_timezone_set($time_zone);
		}
		
		//$datetime= date('F d, Y G:i A', $time);
		$datetime= date('F d, Y g:i A', $time);
		return $datetime;
	}
	
	function currentTime($user_id){
		$currentTime= strtotime($this->dateTime($user_id));
		return $currentTime;
	}
	
	function date_to_time($user_id,$date){
		$get_time_zone= $this->ws_model->get_time_zone($user_id);
		if($get_time_zone){
			 $time_zone=$get_time_zone->time_zone;
			date_default_timezone_set($time_zone);
		}
		
		$date_to_time= strtotime($date);
		return $date_to_time;
		
	}
	
	/* Notification sending */ 
	
	public function notification($from_user_id,$to_user_id,$action_type,$event_id){
		
		$notificationData= array(
		'from_user_id'=>$from_user_id,
		'to_user_id'=>$to_user_id,
		'action_type'=>$action_type,
		'event_id'=>$event_id,
		'is_view'=>0,
		'created_on'=>$this->dateTime($from_user_id)
		);
		
		$user = $this->ion_auth->user($from_user_id)->row();
		$user_name = $user->first_name;	
		
		$this->common_model->insert_notification($notificationData);
		$device_session= $this->common_model->get_user_session($to_user_id);
		
		if(!empty($device_session)){
			foreach($device_session as $session){
				$reg_id= $session->reg_token;
				$user_id=$session->user_id;
				$notifyMessage=$this->push_notification_message($event_id,$action_type);
				
				if(!empty($notifyMessage)){
				$message=$notifyMessage['message'];
				$sub_action_id=$notifyMessage['sub_action_id'];
				$sub_action_type=$notifyMessage['sub_action_type'];
				$title= $user_name;	
				$this->send_fcm_notify($reg_id, $message,$sub_action_id,$sub_action_type,$title,$user_id);
					
				}
				
			}
	    }
		
    }
	
	function push_notification_message($event_id,$action_type){
		$notifyMessage=array();
		if(!empty($event_id)){
			if($action_type==1){
				$table= 'videos';	
				$action= "has added an event";	
				$sub_action_type="watch_event";
			}
			else if($action_type==2){
				$table= 'ads_frame';
				$action='has added a frame';
				$sub_action_type="watch_frame";					
			}
			else if($action_type==3){
				$table= 'ads_frame';
				$action='has edited a frame';	
				$sub_action_type="watch_frame";					
			}
			else if($action_type==4){
				$table1= 'friend_requests';
				$action='followed';
				$sub_action_type="watch_profile";
			}
			else if($action_type==5){
				$table1= 'friend_requests';
				$action='unfollowed';
				$sub_action_type="watch_profile";
			}
			else if($action_type==6){
				$comment_id= strstr("$event_id",",",true);
				$event_id= substr("$event_id", strpos("$event_id", ",") + 1);
				$table= 'videos';
				$action='has commented on an event';
				$sub_action_type="watch_comment";
			}
			else if($action_type==7){
				$comment_id= strstr("$event_id",",",true);
				$event_id= substr("$event_id", strpos("$event_id", ",") + 1);
				$table= 'videos';
				$action='has replyed on a comment';
				$sub_action_type="watch_comment";
			}
			else if($action_type==8){
				$table= 'videos';
				$action='has liked an event ';
				$sub_action_type="watch_event";
			}
			else if($action_type==9){
						
				$table2= 'product';
				$action='has endorsed a product to you';
				$sub_action_type="watch_product";
			}
			else if($action_type==10){
				$table= 'videos';
				$action='has tagged you in an event';
				$sub_action_type="watch_event";
			}
			else{
				$table4= 'Unknown';
				$action='Unknown';
			}
			
			if($table){
				$eventName= $this->common_model->eventName($table,$event_id);
				$event_name=$eventName->title;
				$table="";
			}
			if($table1){
				$eventName= $this->common_model->followUser($event_id);
				$event_name=$eventName->first_name;
				$table1="";
			}
			
			if($table2){
				$magento_product = $this->bwt_magento->get_product($event_id);
				$event_name=$magento_product->getName();
				$table2="";
			}
			if($table3){
				$eventName= $this->common_model->eventName($table3,$event_id);
				$event_name=$eventName->comment;
				$table3="";
			}
			if($table4){
				$table4="";
			}	
			
			$notifyMsg= $action." ".$event_name;
			$notifyMessage=array(
			'message'=>$notifyMsg,
			'sub_action_id'=>$event_id,
			'sub_action_type'=>$sub_action_type
			);
			
		}
		  
			return $notifyMessage;
	}
	
	function send_fcm_notify($reg_id, $message,$sub_action_id,$sub_action_type,$title,$user_id) {
	
		define("GOOGLE_API_KEY", "AIzaSyDZUBjZfX9vxRZHZguJIWCZH8LEXtqCfcs");
		define("GOOGLE_GCM_URL", "https://fcm.googleapis.com/fcm/send");
	
        $fields = array(
			'to'  			=> $reg_id ,
			'priority'		=> "high",
            'notification'  => array( 
			"title"         =>$title, 
			"body"          =>$message
			),
			'data'			=> array("message" =>$message,"sub_action_id" =>$sub_action_id,"sub_action_type" =>$sub_action_type,"user_id" =>$user_id,),
        );
		
        $headers = array(
			GOOGLE_GCM_URL,
			'Content-Type: application/json',
            'Authorization: key=' . GOOGLE_API_KEY 
        );
		
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, GOOGLE_GCM_URL);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
		
        $result = curl_exec($ch);
        if ($result === FALSE) {
            die('Problem occurred: ' . curl_error($ch));
        }
		
        curl_close($ch);
		$decode_result= json_decode($result);
		if(!empty($decode_result)){
		    if($decode_result->failure==1){
			  foreach($decode_result->results as $res){
			  $err=$res->error;
			  }
			  if($err=="InvalidRegistration"){
				$this->ws_model->remove_session($user_id,$reg_id);
			  }
		    }
		}
    }
	
}