<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Product extends MY_Controller {
    public $data;
	
	function __construct() 
	{
		parent::__construct();
		$this->load->model('admin/product_model');
	}
	
	function index( $offset=null)
    {
		$this->data['title'] = "Products";
		
		$this->load->library('pagination');
		$totalRows = $this->product_model->get_total_product();
		
		$config['base_url'] = base_url().'product/admin/product/index/';
		$config['total_rows'] = $totalRows->num;
		$config['per_page'] = 10;
		$config['uri_segment'] = 5;
		$config['num_links'] = 5;
		$config['full_tag_open'] = '<ul class="pagination list_style">';
        $config['full_tag_close'] = '</ul><!--pagination-->';
		$config['first_link'] = '&laquo; First';
		$config['first_tag_open'] = '<li class="prev page">';
		$config['first_tag_close'] = '</li>';
		$config['last_link'] = 'Last &raquo;';
		$config['last_tag_open'] = '<li class="next page">';
		$config['last_tag_close'] = '</li>';
		$config['next_link'] = '>';
		$config['next_tag_open'] = '<li class="next page">';
		$config['next_tag_close'] = '</li>';
		$config['prev_link'] = '<';
		$config['prev_tag_open'] = '<li class="prev page">';
		$config['prev_tag_close'] = '</li>';
		$config['cur_tag_open'] = '<li class="active"><a href="">';
		$config['cur_tag_close'] = '</a></li>';
		$config['num_tag_open'] = '<li class="page">';
		$config['num_tag_close'] = '</li>';
		$this->pagination->initialize($config);
		
		if($totalRows->num >= $config['per_page'])	{
			$limit = $config['per_page'];
		}else{
			$limit = $totalRows->num;
		} 
		$offset = ($this->uri->segment($config['uri_segment'])) ? $this->uri->segment($config['uri_segment']) : 0; 
		//print_r($offset);die;
		$this->data['pagination'] = $this->pagination->create_links(); 
        $this->data['lists'] = $this->product_model->get_all_products( $limit,$offset);
		
		$this->load->view('admin/index',$this->data);
    }
	
	public function product_edit($product_id) {
		
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login', 'refresh');
		}
		$this->data['title'] = 'Product Edit';
		$this->data['product_id'] = $product_id;
		
		$this->form_validation->set_rules('product_name', 'product_name', 'trim|required');
		$this->form_validation->set_rules('category', 'category', 'trim|required');
		$this->form_validation->set_rules('desc_name', 'desc_name', 'trim|required');
		$this->form_validation->set_rules('price', 'price', 'trim|required');
		$this->form_validation->set_rules('qty', 'qty', 'trim|required');
		$this->form_validation->set_error_delimiters('<div class="error">', '</div>');
		
		if($this->form_validation->run() == true) {
			if ( $_FILES && $_FILES['video_file']['name'] ) {
				
				$this->load->library('upload');
				$uploadPath = 'media/products/';
				$config['upload_path'] = $uploadPath;
				$config['allowed_types'] = 'jpg|png|jpeg';
				$config['encrypt_name'] = TRUE;
				$this->upload->initialize($config);
				
				if (!$this->upload->do_upload('video_file')) {
					$this->data['error'] = $this->upload->display_errors();
					$this->session->set_flashdata('error',$this->data['error']);
					$imagePath = 'error';
					redirect('product/admin/product/product_edit');
				} else {
					$imagedata = $this->upload->data(); 
					$configImageResize = array(
						'source_image' => $config['upload_path'].$imagedata['file_name']
					);
					$video_detail = $configImageResize['source_image'];
					$this->session->set_flashdata('message', 'Your profile image is uploaded successfully...');
				}
				
				$imagedata['new_path']='media/thumbnail';
				$config['image_library'] = 'GD2';
				$config['source_image'] = $imagedata['full_path'];
				$config['create_thumb'] = TRUE;
				$config['maintain_ratio'] = TRUE;
				$config['width'] = 140;
				$config['height'] = 160;
				$config['new_image']=$imagedata['new_path'];
				
				$this->load->library('image_lib', $config);
				$this->image_lib->resize();
				
				$new_image = array('file_name' => $imagedata['file_name']);
				$where = array('product_id'=>$product_id);
				$this->product_model->update('product_images',$new_image,$where);
			}
			
			$product_data = array(
				'name' => $this->input->post('product_name', true),
                'description'  => $this->input->post('desc_name', true),
				'quantity'    => $this->input->post('qty', true),
				'price'    => $this->input->post('price', true),
            );
			
			$new_category = $this->input->post('category');
			$cat_update = array('category_id' => $new_category);
			$where = array('product_id' => $product_id);
			$id = $this->product_model->update('category_products',$cat_update,$where);
			
			$where = array('id' => $product_id);
			$id1 = $this->product_model->update('products',$product_data,$where);
			$this->session->set_flashdata('message', 'Product updated successfully.');
			redirect('product/admin/product');
		}
		
		$this->data['category'] = $this->product_model->get_all_category();
		
		$this->data['products'] = $this->product_model->get_product_details($product_id);
		//echo "<pre>"; print_r($this->data['category']); die;
		$this->load->view('product/admin/edit_product', $this->data);
	}
	
	public function product_details($id) {
		
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login', 'refresh');
		}
		$this->data['title'] = 'Product Details';
		$this->data['product_details'] = $this->product_model->get_product_detail($id);
		$this->data['product_images'] = $this->product_model->get_product_images($id,$this->data['product_details']->profile_image);
		
		$this->load->view('product/admin/product_details', $this->data);
	}
	
	
	//--------------- Praveen
	
	function product_lists( $user_id, $offset=null)
    {
		$this->data['title'] = "Product Lists";
		
		$this->load->library('pagination');
		$totalRows = $this->product_model->get_total_product_byid($user_id);
		
		$config['base_url'] = base_url().'product/admin/product/product_lists/'.$user_id.'/';
		$config['total_rows'] = $totalRows->num;
		$config['per_page'] = 10;
		$config['uri_segment'] = 6;
		$config['num_links'] = 5;
		$config['full_tag_open'] = '<ul class="pagination list_style">';
        $config['full_tag_close'] = '</ul><!--pagination-->';
		$config['first_link'] = '&laquo; First';
		$config['first_tag_open'] = '<li class="prev page">';
		$config['first_tag_close'] = '</li>';
		$config['last_link'] = 'Last &raquo;';
		$config['last_tag_open'] = '<li class="next page">';
		$config['last_tag_close'] = '</li>';
		$config['next_link'] = '>';
		$config['next_tag_open'] = '<li class="next page">';
		$config['next_tag_close'] = '</li>';
		$config['prev_link'] = '<';
		$config['prev_tag_open'] = '<li class="prev page">';
		$config['prev_tag_close'] = '</li>';
		$config['cur_tag_open'] = '<li class="active"><a href="">';
		$config['cur_tag_close'] = '</a></li>';
		$config['num_tag_open'] = '<li class="page">';
		$config['num_tag_close'] = '</li>';
		$this->pagination->initialize($config);
		
		if($totalRows->num >= $config['per_page'])	{
			$limit = $config['per_page'];
		}else{
			$limit = $totalRows->num;
		} 
		$offset = ($this->uri->segment($config['uri_segment'])) ? $this->uri->segment($config['uri_segment']) : 0; 
		//print_r($offset);die;
		$this->data['pagination'] = $this->pagination->create_links(); 
        $this->data['lists'] = $this->product_model->get_all_products_byid($user_id, $limit,$offset);
		
		$this->load->view('admin/index',$this->data);
    }
    
	function trash_list($offset=null){
		$data['title'] = "Trash Products";
		$data['offset'] = $offset;
		
		$this->load->library('pagination');
		$totalRows = $this->product_model->count_all_trash_products();
		$config['base_url'] = base_url().'product/admin/product/index/';
		$config['total_rows'] = $totalRows;
		$config['per_page'] = 10;
		$config['uri_segment'] = 5;
		$config['num_links'] = 5;
		$config['full_tag_open'] = '<ul class="pagination list_style">';
		$config['full_tag_close'] = '</ul><!--pagination-->';
		$config['first_link'] = '&laquo; First';
		$config['first_tag_open'] = '<li class="prev page">';
		$config['first_tag_close'] = '</li>';
		$config['last_link'] = 'Last &raquo;';
		$config['last_tag_open'] = '<li class="next page">';
		$config['last_tag_close'] = '</li>';
		$config['next_link'] = '>';
		$config['next_tag_open'] = '<li class="next page">';
		$config['next_tag_close'] = '</li>';
		$config['prev_link'] = '<';
		$config['prev_tag_open'] = '<li class="prev page">';
		$config['prev_tag_close'] = '</li>';
		$config['cur_tag_open'] = '<li class="active"><a href="">';
		$config['cur_tag_close'] = '</a></li>';
		$config['num_tag_open'] = '<li class="page">';
		$config['num_tag_close'] = '</li>';
		$this->pagination->initialize($config);
		
		if($totalRows>=$config['per_page'])	{
			$limit = $config['per_page'];
		}else{
			$limit = $totalRows;
		} 
		$offset = ($this->uri->segment($config['uri_segment'])) ? $this->uri->segment($config['uri_segment']) : 0;  
		
		$data['pagination'] = $this->pagination->create_links(); 
		
		$data['lists'] = $this->product_model->get_all_trash_products($limit, $offset);
		
		$this->load->view('admin/trash_list', $data);
	}
	
	function delete_product($id){
		$this->product_model->delete_product($id);
		redirect('product/admin/product');
	}
	
	function restore_product($id){
		$this->product_model->restore_product($id);
		redirect('product/admin/product/trash_list');
	}
	
	function product_delete_permanent($id){
		$this->product_model->delete_product_img_permanent($id);
		$this->product_model->delete_product_permanent($id);
		redirect('product/admin/product/trash_list');
	}
}