<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Product_model extends CI_Model {
    function __construct() {
		parent::__construct();
	}
	
	function insert($table, $data)
	{
		$id = $this->db->insert($table, $data);
		return $this->db->insert_id();
	}
	
	function update($table, $data, $where)
	{
		$this->db->where($where);
		$id = $this->db->update($table, $data);
		return $this->db->insert_id();
	}
	
	function delete($table, $where)
	{
		$this->db->where($where);
		$this->db->delete($table);
		return true;
	}
	
	function get_product_listing($user_id, $limit, $offset)
	{
		$this->db->select('ps.*, pi.file_name');
		$this->db->from('products ps');
		$this->db->join('product_images pi', 'pi.id=ps.profile_image', 'left');
		$this->db->where('user_id', $user_id);
		$this->db->where('active',1);
		$this->db->limit($limit, $offset);
		$query = $this->db->get();
		return $query->result();
	}
	
	
	function category_listing()
	{
		$query = $this->db->get('categories');
		return $query->result();
	}
	
	function product_category($id)
	{
		$this->db->select('category_id');
		$this->db->where('product_id',$id);
		$query = $this->db->get('category_products');
		return $query->row();
	}
	
	//------------------Ankit
	
	
	function product_detail($product_id,$user_id)
	{
		$this->db->where('id',$product_id);
		$this->db->where('user_id',$user_id);
		$query = $this->db->get('products');
		return $query->row();
	}
	
	function get_total_product($user_id)
	{
		$this->db->select('count(*) as num');
		$this->db->where('user_id',$user_id);
		$this->db->where('active',1);
		$query = $this->db->get('products');
		return $query->row();
	}
	
	function category_update($product_id,$product_data)
	{
		$this->db->where('product_id',$product_id);
		$this->db->update('category_products',$product_data);
	}
	
	function product_images_list($product_id)
	{
		$this->db->select('pds.*,pd.profile_image');
		$this->db->from('products pd');
		$this->db->join('product_images pds', 'pds.id=pd.profile_image', 'right');
		$this->db->where('product_id', $product_id);
		$query = $this->db->get();
		return $query->result();
	}
	//---------------Ankit
}