<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Tagstream_model extends CI_Model {
    function __construct() {
		parent::__construct();
	}
	
	public function get_notifications($user_id, $limit, $offset) {
		$this->db->select('n.*, u.first_name, u.last_name, u.profile_image');
		$this->db->from('notifications n');
		$this->db->join('users u', 'u.id=n.from_user_id');
		$this->db->where('n.to_user_id', $user_id);
		$this->db->order_by('n.created_on', 'desc');
		$this->db->limit($limit, $offset);
		$query = $this->db->get();
		return $query->result();
	}
	
	public function count_notifications($user_id) {
		$this->db->select('n.*');
		$this->db->from('notifications n');
		$this->db->join('users u', 'u.id=n.from_user_id');
		$this->db->where('n.to_user_id', $user_id);
		return $this->db->count_all_results();
	}
	
	public function get_total_tag_streams($userList){
		$this->db->select('ts.id');
		$this->db->from('tag_streams ts');
		$this->db->join('users u', 'u.id=ts.user_id');
		$this->db->where_in('ts.user_id',$userList);
		$this->db->where('ts.action_type',"add");
		
		$this->db->order_by('ts.created_on', 'desc');
		
		return $this->db->count_all_results();
		
	}
}