<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');





class Messages_model extends CI_Model {





    function __construct() {


		parent::__construct();


	}


	


	function check_valid_username($data, $user_id){


		$this->db->select('us.id');


		$this->db->from('users us');


		$this->db->join('friends_list fl', 'fl.user_id=us.id', 'right');


		$this->db->where('us.username', $data);


		$this->db->where('fl.user_id !=', $user_id);


		$query = $this->db->get();


		return $query->row();


	}


	


	function get_inbox_message($user_id, $limit, $offset){


		$this->db->select('me.id as message_id, us.username, me.subject, me.message, me.is_read, me.created_on');


		$this->db->from('message me');


		$this->db->join('users us', 'us.id=me.user_from');


		$this->db->where('user_to', $user_id);


		$this->db->where('me.delete_receiver', 1);


		$this->db->limit($limit, $offset);


		$query = $this->db->get();


		return $query->result();


	}


	


	function get_sent_message($user_id, $limit, $offset){


		$this->db->select('me.id as message_id, us.username, me.subject, me.message, me.is_read, me.created_on');


		$this->db->from('message me');


		$this->db->join('users us', 'us.id=me.user_to');


		$this->db->where('me.user_from', $user_id);


		$this->db->where('me.delete_sender', 1);


		$this->db->limit($limit, $offset);


		$query = $this->db->get();


		return $query->result();


	}


	


	function get_message_details($id){


		$this->db->select('us.*, me.user_from, me.user_to, me.subject, me.message, me.is_read, me.created_on as message_created_on');


		$this->db->from('message me');


		$this->db->join('users us', 'us.id=me.user_to or us.id=me.user_from', 'right');


		$this->db->where('me.id', $id);


		$query = $this->db->get();


		return $query->result();


	}


	


	function insert($table, $data){


		$this->db->insert($table, $data);


		return true;


	}


	


	function update($table, $data, $where){


		$this->db->where($where);


		$this->db->update($table, $data);


		return true;


	}


	


	function get_recent_messages($user_id) {


		$this->db->select('msg.*,us.username');


		$this->db->from('message msg');


		$this->db->join('users us', 'us.id=msg.user_from');


		$this->db->where('msg.user_to', $user_id);


		$this->db->order_by('created_on', 'desc');


		$this->db->limit(5);


		$query = $this->db->get();


		return $query->result();


	}


	


	//------------------- Ankit


	function get_inbox_total_messages($user_id){


		$this->db->select('count(*) as num');


		$this->db->where('user_to',$user_id);


		$this->db->where('delete_sender', 1);


		$query = $this->db->get('message');


		return $query->row();


	}


	


	function get_sent_total_messages($user_id){


		$this->db->select('count(*) as num');


		$this->db->where('user_from', $user_id);


		$this->db->where('delete_receiver', 1);


		$query = $this->db->get('message');


		return $query->row();


	}


	//----------------------End


}