$(function() {
	$("#hideDemo").click(function(e) {
		$(".playVideoInfo").hide('slow');
		$("#hideDemo").hide();
		$("#showDemo").show();
		e.preventDefault();
	});
	$("#showDemo").click(function(e) {
		$(".playVideoInfo").show('slow');
		$("#showDemo").hide();
		$("#hideDemo").show();
		e.preventDefault();
	});
	
	$('#comments').click(function(e){
	
		var video_id = $('#video_id').val();
		var base_url = $('#base_url').val();
		$("#commentBox").show();
	
		$.ajax({
			type: "POST",
			url: base_url + 'videos/comment_view',
			data: 'video_id=' + video_id,
			success: function(response){
				$("#commentList").html(response);
			}
		});
		e.preventDefault();
	});
	
	/*--- Submit comment ---*/
	$('#commentBtn').click(function(e){
	
		var comment = $('#comment').val();
		var video_id = $('#video_id').val();
		var base_url = $('#base_url').val();
		
		if(comment != ''){
			$.ajax({
				type: "POST",
				url: base_url + 'videos/add_comment',
				data: 'video_id=' + video_id + '&comment=' + comment,
				success: function(data){
					console.log(data);
					if(data == 'not_logged_in') {
						alert('Please login your account.');
					} 
					else {
						$("#commentList").append('<div class="media"><div class="media-left"><a href="#"><img class="media-object profile_pic img-circle" src="' + data.profile_image + '" alt=""></a></div><div class="media-body well"><div><i class="fa fa-user"></i>&nbsp;<strong>' + data.username + '</strong></div><div><i class="fa fa-clock-o"></i>&nbsp;' + data.created_on + ' 0 minutes ago </div> <div class="commentxt">' + data.comment + '</div><a href="#" class="replyCommentBtn" id="'+data.id+'" data-video_id='+data.video_id+'>Reply</a><div id="commentBox'+data.id+'"></div></div>')
					
						$('#comment').val('');
					}
				}
			});
		} 
		else {
			alert('Please enter your comment.');
		}
	});
	
	
	/*--- Reply comment ---*/
	
	$(document).on('click', '.replyCommentBtn', function(e){ 
		e.preventDefault();
		
		var base_url = $('#base_url').val();
		var comment_id = $(this).attr('id');
		var video_id = $(this).data('video_id');

		var action = base_url + 'videos/reply_comment';
		
		var commentBox = '<div class="reply-comment" id="reply'+comment_id+'"><div class="row"><div class="col-sm-6"><form action="'+action+'" method="post" class="replyCommentForm"><textarea name="comment" class="form-control"></textarea><input type="hidden" name="comment_id" value="'+comment_id+'" /><input type="hidden" name="video_id" value="'+video_id+'" /><button type="submit" class="btn btn-sm btn-default">Reply</button></form></div></div></div>';
		
		$("#commentBox" + comment_id).html(commentBox);
		
	});
	
	$(document).on('submit', '.replyCommentForm', function(e){
		
		e.preventDefault();
		
		var form = $(this);
		var action = form.attr('action');
		var commentArr = form.serializeArray();
		
		var values = {};
		$.each(commentArr, function(i, field) {
			values[field.name] = field.value;
		});
		
		var comment = values.comment;
	
		if(comment != ''){
			$.ajax({
				type: "POST",
				url: action,
				data: form.serialize(),
				success: function(data){
				
					$("#commentBox" + data.parent_id).hide();
					
					$("#replyCommentList" + data.parent_id).append('<div class="media"><div class="media-left"><a href="#"><img class="media-object profile_pic img-circle" src="' + data.profile_image + '" alt=""></a></div><div class="media-body well"><div><i class="fa fa-user"></i>&nbsp;<strong>' + data.username + '</strong></div><div><i class="fa fa-clock-o"></i>&nbsp;' + data.created_on + ' 0 minutes ago </div><div class="commentxt"><i>' + data.comment + '</i></div></div></div>');
				}
			});
		} 
		else {
			alert('Please enter your comment.');
		}
	});

	
	
	$(document).on('click', '#like_btn', function(e){
		
		var base_url = $('#base_url').val();
		var video_id = $('#video_id').val();
		
		$.ajax({
			type: "POST",
			url: base_url + 'videos/like_video',
			data: 'video_id=' + video_id,
			success: function(response){
				if(response == 'not_logged_in') {
					alert('Please login your account.');
				} 
				else {
					$("#likeDiv").html('<a href="#" id="unlike_btn" class="unlike"><i class="fa fa-thumbs-down"></i>' + response + '</a>');
					//alert(response);
					response=response+' Likes';
					$(".count_like_btn").text(response);
				}
			}
		});
		e.preventDefault();
	});
	
	$(document).on('click', '#unlike_btn', function(e){
		
		var base_url = $('#base_url').val();
		var video_id = $('#video_id').val();
		
		$.ajax({
			type: "POST",
			url: base_url + 'videos/unlike_video',
			data: 'video_id=' + video_id,
			success: function(response){
				if(response == 'not_logged_in') {
					alert('Please login your account.');
				} 
				else {
					$("#likeDiv").html('<a href="#" id="like_btn" class="like"><i class="fa fa-thumbs-up"></i>' + response + '</a>');
					response=response+' Likes';
					$(".count_like_btn").text(response);
				}
			}
		});
		e.preventDefault();
	});
});

/*--- Make favourite video ---*/
$(function() {
	$(document).on('click', '#makeFavourite', function(e){
		
		var base_url = $('#base_url').val();
		var video_id = $('#video_id').val();
		
		$.ajax({
			type: "POST",
			url: base_url + 'videos/create_favourite',
			data: 'video_id=' + video_id,
			success: function(response){
				if(response == 'not_logged_in') {
					alert('Please login your account.');
				} 
				else {
					$("#message").html('<div class="alert custom alert-info" role="alert"><button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>'+response+'</div>');
				}
			}
		});
		e.preventDefault();
	});
});

/*--- Make subscribe video ---*/
$(function() {
	$(document).on('click', '#subscribe', function(e){
		
		var base_url = $('#base_url').val();
		var video_id = $('#video_id').val();
		
		$.ajax({
			type: "POST",
			url: base_url + 'videos/subscribe',
			data: 'video_id=' + video_id,
			success: function(response){
				if(response == 'not_logged_in') {
					alert('Please login your account.');
				} 
				else {
					$("#message").html('<div class="alert custom alert-info" role="alert"><button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>'+response+'</div>');
				}
			}
		});
		e.preventDefault();
	});
});

/*--- Add frame ---*/
$(function() {
	$(document).on('click', '#addFrame', function(e){
		
		var base_url = $('#base_url').val();
		var video_id = $(this).data("video_id")
		
		$.ajax({
			type: "POST",
			url: base_url + 'videos/frame_permission',
			data: 'video_id=' + video_id,
			success: function(response){
				if(response == 'not_logged_in') {
					alert('Please login your account.');
				} 
				else if(response == 'false') {
					alert('Ohh! You do not have permission to add frame on this event!');
				}
				else {
					//window.location.href = base_url + "frame/create/" + video_id;
					window.location.href = base_url + "events/event/" + video_id;
				}
			}
		});
		e.preventDefault();
	});
});