jQuery.validator.addMethod("lettersonly", function(value, element) {
  return this.optional(element) || /^[a-z\s]+$/i.test(value);
}, "Letters only please"); 

$(document).ready(function() {
	var base_url = $("#base_url").val();
	// validate signup form on keyup and submit
	
	$("#signupForm").validate({
		rules: {
			username: {
				required: true,
				remote: {
					url: base_url + 'auth/check_username',
					type: "post",
					data: {
						username: function() {
							return $("#username").val();
						}
					}	
				}
			},
			first_name:
			{
				required:true,
				lettersonly: true
			},
			password: {
				required: true,
				minlength: 5
			},
			password_confirm: {
				required: true,
				minlength: 5,
				equalTo: "#password"
			},
			email: {
				required: true,
				email: true,
				remote: {
					url: base_url + 'auth/check_email',
					type: "post",
					data: {
						email: function() {
							return $("#email").val();
						}
					}	
				}
			},
			phone: {
				required:true,
				number: true
			},
			zipcode: {
				required:true,
				minlength: 5,
				maxlength: 8,
			},
		},
		messages: {
			username:{
				required:"Please enter your username",
				remote:"This username already exists.",
			},
			first_name: {
				required:"Please enter your firstname",
			},
			password: {
				required: "Please provide a password",
				minlength: "Your password must be at least 5 characters long"
			},
			confirm_password: {
				required: "Please provide a password",
				minlength: "Your password must be at least 5 characters long",
				equalTo: "Please enter the same password as above"
			},
			email:
			{
				required:"Please enter a valid email address",
				remote:"Your email already exists.",
			},
			phone:
			{
				required:"Please enter your phone",
				number:  "Please enter numeric value"
			},
			zipcode:
			{
				required:"Please enter your zip code",
			}
		}
	});
});