<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Webservice extends MX_Controller {

	function __construct() {
		parent::__construct();
		$this->load->model('ws_model');
		$this->load->model('videos/videos_model');
		$this->load->library('ion_auth');
	}
	
	public function dateTime($user_id){
		$get_time_zone= $this->ws_model->get_time_zone($user_id);
		if($get_time_zone){
			 $time_zone=$get_time_zone->time_zone;
			date_default_timezone_set($time_zone);
		}
		
		$date= date('Y-m-d H:i:s');
		return $date;
	}
	
	public function setTimeZone($user_id,$time){
		$get_time_zone= $this->ws_model->get_time_zone($user_id);
		if($get_time_zone){
			 $time_zone=$get_time_zone->time_zone;
			date_default_timezone_set($time_zone);
		}
		
		//$datetime= date('F d, Y G:i A', $time);
		$datetime= date('F d, Y g:i A', $time);
		return $datetime;
	}
	
	function currentTime($user_id){
		$currentTime= strtotime($this->dateTime($user_id));
		return $currentTime;
	}
	
	function date_to_time($user_id,$date){
		$get_time_zone= $this->ws_model->get_time_zone($user_id);
		if($get_time_zone){
			 $time_zone=$get_time_zone->time_zone;
			date_default_timezone_set($time_zone);
		}
		
		$date_to_time= strtotime($date);
		return $date_to_time;
		
	}
	
	public function login() {
		
		$username = $this->security->xss_clean($this->input->get_post('username'));
		$password = $this->security->xss_clean($this->input->get_post('password'));
		
		$result = $this->ion_auth->login($username, $password, $remember=FALSE);
		
		if( ! $result) {
			$response = array(
				'status' => 'Invalid username or password.'
			);
		} 
		else {
			$user_id = $this->ion_auth_model->get_user_id('username', $username);
			
			$user = $this->ion_auth->user($user_id)->row();
			
			$profile_image = "";
			if($user->profile_image) {
				$profile_image = base_url().$user->profile_image;
			}
			
			
			$device_id = $this->security->xss_clean($this->input->get_post('device_id'));
			$reg_token = $this->security->xss_clean($this->input->get_post('reg_token'));
			$time_zone = $this->security->xss_clean($this->input->get_post('time_zone'));
			if($time_zone){
				date_default_timezone_set($time_zone);
			}
			
			
			$date_of_birth = '';
			if($user->date_of_birth !== '0000-00-00') {
				$date_of_birth = date('Y-m-d', strtotime($user->date_of_birth));
			}
			
		
			$events = $this->ws_model->count_user_events($user_id);
			$frames = $this->ws_model->count_user_frames($user_id);
			$number_of_following = $this->ws_model->count_following($user_id);
			$number_of_followers = $this->ws_model->count_followers($user_id);
			$unread_notifications = $this->common_model->count_unread_notification($user_id);
			
			$userdata = array(
				'user_id' => $user->id,
				'username' => $user->username,
				'email' => $user->email,
				'first_name' => $user->first_name,
				'last_name' => $user->last_name,
				'address' => $user->address,
				'city' => $user->city,
				'state' => $user->state,
				'country' => $user->country,
				'date_of_birth' => $date_of_birth,
				'phone' => $user->phone,
				'profile_image' => $profile_image,
				'number_of_event' => $events,
				'description' => $user->description,
				'number_of_frame' => COUNT($frames),
				'number_of_following' => $number_of_following,
				'number_of_followers' => $number_of_followers,
				'unread_notifications' => $unread_notifications
			);
			
		   
			
			$deviceSession= array(
			'user_id'=>$user_id,
			'device_id'=>$device_id,
			'reg_token'=>$reg_token,
			'created_on'=>date('Y-m-d H:i:s')
			);
			
			$timeZoneData= array(
			'user_id'=>$user_id,
			'time_zone'=>$time_zone,
			'created_on'=>date('Y-m-d H:i:s')
			);
			
			$device_exists= $this->common_model->check_device_session($user_id,$device_id);
			if($device_exists){
				$this->common_model->update_device_session($user_id,$device_id,$deviceSession);
			}
			else{
				$this->common_model->insert_device_session($deviceSession);
			}
			
			/*time Zone set*/
			$userTimeZoneExists= $this->common_model->check_timeZone($user_id);
			if($userTimeZoneExists){
				if($time_zone){
					$this->common_model->update_timeZone($user_id,$timeZoneData);
				}
				
			}
			else{
				$this->common_model->insert_timeZone($timeZoneData);
			}
			/* time zone end */
			
			$response = array(
				'status' => 'success',
				'userinfo' => $userdata
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function logout(){
        $user_id = $this->security->xss_clean($this->input->get_post('user_id'));
		$device_id = $this->security->xss_clean($this->input->get_post('device_id'));
		
		if(!$user_id OR !$device_id){
			$response = array(
			'status' => 'error'	
			);
		}
        else{
			
			$this->common_model->remove_device_session($user_id,$device_id);
			
			$response = array(
			'status' => 'success'	
			);
	    }
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
		
	}
	
	public function signup() {
		
		$username = $this->input->get_post('username');
		$password = $this->input->get_post('password');
		$email = strtolower($this->input->get_post('email'));
	
		$first_name = $this->input->get_post('first_name');
		$zipcode = $this->input->get_post('zipcode');
		$phone = $this->input->get_post('phone');
		
		if(!$username && !$password && !$email) {
			$response = array(
				'status' => 'error'
			);
		}
		else if($this->ion_auth_model->email_check($email)) { 
			$response = array(
				'status' => $email.' email id already registered.'
			);
		} 
		else if($this->ion_auth_model->username_check($username)) {
			$response = array(
				'status' => $username.' username id already registered.'
			);
		}
		else {
		
			$additional_data = array(
				'first_name' => $first_name,
				'zipcode' => $zipcode,
				'phone' => $phone
			);
		
			$user_id = $this->ion_auth->register($username, $password, $email, $additional_data);
			
			//Signup on magento
			$this->load->library('bwt_magento');
			$fields = array(
				'username' => $username,
				'email' => $email,
				'password' => $password,
				'first_name' => $first_name,
                'last_name'  => NULL
			);
			$this->bwt_magento->signup($fields);
			
			$user = $this->ion_auth->user($user_id)->row();
			
			$date_of_birth = '';
			
			$device_id = $this->security->xss_clean($this->input->get_post('device_id'));
			$reg_token = $this->security->xss_clean($this->input->get_post('reg_token'));
			$time_zone = $this->security->xss_clean($this->input->get_post('time_zone'));
			if($time_zone){
				date_default_timezone_set($time_zone);
			}
			
			if($user->date_of_birth !== 0) {
				$date_of_birth = date('Y-m-d', strtotime($user->date_of_birth));
			}
			
			$events = $this->ws_model->count_user_events($user_id);
			$frames = $this->ws_model->count_user_frames($user_id);
			$number_of_following = $this->ws_model->count_following($user_id);
			$number_of_followers = $this->ws_model->count_followers($user_id);
			$unread_notifications = $this->common_model->count_unread_notification($user_id);
			
			$userdata = array(
				'user_id' => $user->id,
				'username' => $user->username,
				'email' => $user->email,
				'first_name' => $user->first_name,
				'last_name' => $user->last_name,
				'address' => $user->address,
				'city' => $user->city,
				'state' => $user->state,
				'country' => $user->country,
				'date_of_birth' => $date_of_birth,
				'phone' => $user->phone,
				'profile_image' => $profile_image,
				'number_of_event' => $events,
				'description' => $user->description,
				'number_of_frame' => COUNT($frames),
				'number_of_following' => $number_of_following,
				'number_of_followers' => $number_of_followers,
				'unread_notifications' => $unread_notifications
			);
			
			
			$deviceSession= array(
			'user_id'=>$user_id,
			'device_id'=>$device_id,
			'reg_token'=>$reg_token,
			'created_on'=>date('Y-m-d H:i:s')
			);
			
			$timeZoneData= array(
			'user_id'=>$user_id,
			'time_zone'=>$time_zone,
			'created_on'=>date('Y-m-d H:i:s')
			);
			
			$device_exists= $this->common_model->check_device_session($user_id,$device_id);
			if($device_exists){
				$this->common_model->update_device_session($user_id,$device_id,$deviceSession);
			}
			else{
				$this->common_model->insert_device_session($deviceSession);
			}
			
			/*time Zone set*/
			$userTimeZoneExists= $this->common_model->check_timeZone($user_id);
			if($userTimeZoneExists){
				if($time_zone){
					$this->common_model->update_timeZone($user_id,$timeZoneData);
				}
			}
			else{
				$this->common_model->insert_timeZone($timeZoneData);
			}
			/* time zone end */
			
			$response = array(
				'status' => 'success',
				'userinfo' => $userdata
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function countries() {
		
		$countries = $this->ws_model->get_countries();
		
		if(empty($countries)) {
			$response = array(
				'status' => 'no records'
			);
		} 
		else {
			$response = array(
				'status' => 'success',
				'countries' => $countries
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function forgot_password() {
		$email = $this->input->get_post('email');
		
		if(!$email) {
			$response = array(
				'status' => 'error'
			);
		}
		else if($this->ion_auth_model->email_check($email)) { 
			$response = array(
				'status' => $email.' not exist user records.'
			);
		}
		else { 
			$identity = $this->ion_auth->where('email', strtolower($email))->users()->row();
			 //run the forgotten password method to email an activation code to the user
            $forgotten = $this->ion_auth->forgotten_password($identity->{$this->config->item('identity', 'ion_auth')});
			
			if ($forgotten)
            { 
				$response = array(
					'status' => 'success'
				);
			} 
			else {
				$response = array(
					'status' => 'error'
				);
			}
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	function changepassword()
    {
		$user_id = $this->input->get_post('user_id');
		$old_password = $this->input->get_post('old_password');
		$new_password = $this->input->get_post('new_password');
	
		if( ! $user_id) {
			$response = array(
				'status' => 'error'
			);
		}
		else {
			$user = $this->ion_auth->user($user_id)->row();
			
			if(empty($user)) { 
				$response = array(
					'status' => 'user does not exist'
				);
			}
			else { 
				$identity = $user->username;
				
				$change = $this->ion_auth->change_password($identity, $old_password, $new_password);

				if ($change){
					$response = array(
						'status' => 'success'
					);
				}
				else {
					$response = array(
						'status' => 'old password does not match.'
					);
				}
			}
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
    }
	
	public function upload_profile_photo() {
		$user_id = $this->input->get_post('user_id');
		if( ! $user_id) {
			$response = array(
				'status' => 'error'
			);
		} 
		else { 
			$upload_path = 'media/user_image/';
			$config['upload_path'] = $upload_path;
			$config['allowed_types'] = 'gif|jpg|jpeg|png';
			$config['max_size'] = '5120';
			$config['encrypt_name'] = TRUE;
			
			$this->load->library('upload', $config);
			
			if( ! $this->upload->do_upload('profile_photo')) {
				$response = array(
					'status' => $this->upload->display_errors()
				);
			} 
			else {
				
				$description = $this->input->get_post('description');
				
				$user = $this->ion_auth->user($user_id)->row();
				if($user->profile_image && file_exists($user->profile_image)) {
					unlink($user->profile_image);
				}
				
				$imagedata = $this->upload->data();
				$profile_photo = $upload_path.$imagedata['file_name'];
				
				$userdata = array(
					'profile_image' => $profile_photo,
					'description' => $description,
				);
				
				$this->ion_auth->update($user_id, $userdata);
				$image_path= base_url().$profile_photo;
				$response = array(
					'status' => 'success',
					'profile_photo'=>$image_path
				);
			}
		}
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function user_events() {
	
		$user_id = $this->input->get_post('user_id', true);
		$next_records = $this->input->get_post('next_records', true);
		
		if( ! $user_id) {
			$response = array(
				'status' => 'error'
			);
		} 
		else {
			
			if( ! $next_records) {
				$next_records = 0;
			}
			$limit = 10;
			$offset = $next_records;
			 
			$events = $this->ws_model->get_user_events($user_id, $limit, $offset); 
		
			$number_of_event = $this->ws_model->count_user_events($user_id);
			 
			$eventlist = array();
			
			if( ! empty($events)) {
			
				$kaltura_user = $this->ion_auth->get_username($user_id);
				$user = $this->ion_auth->user($user_id)->row();
			
				$profile_image = "";
				if($user->profile_image) {
					$profile_image = base_url().$user->profile_image;
				}
				foreach($events as $event) {
				
					$kaltura_video_id = $event->kaltura_video_id;
					$video = $this->kaltura->videolist($access_type='USER', $kaltura_user, $page='', $kaltura_video_id, $categoriesId = TRUE);
					
					$duration = $video['result']->objects[0]->duration;
					$views = $video['result']->objects[0]->views;
					
					$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
					$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
					$dataUrl=$this->videoDataUrl($kaltura_video_id);
					
					
					$video_id = $event->id;
					$countLike = $this->ws_model->count_like($video_id);
					
					$kaltura_video_id = $event->kaltura_video_id;
					$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);
					
					$liked = $this->ws_model->is_liked($user_id, $video_id);
					if($liked){
						$is_liked = 'Yes';
					} else {
						$is_liked = 'No';
					}
					
					// Event frames
					
					$video_frames = $this->ws_model->get_video_frames($video_id);
					$frames = array();
					
					if( ! empty($video_frames)) {

						foreach($video_frames as $frame) {
					
							$frameDataUrl = "";
							if($frame->media_type == 'VIDEO'){
								$frm_kaltura_video_id = $frame->kaltura_video_id;
								$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
								
								$frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
							}
					
							$magento_product = $this->bwt_magento->get_product($frame->product_id);
						    if($frame->media_type=="VIDEO"){
								$frame_media_type=111;
							}
							else if($frame->media_type=="IMAGE"){
								$frame_media_type=110;
							}
							$frames[] = array(
								'frame_id' => $frame->id,
								'user_id' => $frame->user_id,
								'product_id' => $frame->product_id,
								'product_image' => $magento_product->getImageUrl(),
								'frame_title' => $frame->title,
								'frame_start_time' => $frame->start_time,
								'frame_end_time' => $frame->end_time,
								'frame_media_type' => $frame_media_type,
								'frame_kmedia_id' => $frame->frame_kaltura_media_id,
								'frame_thumbnail_url' => $frame->thumbnail_url,
								'frame_image_url' => $frame->image_url,
								'frame_data_url' => $frameDataUrl,
								'frame_product_url' => $magento_product->getProductUrl(),
								'frame_resource_type' =>"internet",
								
								
							);
						}
					}
					
					//$this->load->helper('datetime');
					if($event->event_type=="VIDEO"){
								$event_media_type=111;
							}
					else if($event->event_type=="IMAGE"){
								$event_media_type=110;
					}
					/* Tagged users on a events*/
					$tagged_user_id=array();
					$taggedUserData = $this->ws_model->get_tagged_users_on_event($video_id);
					$num_of_comments= $this->videos_model->num_of_comments_video($video_id);
					
					$profile_pic="";
					if(!empty($taggedUserData)){
						
						foreach($taggedUserData as $taggedUser){
						if(!empty($taggedUser->profile_image)){
							$profile_pic=base_url().$taggedUser->profile_image;
						}
						$tagged_user_id[]=array(
						'name'=>$taggedUser->first_name,
						'user_id'=>$taggedUser->tagged_user_id,
						'profile_pic'=>$profile_pic,
						
						);
					    }
						
					}
					
					//unset($tagged_user_id);
					$eventlist[] = array(
						'event_id' => $event->id,
						'kuser_id' => $event->kaltura_user_id,
						'kvideo_id' => $event->kaltura_video_id,
						'type' => $event->type,
						'event_type' => $event_media_type,
						'title' => $event->title,
						'description' => $event->description,
						'tags' => $event->tag_keyword,
						'is_paid' => $event->is_paid,
						'price' => $event->price,
						'duration' => $duration,
						'views' => $views,
						'thumbnail' =>($event->event_type == 'VIDEO')?$thumbnailUrl:$event->thumbnail_url,
						'data_url' => $dataUrl,
						'number_of_event' => $number_of_event,
						'created_at' => $this->humanTiming($user_id,$event->created_on)." ago",
						'count_like' => $countLike,
						'website_video_url' => $websiteVideoUrl,
						'is_liked' => $is_liked,
						'name'=>$user->first_name,
						'profile_picture'=>$profile_image,
						'user_id'=>$user_id,
						'frames' => $frames,
						'tagged_user_id'=>$tagged_user_id,
						'num_of_comments'=>$num_of_comments
					);
				}
				
				$response = array(
					'status' => 'success',
					'records' => $eventlist
				);
			}
			else{
				$response = array(
					'status' => 'success',
					'records' => $eventlist
				);
			}
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function user_frames() {
	
		$user_id = $this->input->get_post('user_id', true);
		$next_records = $this->input->get_post('next_records', true);
		
		if(!$user_id){
			$response= array(
				'status' => 'error'
			);
		} 
		else {
			
			if(!$next_records) {
				$next_records = 0;
			}
			$limit = 10;
			$offset = $next_records;
			 
			$frames = $this->ws_model->get_user_frames($user_id, $limit, $offset);
			
			$countframes = $this->ws_model->count_user_frames($user_id);
			$number_of_frames = COUNT($countframes);
			
			$framelist = array();
			 
			if( ! empty($frames)) {
			
				$kaltura_user = $this->ion_auth->get_username($user_id);
				
				foreach($frames as $frame) {
					 
					$kaltura_video_id = $frame->kaltura_video_id;
					$video = $this->kaltura->videolist($access_type='USER', $kaltura_user, $page='', $kaltura_video_id, $categoriesId = TRUE);
					$duration = $video['result']->objects[0]->duration;
					$views = $video['result']->objects[0]->views;
					
					$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
					$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
					$dataUrl=$this->videoDataUrl($kaltura_video_id);
					
					// Event frames
					$video_id = $frame->video_id;
					$video_frames = $this->ws_model->get_video_frames($video_id);
					$frames = array();
					
					if( ! empty($video_frames)) {

						foreach($video_frames as $vframe) {
							
							$frameDataUrl = "";
							if($vframe->media_type == 'VIDEO'){
								$frm_kaltura_video_id = $vframe->kaltura_video_id;
								$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
								$frameDataUrl = $frmvideo['result']->objects[0]->dataUrl;
								
							    $frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
							}
					        if($vframe->media_type=="VIDEO"){
								$frame_media_type=111;
							}
							else if($vframe->media_type=="IMAGE"){
								$frame_media_type=110;
							}
							$magento_product = $this->bwt_magento->get_product($vframe->product_id);
						
							$frames[] = array(
								'frame_id' => $vframe->id,
								'user_id' => $vframe->user_id,
								'product_id' => $vframe->product_id,
		                        'product_image' => $magento_product->getImageUrl(),
								'frame_title' => $vframe->title,
								'frame_start_time' => $vframe->start_time,
								'frame_end_time' => $vframe->end_time,
								'frame_media_type' => $frame_media_type,
								'frame_kmedia_id' => $vframe->frame_kaltura_media_id,
								'frame_thumbnail_url' => $vframe->thumbnail_url,
								'frame_image_url' => $vframe->image_url,
								'frame_data_url' => $frameDataUrl,
								'frame_product_url' => $magento_product->getProductUrl(),
		                        'frame_resource_type' =>"internet",
							);
						}
					}
			        if($frame->media_type=="VIDEO"){
								$frame_media_type=111;
					}
					else if($frame->media_type=="IMAGE"){
								$frame_media_type=110;
					}
					/* Tagged users on a events*/
					
					$tagged_user_id=array();
					$taggedUserData = $this->ws_model->get_tagged_users_on_event($frame->video_id);
					$num_of_comments= $this->videos_model->num_of_comments_video($frame->video_id);
					$countLike = $this->ws_model->count_like($video_id);
					
					$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);
					
					$liked = $this->ws_model->is_liked($user_id, $video_id);
					if($liked){
						$is_liked = 'Yes';
					} else {
						$is_liked = 'No';
					}
					
					$profile_pic="";
					if(!empty($taggedUserData)){
						
						foreach($taggedUserData as $taggedUser){
						if(!empty($taggedUser->profile_image)){
							$profile_pic=base_url().$taggedUser->profile_image;
						}
						$tagged_user_id[]=array(
						'name'=>$taggedUser->first_name,
						'user_id'=>$taggedUser->tagged_user_id,
						'profile_pic'=>$profile_pic,
						
						);
						}
						
					}
			       
					//$this->load->helper('datetime');
					$event_user_id=$this->ws_model->get_event_userId($video_id);
					$magentoProduct = $this->bwt_magento->get_product($frame->product_id);
					$framelist[] = array(
						'frame_id' => $frame->id,
						'event_user_id'=>$event_user_id,
						'video_id' => $frame->video_id,
						'title' => $frame->title,
						'kaltura_video_id' => $frame->kaltura_video_id,
						'product_id' => $frame->product_id,
						'product_url'=>$magentoProduct->getProductUrl(),
						'product_image_url'=>$magentoProduct->getImageUrl(),
						'media_type' => $frame_media_type, 
						'frame_kaltura_media_id' => $frame->frame_kaltura_media_id, 
						'name' => $frame->first_name, 
						'thumbnail_url' => $frame->thumbnail_url,
						'image_url' => $frame->image_url,
						'data_url' => $dataUrl,
						'number_of_frames' => $number_of_frames,
						'event_title' => $frame->event_title,
						'event_description' => $frame->event_description,
						'created_on' => $this->humanTiming($frame->user_id,$frame->created_on),
						'frames' => $frames,
						'tagged_user_id' => $tagged_user_id,
						'num_of_comments'=>$num_of_comments,
						'count_like' => $countLike,
						'user_id' => $frame->user_id,
						'website_video_url' => $websiteVideoUrl,
						'is_liked' => $is_liked,
					);
					
					unset($frames);
				}
				
				$response = array(
					'status' => 'success',
					'framedata' => $framelist
				);
			}
			else{
				$response = array(
					'status' => 'success',
					'framedata' => $framelist
				);
			}
			 
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	
	public function favourites() {
	
		$user_id = $this->input->get_post('user_id', true);
		
		if( ! $user_id) {
			$response['favourites'] = array(
				'status' => 'error'
			);
		} 
		else {
			
			$favourites = $this->ws_model->get_user_favourites($user_id);
			
			$eventlist = array();
			
			if( ! empty($favourites)) {
			
				foreach($favourites as $event) {
				
					$kaltura_video_id = $event->kaltura_video_id;
					$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);
					
					$duration = $video['result']->objects[0]->duration;
					$views = $video['result']->objects[0]->views;
					
					$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
					$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
					$dataUrl=$this->videoDataUrl($kaltura_video_id);
					
					$posted_by = $event->first_name.' '.$event->last_name;
					
					$eventlist[] = array(
						'event_id' => $event->id,
						'kuser_id' => $event->kaltura_user_id,
						'kvideo_id' => $event->kaltura_video_id,
						'type' => $event->type,
						'title' => $event->title,
						'description' => $event->description,
						'tags' => $event->tag_keyword,
						'is_paid' => $event->is_paid,
						'price' => $event->price,
						'duration' => $duration,
						'views' => $views,
						'thumbnail' => $thumbnailUrl,
						'data_url' => $dataUrl,
						'posted_by' => $posted_by
					);
				}
				
				$response['favourites'] = array(
					'status' => 'success',
					'favouritedata' => $eventlist
				);
			}
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function subscribes() {
	
		$user_id = $this->input->get_post('user_id', true);
		
		if( ! $user_id) {
			$response['subscribes'] = array(
				'status' => 'error'
			);
		} 
		else {
			
			$subscribes = $this->ws_model->get_user_subscribed_event($user_id);
			
			$eventlist = array();
			
			if( ! empty($subscribes)) {
				foreach($subscribes as $event) {
				
					$kaltura_video_id = $event->kaltura_video_id;
					$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);
					
					$duration = $video['result']->objects[0]->duration;
					$views = $video['result']->objects[0]->views;
					
					$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
					$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
					$dataUrl=$this->videoDataUrl($kaltura_video_id);
					
					$posted_by = $event->first_name.' '.$event->last_name;
					
					$eventlist[] = array(
						'event_id' => $event->id,
						'kuser_id' => $event->kaltura_user_id,
						'kvideo_id' => $event->kaltura_video_id,
						'type' => $event->type,
						'title' => $event->title,
						'description' => $event->description,
						'tags' => $event->tag_keyword,
						'is_paid' => $event->is_paid,
						'price' => $event->price,
						'duration' => $duration,
						'views' => $views,
						'thumbnail' => $thumbnailUrl,
						'data_url' => $dataUrl,
						'posted_by' => $posted_by
					);
				}
				
				$response['subscribes'] = array(
					'status' => 'success',
					'subscribedata' => $eventlist
				);
			}
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function user_products() {
		
		$user_id = $this->input->get_post('user_id', true);
	
		if( ! $user_id ) { 
			$response['products'] = array(
				'status' => 'error'
			);
		} 
		else {
			$user = $this->ion_auth->user($user_id)->row();
			$email = $user->email;
			
			$productlist = array();
			
			$collection = $this->bwt_magento->get_seller_products($email);
	
			foreach($collection as $products){
			
				$productlist[] = array(
					'product_id' => $products->getEntityId(),
					'product_name' => $products->getName(),
					'product_image' => $products->getImageUrl(),
					'product_url' => $products->getProductUrl(),
				);
			}
			
			$response['products'] = array(
				'status' => 'success',
				'product_data' => $productlist
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function event() {
	
		$event_id = $this->input->get_post('event_id');
		
		if( ! $event_id ) { 
			$response['event'] = array(
				'status' => 'error'	
			);
		} 
		else {
			
			$this->load->model('videos/videos_model');
			
			$event = $this->videos_model->get_video('id', $event_id, $kaltura_user_id='', $active=1);
			
			$kaltura_video_id = $event->kaltura_video_id;
			$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);
			
			$duration = $video['result']->objects[0]->duration;
			$views = $video['result']->objects[0]->views;
			
			$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
			$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
			$dataUrl=$this->videoDataUrl($kaltura_video_id);
			
			$posted_by = $event->first_name.' '.$event->last_name;
			
			$video_frames = $this->videos_model->get_video_frames($event_id);
			$frames = array();
			if( ! empty($video_frames)) {

				foreach($video_frames as $frame) {
			
					$magento_product = $this->bwt_magento->get_product($frame->product_id);
				
					$frames[] = array(
						'frame_id' => $frame->id,
						'frame_start_time' => $frame->start_time,
						'frame_end_time' => $frame->end_time,
						'frame_media_type' => $frame->media_type,
						'frame_kmedia_id' => $frame->frame_kaltura_media_id,
						'frame_thumbnail_url' => $frame->thumbnail_url,
						'frame_product_url' => $magento_product->getProductUrl(),
					);
				}
			}
			
			$media = array(
				'event_id' => $event->id,
				'kuser_id' => $event->kaltura_user_id,
				'kvideo_id' => $event->kaltura_video_id,
				'type' => $event->type,
				'title' => $event->title,
				'description' => $event->description,
				'tags' => $event->tag_keyword,
				'is_paid' => $event->is_paid,
				'price' => $event->price,
				'duration' => $duration,
				'views' => $views,
				'thumbnail' => $thumbnailUrl,
				'data_url' => $dataUrl,
				'posted_by' => $posted_by,
				'frames' => $frames
			);
			
			$response['event'] = array(
				'status' => 'success',
				'media' => $media
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	function upload_video(){
	
		$this->load->model('videos/videos_model');
		
		$user_id = $this->input->get_post('user_id');
		
		$access_type = $this->input->get_post('access_type');
		$title = $this->input->get_post('title');
		$description = $this->input->get_post('description');
		$tags_keywords = $this->input->get_post('tags_keywords');
		$price = $this->input->get_post('price');
		$is_paid = $this->input->get_post('is_paid');
		$duration = $this->input->get_post('duration');
		
		$event_type = $this->input->get_post('event_type');
		
		$tagged_user_json = $this->input->get_post('tagged_user_id', true);
		if($tagged_user_json){
			 $taggedUser= json_decode($tagged_user_json);
		}
		
		if ( ! $user_id) {
			$response = array(
				'status' => 'error',
			);
		} 
		else {
		
			if($event_type == 'VIDEO'){
				
				$this->load->library('upload');
				
				$uploadPath = 'media/temp/';
				$config['upload_path'] = $uploadPath;
				$config['max_size']	= "2048000000000";
				$config['allowed_types'] = 'mp4|mov|mkv';
				$config['encrypt_name'] = TRUE;
				$this->upload->initialize($config);
				
				if( ! $this->upload->do_upload('media_file')) {
					$response = array(
						'status' => $this->upload->display_errors()
					);
				} 
				else {
					$upload_data = $this->upload->data();
					$videofile = $upload_data['file_name'];
					
					$kaltura_user = $this->ion_auth->get_username($user_id);
					$video_file_path = $uploadPath.$videofile;
					
					// Kaltura data
					$media = array(
						'user' => $kaltura_user,
						'access_type' => 'USER',
						'media_type' => 'VIDEO',
						'title' => $title,
						'description' => $description,
						'tags' => $tags_keywords,
						'media_path' => $video_file_path
					);
					
					$kvideo = $this->kaltura->uploadfile($media);
					
					$video_data =array(
						'user_id' => $user_id,
						'kaltura_user_id' => $kvideo->userId,
						'kaltura_video_id' => $kvideo->id,
						'type' => $access_type,
						'title' => $title,
						'event_type' => 'VIDEO',
						'description' => $description,
						'tag_keyword' => $tags_keywords,
						'video_duration' => $duration,
						'price' => $price,
						'is_paid' => $is_paid,
						'created_on' =>  $this->currentTime($user_id)
					);
					
					$video_id = $this->videos_model->insert('videos', $video_data);
					
					// Tag Streams
					$streams_data = array(
						'user_id' => $user_id,
						'stream_type' => 'event',
						'event_id' => $video_id,
						'action_type' => 'add',
						'created_on' => $this->currentTime($user_id) 
					);
					$this->common_model->insert_tag_stream($streams_data);
					
					// Tagged User
					
					if($taggedUser) 
					{
						foreach ($taggedUser->tag_array as $tag_user) {
							$taggedUserData = array(
								'user_id' => $user_id,
								'tagged_user_id' => $tag_user,
								'video_id' => $video_id,
								'type' => 'Event',
								'created_at' => $this->dateTime($user_id)
							);			
							$this->ws_model->insert_tagged_user($taggedUserData);
							
							$from_user_id=$user_id;
							$to_user_id=$tag_user;
							$action_type =10;
							$event_id =$video_id;
							
                            if($from_user_id !=$to_user_id){
								$this->notification($from_user_id,$to_user_id,$action_type,$event_id);
							}						
																					
						}						
					}
					
					unlink($video_file_path);
					$response = array(
						'status' => 'success',
						'event_id' => $video_id
					);
				}
			}

			if($event_type == 'IMAGE'){
				
				$this->load->library('upload');
				
				$uploadPath = 'media/temp/';
				$config['upload_path'] = $uploadPath;
				$config['allowed_types'] = 'gif|jpg|jpeg|png';
				$config['encrypt_name'] = TRUE;
				$this->upload->initialize($config);
				
				if( ! $this->upload->do_upload('media_file')) {
					$response = array(
						'status' => $this->upload->display_errors()
					);
				} 
				else {
					$upload_data = $this->upload->data();
					$imgfile = $upload_data['file_name'];
					
					$kaltura_user = $this->ion_auth->get_username($user_id);
					$imgfile_path = $uploadPath.$imgfile;
					
					// Kaltura data
					$media = array(
						'user' => $kaltura_user,
						'access_type' => 'USER',
						'media_type' => 'IMAGE',
						'title' => $title,
						'description' => $description,
						'tags' => $tags_keywords,
						'media_path' => $imgfile_path
					);
					
					$kvideo = $this->kaltura->uploadfile($media);
					
					$image_data =array(
						'user_id' => $user_id,
						'kaltura_user_id' => $kvideo->userId,  
						'kaltura_video_id' => $kvideo->id, 
						'type' => $access_type,
						'title' => $title,
						'event_type' => 'IMAGE',
						'thumbnail_url' => $kvideo->dataUrl,
						'description' => $description,
						'tag_keyword' => $tags_keywords, 
						'price' => $price,
						'is_paid' => $is_paid,
						'created_on' =>  $this->currentTime($user_id)
					);
					
					$video_id = $this->videos_model->insert('videos', $image_data);
					
					// Tag Streams
					$streams_data = array(
						'user_id' => $user_id,
						'stream_type' => 'event',
						'event_id' => $video_id,
						'action_type' => 'add',
						'created_on' => $this->currentTime($user_id) 
					);
					$this->common_model->insert_tag_stream($streams_data);
					
					if($taggedUser) 
					{
						foreach ($taggedUser->tag_array as $tag_user) {
							$taggedUserData = array(
								'user_id' => $user_id,
								'tagged_user_id' => $tag_user,
								'video_id' => $video_id,
								'type' => 'Event',
								'created_at' => $this->dateTime($user_id)
							);			
							$this->ws_model->insert_tagged_user($taggedUserData);
							
							$from_user_id=$user_id;
							$to_user_id=$tag_user;
							$action_type =10;
							$event_id =$video_id;
							
							if($from_user_id !=$to_user_id){
								$this->notification($from_user_id,$to_user_id,$action_type,$event_id);	
							}														
						}						
					}
					
					unlink($imgfile_path);
					
					$response = array(
						'status' => 'success',
						'event_id' => $video_id
					);
					
				}
			}	
			
		} 
		
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response)); 
		
		
	}
	
	public function create_frame()
	{
		$user_id = $this->input->get_post('user_id', true);
		$video_id = $this->input->get_post('video_id', true);
		$title = $this->input->get_post('title', true);
		$media_type = $this->input->get_post('media_type', true);
		$is_product_frame = $this->input->get_post('is_product_frame', true);
		$product_id = $this->input->get_post('product_id', true);
		$start_time = $this->input->get_post('start_time', true);
		$end_time = $this->input->get_post('end_time', true);
		
		if( ! $video_id) {
			$response = array(
				'status' => 'error',
			);
		}
		else {
		
			$framestatus = $this->frameslot($video_id, $start_time, $end_time);
			
			if( ! $framestatus)
			{ 
				$response = array(
					'status' => 'no space available'
				);
			} 
			else{
			    if($is_product_frame=="yes"){
					
						$this->load->model('frame/frame_model');
						$this->load->model('videos/videos_model');
						$media_file = $this->input->get_post('media_file', true);
						$kaltura_user = $this->ion_auth->get_username($user_id);
						
						// Kaltura data
						/* $media = array(
							'user' => $kaltura_user,
							'access_type' => 'USER',
							'media_type' => $media_type,
							'title' => "Advertisement",
							'description' => NULL,
							'tags' => NULL,
							'media_path' => $media_file
						);
						$kmedia = $this->kaltura->uploadfile($media, $frame = TRUE);
				        */
						//Magento product
						$this->load->library('bwt_magento');
						$magento_product = $this->bwt_magento->get_product($product_id);
						
						$frame_data = array(
							'user_id' => $user_id,
							'video_id' => $video_id,
							'product_id' => $this->input->get_post('product_id'),
							'title' => $title,
							'start_time' => $start_time,
							'end_time' => $end_time,
							'media_type' => $media_type,
							'thumbnail_url' => $magento_product->getImageUrl(),
							'image_url' => $media_file,
							'product_url' => $magento_product->getProductUrl(),
							'created_on' => $this->currentTime($user_id)
						);
						
						$frame_id = $this->frame_model->insert('ads_frame', $frame_data);
						$video = $this->videos_model->get_video('id', $video_id, $kaltura_user_id=NULL);

						// Tag Streams
						$streams_data = array(
							'user_id' => $user_id,
							'stream_type' => 'event',
							'event_id' => $frame_id,
							'action_type' => 'frame',
							'created_on' =>$this->currentTime($user_id) 
						);
						$id=$this->common_model->insert_tag_stream($streams_data);
						
						// Tagged User
						/* if($tagged_user_id) 
						{
							$taggedUserData = array(
								'user_id' => $user_id,
								'tagged_user_id' => $tagged_user_id,
								'frame_id' => $frame_id,
								'video_id' => $video_id,
								'type' => 'Frame',
								'created_at' => date('Y-m-d H:i:s', time())
							);
							
							$id= $this->ws_model->insert_tagged_user($taggedUserData);
						} */
						
						$response = array(
							'status' => 'success'
					    );
				}
				else{
					
					$this->load->model('frame/frame_model');
					$this->load->model('videos/videos_model');
					
					$this->load->library('upload');
				
					$uploadPath = 'media/temp/';
					$config['upload_path'] = $uploadPath;
					if($media_type == 'IMAGE') {
						$config['allowed_types'] = 'gif|jpg|jpeg|png';
					}
					else {
						$config['allowed_types'] = 'mp4';
					}
					$config['encrypt_name'] = TRUE;
					$this->upload->initialize($config);
					
					if( ! $this->upload->do_upload('media_file')) {
						$response = array(
							'status' => $this->upload->display_errors()
						);
					} 
					else {
					
						$upload_data = $this->upload->data();
						$mediafile = $upload_data['file_name'];
						
						$kaltura_user = $this->ion_auth->get_username($user_id);
						$media_file_path = $uploadPath.$mediafile;
						
						// Kaltura data
						$media = array(
							'user' => $kaltura_user,
							'access_type' => 'USER',
							'media_type' => $media_type,
							'title' => "Advertisement",
							'description' => NULL,
							'tags' => NULL,
							'media_path' => $media_file_path
						);
						$kmedia = $this->kaltura->uploadfile($media, $frame = TRUE);
				
						//Magento product
						$this->load->library('bwt_magento');
						$magento_product = $this->bwt_magento->get_product($product_id);
						
						$frame_data = array(
							'user_id' => $user_id,
							'video_id' => $video_id,
							'product_id' => $this->input->get_post('product_id'),
							'title' => $title,
							'start_time' => $start_time,
							'end_time' => $end_time,
							'media_type' => $media_type,
							'frame_kaltura_media_id' => $kmedia->id,
							'frame_kaltura_user_id' => $kmedia->userId,
							'thumbnail_url' => $kmedia->thumbnailUrl,
							'image_url' => $kmedia->dataUrl,
							'product_url' => $magento_product->getProductUrl(),
							'created_on' => $this->currentTime($user_id)
						);
						
						$frame_id = $this->frame_model->insert('ads_frame', $frame_data);
						$video = $this->videos_model->get_video('id', $video_id, $kaltura_user_id=NULL);

						// Tag Streams
						$streams_data = array(
							'user_id' => $user_id,
							'stream_type' => 'event',
							'event_id' => $frame_id,
							'action_type' => 'frame',
							'created_on' => $this->currentTime($user_id) 
						);
						$id=$this->common_model->insert_tag_stream($streams_data);
						
						// Tagged User
						/* if($tagged_user_id) 
						{
							$taggedUserData = array(
								'user_id' => $user_id,
								'tagged_user_id' => $tagged_user_id,
								'frame_id' => $frame_id,
								'video_id' => $video_id,
								'type' => 'Frame',
								'created_at' => date('Y-m-d H:i:s', time())
							);
							
							$id= $this->ws_model->insert_tagged_user($taggedUserData);
						} */
						
						$response = array(
							'status' => 'success'
						);
						
						unlink($media_file_path);
					}	
					
				} 	
			}
				
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
		
       
		if($response['status']=="success"){
			$user= $this->common_model->get_user($video_id);
			if(!empty($user)){
				$from_user_id=$user_id;
				$to_user_id=$user->user_id;
				$action_type =2;
				$event_id =$frame_id;
				if($from_user_id !=$to_user_id){
					$this->notification($from_user_id,$to_user_id,$action_type,$event_id);
				}
			}		
		}			
		
	}
	
	public function frameslot($video_id, $start_time, $end_time)
	{
		$this->load->model('frame/frame_model');
		
		$this->load->model('videos/videos_model');
		
		
		
		$video = $this->videos_model->get_video('id', $video_id, $kaltura_user_id='', $active=1);		
        $kvideoInfo = $this->kaltura->kvideo($video->kaltura_video_id);
        $video_duration= $kvideoInfo->msDuration;
		
		
		if($end_time > $video_duration){
			$end_time= $video_duration;
		}
		$frames = $this->frame_model->get_video_frames($video_id);
		
		$noframes = array();
		
		if( ! empty($frames))
		{
			$k = 0;
			foreach($frames as $key => $frame)
			{
				if($key == 0) 
				{
					$nf_start_time = '0';
					$nf_end_time = $frame->start_time;
				} 
				else {
					$nf_start_time = $frames[$key-1]->end_time;
					$nf_end_time = $frames[$key]->start_time;
				}
				
				$noframes[] = array(
					'nfst' => $nf_start_time,
					'nfet' => $nf_end_time
				);
			}
			
			$count = count($frames);
			
			$lastspace = array(
				'nfst' => $frames[$count-1]->end_time,
				'nfet' => $video_duration
			);
		} 
		else{
			$lastspace = array(
				'nfst' => 0,
				'nfet' => $video_duration
			);
		}
		
		array_push($noframes, $lastspace);
		
		foreach($noframes as $nframe)
		{
			$nfst = $nframe['nfst'];
			$nfet = $nframe['nfet'];
			if($start_time >= $nfst && $end_time <= $nfet) {
				$status = true;
				break;
			}
			else{
				$status = false;
			}
		}
		return $status;
	}
	

	public function tagstreams()
	{
		$user_id = $this->input->get_post('user_id', true);
		$next_records = $this->input->get_post('next_records', true);
		
		if( ! $user_id) {
			$response = array(
				'status' => 'error',
			);
		}
		else {
		
			if( ! $next_records) {
				$next_records = 0;
			}
			$limit = 10;
			$offset = $next_records;
            $userList=array();			
			$friendList= $this->ws_model->get_freinds($user_id);
			$userList[]=$user_id;
			if(!empty($friendList)){
				foreach($friendList as $row){
					$userList[]=$row->user_to;
				}	
			}
			$tagstreams = $this->ws_model->get_tag_streams($userList, $limit, $offset);
			
			$records = array();
			if( ! empty($tagstreams))
			{
			foreach($tagstreams as $tagstream)
			{ 
			
			    
				if($tagstream->profile_image){
						$profile_picture = base_url().$tagstream->profile_image;
				} 
				else {
					$profile_picture = base_url().'assets/img/no-image.png';
				}
				$name = $tagstream->first_name;
				$created_at = $this->humanTiming($tagstream->user_id,$tagstream->created_on);
				
					if($tagstream->action_type == 'add') {
						$streamtype = "added a new event";
					}
					if($tagstream->action_type == 'edit') {
						$streamtype = "updated event";
					} 
					
					if($tagstream->action_type == 'comment') {
						$streamtype = "commented on event";
					} 
					if($tagstream->action_type == 'subscribe') {
						$streamtype = "subscribed event";
					} 
					if($tagstream->action_type == 'favourite') {
						$streamtype = "liked event";
					} 
					if($tagstream->action_type == 'buyproduct') {
						$streamtype = "purchased product";
					} 
					$videoData= $this->ws_model->get_video_info($tagstream->event_id);
				  	
					$kaltura_video_id = "";
					$thumbnailUrl = "";
					$dataUrl = "";
					$product = "";
					$product_url = "";
					$product_image = "";
					$product_name = "";
					$title="";
					$description="";
					$product_id="";
					$countLike="";
					$websiteVideoUrl="";
					
					$frame_media_type="";
					$frame_media_url="";
					if($tagstream->action_type != 'buyproduct') 
					{
						$kaltura_video_id = $videoData->kaltura_video_id;
						$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);
						
						$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
						$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
						$dataUrl=$this->videoDataUrl($kaltura_video_id);
							
						
						$title = $videoData->title;
						$description = $videoData->description;
					} 
					else {
						$product = $this->bwt_magento->get_product($tagstream->product_id);
						$product_url = $product->getProductUrl();
						$product_image = $product->getImageUrl();
						$product_name = $product->getName();
					}
					
					$video_id = $videoData->id;
					$countLike = $this->ws_model->count_like($video_id);
					
					$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);
					
					$liked = $this->ws_model->is_liked($user_id, $video_id);
					if($liked){
						$is_liked = 'Yes';
					} else {
						$is_liked = 'No';
					}
					
					// Event frames
					$video_frames = $this->videos_model->get_video_frames($video_id);
					$num_of_comments= $this->videos_model->num_of_comments_video($video_id);
					$frames = array();
	                $myframes =array();
					$otherframes =array();
					
					if( ! empty($video_frames)) {
						
						foreach($video_frames as $frame) {
							
							$frameDataUrl = "";
							if($frame->media_type == 'VIDEO'){
								$frm_kaltura_video_id = $frame->kaltura_video_id;
								$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
								$frameDataUrl = $frmvideo['result']->objects[0]->dataUrl;
								
						        $frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
						
							}
					        if($frame->media_type=="VIDEO"){
								$frame_media_type=111;
							}
							else if($frame->media_type=="IMAGE"){
								$frame_media_type=110;
							}
							$magento_product = $this->bwt_magento->get_product($frame->product_id);
							$user_name = $this->ion_auth->get_username($frame->user_id);
							$frames[] = array(
								'frame_id' => $frame->id,
								'user_id' => $frame->user_id,
								'user_name' => $user_name,
								'product_id' => $frame->product_id,
								'product_image' => $magento_product->getImageUrl(),
								'frame_title' => $frame->title,
								'frame_start_time' => $frame->start_time,
								'frame_end_time' => $frame->end_time,
								'frame_media_type' => $frame_media_type,
								'frame_kmedia_id' => $frame->frame_kaltura_media_id,
								'frame_thumbnail_url' => $frame->thumbnail_url,
								'frame_image_url' => $frame->image_url,
								'frame_data_url' => $frameDataUrl,
								'frame_product_url' => $magento_product->getProductUrl(),
								'frame_resource_type' =>"internet",
							);
						    if($user_id==$frame->user_id){
								
								$myframes[] = array(
									'frame_id' => $frame->id,
									'user_id' => $frame->user_id,
									'user_name' => $user_name,
									'product_id' => $frame->product_id,
									'product_image' => $magento_product->getImageUrl(),
									'frame_title' => $frame->title,
									'frame_start_time' => $frame->start_time,
									'frame_end_time' => $frame->end_time,
									'frame_media_type' => $frame_media_type,
									'frame_kmedia_id' => $frame->frame_kaltura_media_id,
									'frame_thumbnail_url' => $frame->thumbnail_url,
									'frame_image_url' => $frame->image_url,
									'frame_data_url' => $frameDataUrl,
									'frame_product_url' => $magento_product->getProductUrl(),
									'frame_resource_type' =>"internet",
								);
							}
                            else{
								$otherframes[] = array(
									'frame_id' => $frame->id,
									'user_id' => $frame->user_id,
									'user_name' => $user_name,
									'product_id' => $frame->product_id,
									'product_image' => $magento_product->getImageUrl(),
									'frame_title' => $frame->title,
									'frame_start_time' => $frame->start_time,
									'frame_end_time' => $frame->end_time,
									'frame_media_type' => $frame_media_type,
									'frame_kmedia_id' => $frame->frame_kaltura_media_id,
									'frame_thumbnail_url' => $frame->thumbnail_url,
									'frame_image_url' => $frame->image_url,
									'frame_data_url' => $frameDataUrl,
									'frame_product_url' => $magento_product->getProductUrl(),
									'frame_resource_type' =>"internet",
								);
							}								
						}
					}
					/* Tagged users on a events*/
					$frame_media_type="";
					$tagged_user_id=array();
					$taggedUserData = $this->ws_model->get_tagged_users_on_event($video_id);
					
					$profile_pic="";
					if(!empty($taggedUserData)){
						
						foreach($taggedUserData as $taggedUser){
						if(!empty($taggedUser->profile_image)){
							$profile_pic=base_url().$taggedUser->profile_image;
						}
						$tagged_user_id[]=array(
						'name'=>$taggedUser->first_name,
						'user_id'=>$taggedUser->tagged_user_id,
						'profile_pic'=>$profile_pic,
						
						);
						}
						
					}
				    
					$records[] = array(
						'action_type' => $tagstream->action_type,
						'name' => $tagstream->first_name,
						'profile_picture' => $profile_picture,
						'user_id'=>$tagstream->user_id,
						'streamtype' => $streamtype,
						'created_at' => $created_at." ago",
						'thumbnail' => $thumbnailUrl,
						'data_url' => $dataUrl,
						'kvideo_id' => $kaltura_video_id,
						'event_id' => $tagstream->event_id,
						'title' => $title,
						'description' => $description,
						'product_id' => $product_id,
						'media_type' => $frame_media_type,
						'frame_media_url' => $frame_media_url,
						'product_image' => $product_image,
						'product_name' => $product_name,
						'count_like' => $countLike,
						'website_video_url' => $websiteVideoUrl,
						'is_liked' => $is_liked,
						'frames' => $frames,
						'tagged_user_id' => $tagged_user_id,
						'num_of_comments'=>$num_of_comments,
						'my_frames'=>$myframes,
						'other_frames'=>$otherframes
					);
			}
				
				$response = array(
					'status' => 'success',
					'records' => $records
				);
			} 
			else {
				$response = array(
					'status' => 'success',
					'records'=>$records
				);
			}
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function searching() {
		
		$search = $this->input->get_post('search', true);
		$user_id = $this->input->get_post('user_id', true);
	
		if( ! $search ) { 
			$response = array(
				'status' => 'error',
			);
		} 
		else {
		
			$collections = $this->ws_model->get_search_record($search);
			 
			if(!empty($collections))	
			foreach($collections as $collection){
				
				if($collection->profile_image){
					$profile_picture = base_url().$collection->profile_image;
				} 
				else {
					$profile_picture = base_url().'assets/img/no-image.png';
				}
				
				$created_at = $this->humanTiming($user_id,$collection->created_on);
					
				if($collection->action_type != 'buyproduct') 
				{
					$kaltura_video_id = $collection->kaltura_video_id;
					$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);
					
					$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
					$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
					$dataUrl=$this->videoDataUrl($kaltura_video_id);
						
					$title = $collection->title;
					$description = $collection->description;
				} 	
			  
				$records[] = array( 
					'name' => $collection->first_name.' '.$collection->last_name,
					'profile_picture' => $profile_picture, 
					'created_at' => $created_at,
					'thumbnail' => $thumbnailUrl,
					'data_url' => $dataUrl,
					'kvideo_id' => $kaltura_video_id,
					'event_id' => $collection->id,
					'title' => $title,
					'description' => $description 
				);  
			}
			  
			$response = array(
				'status' => 'success',
				'records' => $records
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function subscribe(){
	
		$user_id = $this->input->get_post('user_id', true);
		$video_id = $this->input->get_post('video_id', true); 
	
		if ( !$video_id && !$user_id ) {
			$response = array(
				'status' => 'error',
			);
		}
		else {
			 
			$result = $this->ws_model->check_subscribe($user_id, $video_id);
			
			if($result){ 
				$message = "Already subscribed.";
				$response = array(
					'status' => 'success',
					'message' => $message 
				);
			} 
			else {
				$subscribe_data = array(
					'user_id'  => $user_id,
					'video_id' => $video_id,
					'created_on' => $this->currentTime($user_id)
				);
				
				$subscribe_video_id = $this->ws_model->insert('subscribe_video', $subscribe_data);	
				
				// Tag Streams
				$streams_data = array(
					'user_id' => $user_id,
					'stream_type' => 'event',
					'event_id' => $video_id,
					'action_type' => 'subscribe',
					'created_on' => $this->currentTime($user_id) 
				);
				$this->ws_model->insert_tag_stream($streams_data);
				
				$message = "Subscription successfully.";
				$response = array(
					'status' => 'success',
					'message' => $message 
				);
			}
			 
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	  
	public function user_timeline() {
		
		$user_id = $this->input->get_post('user_id', true);
	
		if( ! $user_id ) { 
			$response = array(
				'status' => 'error',
			);
		} 
		else {
			
			$collections = $this->ws_model->get_timelines($user_id);
			
			$kaltura_user = $this->ion_auth->get_username($user_id);
			
				foreach($collections as $event) {
					
					$kaltura_video_id = $event->kaltura_video_id;
					$video = $this->kaltura->videolist($access_type='USER', $kaltura_user, $page='', $kaltura_video_id, $categoriesId = TRUE);
					
					$duration = $video['result']->objects[0]->duration;
					$views = $video['result']->objects[0]->views;
					
					$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
					$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
					$dataUrl=$this->videoDataUrl($kaltura_video_id);
					
					if(!empty($event->event_id)){
				 
						$timelinedata[] = array(
							'event_id' => $event->event_id,
							'kuser_id' => $event->kaltura_user_id,
							'kvideo_id' => $event->kaltura_video_id,
							'type' => $event->type,
							'title' => $event->title,
							'description' => $event->description,
							'tags' => $event->tag_keyword,
							'is_paid' => $event->is_paid,
							'price' => $event->price,
							'duration' => $duration,
							'views' => $views,
							'thumbnail' => $thumbnailUrl,
							'data_url' => $dataUrl,
							'created_on' => $this->humanTiming($user_id,$event->event_date) 
						);
					}
					if(!empty($event->frame_id)){
						 
						$timelinedata[] = array(
							'frame_id' => $event->frame_id,
							'user_id' => $event->user_id,
							'video_id' => $event->video_id,
							'product_id' => $event->product_id,
							'media_type' => $event->media_type, 
							'frame_kaltura_media_id' => $event->frame_kaltura_media_id, 
							'thumbnail_url' => $event->thumbnail_url,
							'created_on' => $this->humanTiming($user_id,$event->frame_date) 
						);
						
					}	
				}
			 
			$response = array(
				'status' => 'success',
				'timelineinfo' => $timelinedata
			);
			
		}
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function like_video(){
		
		$user_id = $this->input->get_post('user_id', true);
		$video_id = $this->input->get_post('video_id', true);
	
		if( !$user_id ) { 
			$response = array(
				'status' => 'error',
			);
		}
		else if(!$video_id)	{
			$response = array(
				'status' => 'error',
			);
		}
		else {
			
			$data = array( 
				'user_id' => $user_id,
				'video_id' => $video_id,
				'created_on' => $this->currentTime($user_id)
			);
			
			$this->ws_model->insert('videos_likes', $data);
			
			$count_like = $this->ws_model->get_all_like_count($video_id);
			
			$response = array(
				'status' => 'success',
				'count_like' => $count_like
			);
		}
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response)); 
		
        if($response['status']=="success"){
			$user= $this->common_model->get_user($video_id);
			if(!empty($user)){
				$from_user_id=$user_id;
				$to_user_id=$user->user_id;
				$action_type =8;
				$event_id =$video_id;
				
                if($from_user_id !=$to_user_id){
					$this->notification($from_user_id,$to_user_id,$action_type,$event_id);
				}				
			}
		}			
	}
	
	public function unlike_video(){
		
		$user_id = $this->input->get_post('user_id', true);
		$video_id = $this->input->get_post('video_id', true);
	
		if( !$user_id ) { 
			$response = array(
				'status' => 'error',
			);
		}
		else if(!$video_id)	{
			$response = array(
				'status' => 'error',
			);
		}
		else {
			
			$this->ws_model->remove_video_like($user_id, $video_id);
			$count_like = $this->ws_model->get_all_like_count($video_id);
			
			$response = array(
				'status' => 'success',
				'count_like' => $count_like
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response)); 
			
		
	}
	
	public function testing() {
	
		$apikey = $this->input->get_post('apikey');
		$method = $this->input->get_post('method');
		$data = $this->input->get_post('data');
	
		$name = $this->input->get_post('name');
		$esr_name = $this->input->get_post('esr_name');
		$time = $this->input->get_post('time');
		$date = $this->input->get_post('date');
		
		$media_file = $this->input->get_post('media_file');
		$media_file_esr = $this->input->get_post('media_file_esr');
		 
		if(!$apikey && !$method) {
			$response = array(
				'status' => 'error'
			);
		} 
		else { 
		
		//-----------------------------
		
			$upload_path = 'media/user_image/';
			$config['upload_path'] = $upload_path;
			$config['allowed_types'] = 'gif|jpg|jpeg|png';
			$config['max_size'] = '5120';
			$config['encrypt_name'] = TRUE;
			
			$this->load->library('upload', $config);
			
			if( ! $this->upload->do_upload('media_file')) {
				
				$media_file  =  $this->upload->display_errors();
				
			}
			else {
				$media_file_data = $this->upload->data();
				$media_file = base_url().$upload_path.$media_file_data['file_name'];
				 
			}
			
		//------------------------------
		
			$upload_path = 'media/user_image/';
			$config['upload_path'] = $upload_path;
			$config['allowed_types'] = 'gif|jpg|jpeg|png';
			$config['max_size'] = '5120';
			$config['encrypt_name'] = TRUE;
			
			$this->load->library('upload', $config);
			
			if( ! $this->upload->do_upload('media_file_esr')) {
				 
				$media_file_esr  =  $this->upload->display_errors();
				 
			}
			else {
				$imagedata = $this->upload->data();
				$media_file_esr = base_url().$upload_path.$imagedata['file_name']; 
			}

			$userdata = array(
				'apikey' => $apikey,
				'method' => $method,
				'data' => $data,
				'name' => $name,
				'esr_name' => $esr_name,
				'time' => $time,
				'date' => $date, 
				'media_file' => $media_file ,
				'media_file_esr' => $media_file_esr 
			);
			
			$response = array(
				'status' => 'success',
				'userinfo' => $userdata
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	function follow(){
		
		$user_id = $this->input->get_post('user_id', true);
		$to_user_id = $this->input->get_post('to_user_id', true);
	
		if( ! $user_id && (!$to_user_id)) { 
			$response['follow'] = array(
				'status' => 'user id not exists'
			);
		} 
		else {
			
			$check_request = $this->ws_model->check_request($user_id, $to_user_id);
			
			if( ! empty($check_request)){ 
				$response['follow'] = array(
					'status' => 'user already followed'
				);
			}
			else {
				$is_blocked = $this->ws_model->check_is_blocked($user_id, $to_user_id);
				$check_other_blocked = $this->ws_model->check_other_blocked($user_id, $to_user_id);
				
			    if($is_blocked OR $check_other_blocked){
					$response['follow'] = array(
					'status' => 'you can not follow'
				    );
				}
				else {
					$this->load->model('ion_auth_model');
					$result = $this->ion_auth_model->check_viewer_privacy($to_user_id);
					$request = 0;
					
					if( !$result) {
						$request = 1;
					}
					
					$requestData = array(
						'user_from' => $user_id,
						'user_to' => $to_user_id,
						'request' => $request,
						'created_on' => $this->currentTime($user_id)
					);
					
					$id = $this->ws_model->insert_friends($requestData);
					
					
					$to_user= $to_user_id;
					//$all_friends= $this->common_model->get_friends($user_id);
					if($id){
						$from_user_id=$user_id;
						$to_userid=$to_user;
						$action_type =4;
						$event_id =$to_user;
						
						if($from_user_id !=$to_user_id){
						 $this->notification($from_user_id,$to_userid,$action_type,$event_id);
						}
							
					}
					
					/* if(!empty($all_friends)){
							foreach($all_friends as $friend){
							$from_user_id=$user_id;
							$to_userid=$friend->user_from;
							$action_type =4;
							$event_id =$to_user;
						
							if($from_user_id !=$to_user_id){
							$this->notification($from_user_id,$to_userid,$action_type,$event_id);	
							}		
						}
					} */
					
					$response['follow'] = array(
						'status' => 'success',
					);
				}
			}
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
		
       
	}
	
	function unfollow(){

		$user_id = $this->input->get_post('user_id', true);
		$to_user_id = $this->input->get_post('to_user_id', true);
		$type = $this->input->get_post('type', true);
	
		if( ! $user_id && (!$to_user_id)) { 
			$response['unfollow'] = array(
				'status' => 'user id not exists'
			);
		} 
		else {
			if($type == 'follower') {
				$this->ws_model->delete_followers($user_id, $to_user_id);
				$this->ws_model->delete_followers_notification($user_id, $to_user_id);
			} 
			else {
				$this->ws_model->delete_following($user_id, $to_user_id);
				$this->ws_model->delete_following_notification($user_id, $to_user_id);
			}
			
			$response['unfollow'] = array(
				'status' => 'success'
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
			
		 
			
	}
	
	public function followers() {
		
		$user_id = $this->input->get_post('user_id', true);
		$next_records = $this->input->get_post('next_records', true);
	
		if( ! $user_id ) { 
			$response = array(
				'status' => 'user id not exists'
			);
		} 
		else {
			
			if( ! $next_records) {
				$next_records = 0;
			}
			$limit = 10;
			$offset = $next_records;
			
			$followers = $this->ws_model->get_followers($user_id, $limit, $offset);
			
			$number_of_followers = $this->ws_model->count_followers($user_id);
			
			$followerList = array();
			
			if( ! empty($followers))
			{
				foreach($followers as $row){
				
					$profile_image = "";
					if($row->profile_image) {
						$profile_image = base_url().$row->profile_image;
					}
				    $isFollowing= $this->ws_model->checkFollowing($user_id,$row->id);
					$followerList[] = array(
					    'to_user_id' => $row->id,
						'user_id' => $user_id,
						'first_name' => $row->first_name,
						'last_name' => $row->last_name,
						'username' => $row->username,
						'email' => $row->email,
						'image' => $profile_image,
						'number_of_followers' => $number_of_followers,
						'is_following' => $isFollowing,
					);
				}
				$response = array(
				'status' => 'success',
				'userinfo' => $followerList
			   );
			}
			else{
				$response = array(
				'status' => 'success',
				'userinfo' => $followerList
			   );
			}
			
			
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function following() {
		
		$user_id = $this->input->get_post('user_id', true);
		$next_records = $this->input->get_post('next_records', true);
		
		if( ! $user_id ) { 
			$response = array(
				'status' => 'user id not exists'
			);
		} 
		else {
		
			if( ! $next_records) {
				$next_records = 0;
			}
			$limit = 10;
			$offset = $next_records;
			
			$following = $this->ws_model->get_following($user_id, $limit, $offset);
			
			$number_of_following = $this->ws_model->count_following($user_id);
			
			$followingList = array();
			
			if( ! empty($following))
			{
				foreach($following as $row){
				
					$profile_image = "";
					if($row->profile_image) {
						$profile_image = base_url().$row->profile_image;
					}
				
					$followingList[] = array(
						'to_user_id' => $row->id,
						'user_id' => $user_id,
						'first_name' => $row->first_name,
						'last_name' => $row->last_name,
						'username' => $row->username,
						'email' => $row->email,
						'image' => $profile_image,
						'number_of_following' => $number_of_following,
					);
				 }
				$response = array(
				'status' => 'success',
				'userinfo' => $followingList
			    );
			}
			else{
				$response = array(
				'status' => 'success',
				'userinfo' => $followingList
			    );
			}
			
			
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
		
	}
	
	public function search() {
		
		$user_id = $this->input->get_post('user_id', true);
		$keyword = $this->input->get_post('keyword', true);
		
		if( ! $user_id ) { 
			$response = array(
				'status' => 'user id not exists'
			);
		} 
		else {
			$blockedUsers= $this->ws_model->blocked_users($user_id);
			//echo "<pre>";print_r($blockedUsers);die;
			$results = $this->ws_model->get_search_user($user_id, $keyword);
			
			$resultList = array();
			
			if( ! empty($results))
			{
				foreach($results as $row){
					if (!in_array($row->id, $blockedUsers)) {
						$profile_image = "";
						if($row->profile_image) {
							$profile_image = base_url().$row->profile_image;
						}
						
						$result = $this->ws_model->check_followed($user_id, $user->id);
						$is_followed = 'No';
						if($result){
							$is_followed = 'Yes';
						}
					
						$resultList[] = array(
							'user_id' => $user_id,
							'to_user_id' => $row->id,
							'first_name' => $row->first_name,
							'last_name' => $row->last_name,
							'username' => $row->username,
							'email' => $row->email,
							'followed' => $is_followed,
							'image' => $profile_image,
						);
					}
				}
			}
			
			$response = array(
				'status' => 'success',
				'userinfo' => $resultList
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function profile() {
		
		$user_id = $this->input->get_post('user_id', true);
		$logged_user_id = $this->input->get_post('logged_user_id', true);
		
		if( ! $user_id ) { 
			$response = array(
				'status' => 'user id not exists'
			);
		}
		else {
			
			$user = $this->ion_auth->user($user_id)->row();
			
			$frames = $this->ws_model->count_user_frames($user_id);
			
			$number_of_frames = COUNT($frames);
			
			$number_of_event = $this->ws_model->count_user_events($user_id);
			$number_of_following = $this->ws_model->count_following($user_id);
			$number_of_followers = $this->ws_model->count_followers($user_id);
			$number_of_timeline = $this->ws_model->count_user_timeline($user_id);
			
			$profile_image = "";
			if($user->profile_image) {
				$profile_image = base_url().$user->profile_image;
			}
			
			$result = $this->ws_model->is_followed($user_id, $logged_user_id);
			
			$is_followed = 'No';
			
			if($result == 'followed'){
				$is_followed = 'followed';
			}
			if($result == 'follower'){
				$is_followed = 'follower';
			}
			$blocked = $this->ws_model->is_blocked($user_id, $logged_user_id);
			
			$is_blocked=false;
			if($blocked){
				$is_blocked= $blocked->is_blocked;
				if($blocked->is_blocked==1){
					$is_blocked=true;
				}
				if($blocked->is_blocked==0){
					$is_blocked=false;
				}
			}
			
			$resultList = array(
				'user_id' => $user_id,
				'username' => $user->username,
				'first_name' => $user->first_name,
				'description' => $user->description,
				'profile_image' => $profile_image,
				'number_of_event' => $number_of_event,
				'number_of_frame' => $number_of_frames,
				'number_of_following' => $number_of_following,
				'number_of_followers' => $number_of_followers,
				'number_of_timeline' => $number_of_timeline,
				'followed' => $is_followed,
				'blocked' => $is_blocked
			);
			
			$response = array(
				'status' => 'success',
				'userinfo' => $resultList
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	function update_identity(){

		$user_id = $this->input->get_post('user_id', true);
		$email = $this->input->get_post('email', true);
		$username = $this->input->get_post('username', true);
		$first_name = $this->input->get_post('first_name', true);
		$description = $this->input->get_post('description', true);
		
		if( ! $user_id) { 
			$response = array(
				'status' => 'user id not exists'
			);
		} 
		else if( ! $username && ! $email) { 
			$response = array(
				'status' => 'error'
			);
		} 
		else {
			$user = $this->ion_auth->user($user_id)->row();
			
			if($user->email != $email && $this->ion_auth_model->email_check($email) ) {
				
				$response = array(
					'status' => $email.' email id already exists.'
				);
				
			} 
			else if($user->username != $username && $this->ion_auth_model->username_check($username)) {

				$response = array(
					'status' => $username.' username id already exists.'
				);

			} 
			else {
				if($_FILES){
					$upload_path = 'media/user_image/';
					$config['upload_path'] = $upload_path;
					$config['allowed_types'] = 'gif|jpg|jpeg|png';
					$config['max_size'] = '5120';
					$config['encrypt_name'] = TRUE;
					
					$this->load->library('upload', $config);
					
					if( ! $this->upload->do_upload('profile_photo')) {
						$response = array(
							'status' => $this->upload->display_errors()
						);
					}
                    else{
						$user = $this->ion_auth->user($user_id)->row();
						if($user->profile_image && file_exists($user->profile_image)) {
							unlink($user->profile_image);
						}
						$imagedata = $this->upload->data();
						$profile_photo = $upload_path.$imagedata['file_name'];
						$userdata = array(
						'username' => $username,
						'email' => $email,
						'first_name' => $first_name,
						'description' => $description,
						'profile_image' => $profile_photo
						);
						
						$this->ion_auth->update($user_id, $userdata);
						$userinfo = array(
						'user_id' => $user_id,
						'username' => $username,
						'email' => $email,
						'first_name' => $first_name,
						'description' => $description,
						'profile_image' =>base_url().$profile_photo
						);
						$response = array(
							'status' => 'success',
							'userinfo' => $userinfo
						);
				    }	
				}
				else{
					$userdata = array(
					'username' => $username,
					'email' => $email,
					'first_name' => $first_name,
					'description' => $description,
					);
					$this->ion_auth->update($user_id, $userdata);
					$user = $this->ion_auth->user($user_id)->row();
					if($user->profile_image){
						$profile_photo=base_url().$user->profile_image;
					}
					else{
						$profile_photo="";
					}
					$userinfo = array(
					'user_id' => $user_id,
					'username' => $username,
					'email' => $email,
					'first_name' => $first_name,
					'description' => $description,
					'profile_image' =>$profile_photo
					);
					$response = array(
						'status' => 'success',
						'userinfo' => $userinfo
					);
				}
			}
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function timeline()
	{
		$user_id = $this->input->get_post('user_id', true);
		$next_records = $this->input->get_post('next_records', true);
		
		if( ! $user_id) {
			$response = array(
				'status' => 'error',
			);
		}
		else {
		
			if( ! $next_records) {
				$next_records = 0;
			}
			$limit = 10;
			$offset = $next_records;
			
			$tagstreams = $this->ws_model->get_tagged_users($user_id, $limit, $offset);
			$records = array();
			//echo "<pre>";print_r($tagstreams); die;
			if( ! empty($tagstreams))
			{
				foreach($tagstreams as $tagstream)
				{ 
					if($tagstream->profile_image){
						$profile_picture = base_url().$tagstream->profile_image;
					} 
					else {
						$profile_picture = base_url().'assets/img/no-image.png';
					}
					
					$name = $tagstream->first_name;
					
					$createdTime= $this->date_to_time($tagstream->tuuserId,$tagstream->created_at);
					
					$created_at = $this->humanTiming($tagstream->tuuserId,$createdTime);
					
					$title = "";
					$kaltura_video_id = "";
					$thumbnailUrl = "";
					$dataUrl = "";
					$product = "";
					$product_url = "";
					$product_image = "";
					$product_name = "";
					
					if($tagstream->type == 'Event') 
					{
						$kaltura_video_id = $tagstream->kaltura_video_id;
						$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);
						
						$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
						$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
						$dataUrl=$this->videoDataUrl($kaltura_video_id);
							
						$title = $tagstream->title;
						$description = $tagstream->description;
					} 
					else if($tagstream->product_id) {
					
						$product = $this->bwt_magento->get_product($tagstream->product_id);
						$product_url = $product->getProductUrl();
						$product_image = $product->getImageUrl();
						$product_name = $product->getName();
					}
					
					$video_id = $tagstream->id;
					$countLike = $this->ws_model->count_like($video_id);
					
					$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);
					
					$liked = $this->ws_model->is_liked($user_id, $video_id);
					if($liked){
						$is_liked = 'Yes';
					} else {
						$is_liked = 'No';
					}
					// Event frames
					
					$video_frames = $this->videos_model->get_video_frames($video_id);
					$num_of_comments= $this->videos_model->num_of_comments_video($video_id);
					$frames = array();
	
					if(!empty($video_frames)) {
						
						foreach($video_frames as $frame) {
							
							$frameDataUrl = "";
							if($frame->media_type == 'VIDEO'){
								$frm_kaltura_video_id = $frame->kaltura_video_id;
								$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
								
							    $frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
							
							}
					        if($frame->media_type=="VIDEO"){
								$frame_media_type=111;
							}
							else if($frame->media_type=="IMAGE"){
								$frame_media_type=110;
							}
							$magento_product = $this->bwt_magento->get_product($frame->product_id);
						
							$frames[] = array(
								'frame_id' => $frame->id,
								'user_id' => $frame->user_id,
								'product_id' => $frame->product_id,
								'product_image' => $magento_product->getImageUrl(),
								'frame_title' => $frame->title,
								'frame_start_time' => $frame->start_time,
								'frame_end_time' => $frame->end_time,
								'frame_media_type' => $frame_media_type,
								'frame_kmedia_id' => $frame->frame_kaltura_media_id,
								'frame_thumbnail_url' => $frame->thumbnail_url,
								'frame_image_url' => $frame->image_url,
								'frame_data_url' => $frameDataUrl,
								'frame_product_url' => $magento_product->getProductUrl(),
								'frame_resource_type' =>"internet",
							);
						}
					}
					
					$taggedUserData = $this->ws_model->get_tagged_users_on_event($video_id);
					
					$profile_pic="";
					foreach($taggedUserData as $taggedUser){
						if(!empty($taggedUser->profile_image)){
							$profile_pic=base_url().$taggedUser->profile_image;
						}
						$tagged_user_id[]=array(
						'name'=>$taggedUser->first_name,
						'user_id'=>$taggedUser->tagged_user_id,
						'profile_pic'=>$profile_pic,
						
						);
					}
					
					$records[] = array(
						'tag_type' => $tagstream->type,
						'thumbnail' => $thumbnailUrl,
						'data_url' => $dataUrl,
						'kvideo_id' => $kaltura_video_id,
						'event_id' => $tagstream->id,
						'title' => $title,
						'description' => $description,
						'product_url' => $product_url,
						'product_image' => $product_image,
						'product_name' => $product_name,
						'created_at' => $created_at." ago",
						'count_like' => $countLike,
						'website_video_url' => $websiteVideoUrl,
						'is_liked' => $is_liked,
						'name' => $name,
						'profile_picture' => $profile_picture,
						'user_id'=>$tagstream->user_id,
						'frames' => $frames,
						'tagged_user_id'=>$tagged_user_id,
						'num_of_comments'=>$num_of_comments
					);
									
				}
				
				$response = array(
					'status' => 'success',
					'records' => $records
				);
			}
			else{
				$response = array(
					'status' => 'success',
					'records' => $records
				);
			}
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function search_users()
	{
		$keyword = $this->input->get_post('keyword', true);
		$next_records = $this->input->get_post('next_records', true);
		$user_id = $this->input->get_post('user_id', true);
		
		if( ! $keyword) {
			$response = array(
				'status' => 'error',
			);
		}
		else {
		
			if( ! $next_records) {
				$next_records = 0;
			}
			$limit = 10;
			$offset = $next_records;
			
			$users = $this->ws_model->search_user($keyword, $limit, $offset);
			
			if( ! empty($users))
			{
				foreach($users as $user) {
					
					if($user->profile_image){
						$profile_picture = base_url().$user->profile_image;
					} 
					else {
						$profile_picture = base_url().'assets/img/no-image.png';
					}
					
					$result = $this->ws_model->check_followed($user_id, $user->id);
					$is_followed = 'No';
					if($result){
						$is_followed = 'Yes';
					}
					
					$name = $user->first_name.' '.$user->last_name;
					
					$records[] = array(
						'user_id' => $user->id,
						'name' => $name,
						'followed' => $is_followed,
						'profile_picture' => $profile_picture,
					);
				}
			}
			
			$response = array(
				'status' => 'success',
				'records' => $records
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function delete_user()
	{
		$user_id = $this->input->get_post('user_id', true);
		
		if( ! $user_id) {
			$response = array(
				'status' => 'user id not exists',
			);
		}
		else {
		
			$user = $this->ion_auth->user($user_id)->row();
			
			$kaltura_user = $user->username;
			
			$this->db->where('user_id', $user_id);
			$query = $this->db->get('videos');
			$videos = $query->result();
			if(!empty($videos))
			{
				foreach($videos as $video)
				{
					$video = $this->videos_model->get_video('id', $video->id, $kaltura_user, $active=NULL);
					
					// Kaltura data
					$media = array(
						'user' => $kaltura_user,
						'access_type' => 'USER',
					);
					$this->kaltura->delete($media, $video->kaltura_video_id);
					
					$this->load->model('videos/videos_model');
					
                
                   /* Delete Frame */
					$event_id= $video->id;
					$video_frames = $this->videos_model->get_video_frames($event_id);
					if( ! empty($video_frames)) {
						foreach($video_frames as $frame) {
							
							$this->ws_model->removeEventFrameNotification($frame->id);
							$this->ws_model->removeEventFrame($frame->id);
							
							if($frame->frame_kaltura_media_id){
								$entryId = $frame->frame_kaltura_media_id;
								$media = array(
									'user' => $frame->frame_kaltura_user_id,
									'access_type' => 'USER',
								);
								$this->kaltura->delete($media, $entryId);
							}

						}
					}
					$event_info= $this->videos_model->get_event($event_id);
					//print_r($event_info);
					if(!empty($event_info->kaltura_video_id)){
						$entryId = $event_info->kaltura_video_id;
						$media = array(
							'user' => $event_info->kaltura_user_id,
							'access_type' => 'USER',
						);
						$this->kaltura->delete($media, $entryId);
					}
							
					$this->ws_model->removeEventNotification($event_id);
					$this->ws_model->remove_event($event_id);
					$this->ws_model->remove_video_likes($event_id);
					$this->ws_model->remove_video_comments($event_id);
					$this->ws_model->remove_favourite_video($event_id);	
					$this->ws_model->remove_tag_streams($event_id);
					
					/* End delete frame option */
						
				}
			}
		
			if($user->profile_image && file_exists($user->profile_image)) {
				unlink($user->profile_image);
			}
		
			$this->ion_auth_model->del_user($user_id);
		
			$response = array(
				'status' => 'success',
			);
		}
			
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function search_product()
	{
		$keyword = $this->input->get_post('product_title', true);
        $page_number = $this->input->get_post('page_number', true);

        if(!$page_number){
           $page_number=1;                
        }    
		$this->load->library('bwt_magento');
		if($keyword){
			$products = $this->bwt_magento->product_search($keyword,$page_number);
            $last_page_number = $this->bwt_magento->product_count_for_search();
		}
		else{
		    $products = $this->bwt_magento->product_search_all($page_number);
            $last_page_number = $this->bwt_magento->product_count();
		}
            $records_null=array();  
			$records = array();
			if( count($products) > 0){
				foreach($products as $product){
					$records[] = array(
						'product_id' => $product->getId(),
						'product_name' => $product->getName(),
						'product_url' => $product->getProductUrl(),
						'product_image' => $product->getImageUrl(),
                        'product_price'=>number_format($product->getPrice(),2)
					);  
				}
			}
		
			if($page_number>$last_page_number){
				$response = array(
				'status' => 'success',
				'records' => $records_null
			   ); 
			}
			else{
				$response = array(
				'status' => 'success',
				'records' => $records
			    );
			}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function post_comment()
	{
		$user_id = $this->input->get_post('user_id');
		$parent_id = $this->input->get_post('parent_id');
		$video_id = $this->input->get_post('video_id');
		$comment = $this->input->get_post('comment');
		
		if( ! $user_id && ( ! $comment)) {
			$response = array(
				'status' => 'error',
			);
		}
		else {
		
			$comment_data = array(
				'parent_id' => $parent_id,
				'user_id' => $user_id,
				'video_id' => $video_id,
				'comment' => $comment,
				'created_on' => $this->currentTime($user_id),
				'status' => 1
			);
			$comment_id = $this->videos_model->insert_comment($comment_data);
			
			// Tag Streams
			$streams_data = array(
				'user_id' => $user_id,
				'stream_type' => 'event',
				'event_id' => $video_id,
				'action_type' => 'comment',
				'created_on' => $this->currentTime($user_id) 
			);
			$this->common_model->insert_tag_stream($streams_data);
			
			$comment = $this->videos_model->get_video_comment($comment_id);
			
			$profile_image = "";
			if($comment->profile_image) {
					$profile_image = base_url().$comment->profile_image;
			} 
	
			$commentData = array(
				'id' => $comment->id,
				'parent_id' => $comment->parent_id,
				'video_id' => $comment->video_id,
				'profile_image' => $profile_image,
				'username' => $comment->username,
				'created_on' => date('F d, Y G:i A', $comment->created_on),
				'comment' => $comment->comment,
			);
			
			$response = array(
				'status' => 'success',
				'comment' => $commentData
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
		
       
		if($response['status']=="success"){
			$user= $this->common_model->get_user($video_id);
            if(!empty($user)){
				$from_user_id=$user_id;
				$to_user_id=$user->user_id;
				$action_type =6;
			    $event_id =$comment_id.",".$video_id;
				
				if($from_user_id !=$to_user_id){
					$this->notification($from_user_id,$to_user_id,$action_type,$event_id);		
				}
			}			
			
		}		
		
			
	}
	
	public function comment_list()
	{
		$video_id = $this->input->get_post('video_id');
		$user_id = $this->input->get_post('user_id');
		
		$next_records = $this->input->get_post('next_records', true);
		
		if( ! $video_id ) {
			$response = array(
				'status' => 'error',
			);
		}
		else {
			if( ! $next_records) {
				$next_records = 0;
			}
			$limit = 3;
			$offset = $next_records;
			
			$commentData = array();
			$comments = $this->videos_model->get_video_comments($video_id, $parent_id=0,$limit, $offset);
			
			if( ! empty($comments)) {
				foreach($comments as $comment){
					
					$profile_image = "";
					if($comment->profile_image) {
						$profile_image = base_url().$comment->profile_image;
					} 
					
				$replycomments = array();
					
				$replyComment = $this->videos_model->get_video_comments($video_id, $comment->id,$limit, $offset);

					if( ! empty($replyComment)) {
						foreach($replyComment as $rplcomment){
							
							$rplprofile_image = "";
							if($rplcomment->profile_image) {
								$rplprofile_image = base_url().$rplcomment->profile_image;
							}
							
							$replycomments[] = array(
								'id' => $rplcomment->id,
								'parent_id' => $rplcomment->parent_id,
								'video_id' => $rplcomment->video_id,
								'profile_image' => $rplprofile_image,
								'username' => $rplcomment->username,
								'created_on' => $this->setTimeZone($user_id,$comment->created_on),
								'comment' => $rplcomment->comment,
							);
						}
					}
					
					$commentData[] = array(
						'id' => $comment->id,
						'parent_id' => $comment->parent_id,
						'video_id' => $comment->video_id,
						'profile_image' => $profile_image,
						'username' => $comment->username,
						'created_on' => $this->setTimeZone($user_id,$comment->created_on),
						'comment' => $comment->comment,
						'replycomments' => $replycomments,
					);
					
				}
			}
			
			$response = array(
				'status' => 'success',
				'comments' => $commentData,
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	/* Mahesh */
	public function edit_frame(){
		$user_id= $this->input->get_post('user_id',true);
		$frame_id= $this->input->get_post('frame_id',true);
		$video_id= $this->input->get_post('video_id',true);
		$product_id= $this->input->get_post('product_id',true);
		$title= $this->input->get_post('title',true);
		$start_time= $this->input->get_post('start_time',true);
		$end_time= $this->input->get_post('end_time',true);
		
		if(!$frame_id ) {
			$response = array(
				'status' => 'error',
			);
		}
		else{
			$framestatus = $this->frameslot($video_id, $start_time, $end_time);
			
			if( ! $framestatus)
			{ 
				$response = array(
					'status' => 'no space available'
				);
			} 
			else{
				$frame_data=array(
				'product_id' => $product_id,
				'title' => $title,
				'start_time' => $start_time,
				'end_time' => $end_time
				);
				$this->ws_model->edit_frame($frame_id,$frame_data);
				$response = array(
					'status' => 'success'
				);
				
			}
		}
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
		
        if($response['status']=="success"){
			$user= $this->common_model->get_user($video_id);
			if(!empty($user)){
				$from_user_id=$user_id;
				$to_user_id=$user->user_id;
				$action_type =3;
				$event_id =$frame_id;
				
                if($from_user_id !=$to_user_id){
					$this->notification($from_user_id,$to_user_id,$action_type,$event_id);
				}
			}	
		}		
			
	}
	
	public function direct_endorse(){
		
		$from_user_id= $this->input->get_post('from_user_id',true);
		$to_user_id= $this->input->get_post('to_user_id',true);
		$product_id= $this->input->get_post('product_id',true);
		$message= $this->input->get_post('message',true);
		
		if(!$from_user_id OR !$to_user_id OR !$product_id){
			$response = array(
				'status' => 'error',
			);
		}
		else{
			
			
			$direct_endorse_data=array(
			'from_user_id' => $from_user_id,
			'to_user_id' => $to_user_id,
			'product_id' => $product_id,
			'message' => $message,
			'date' => $this->dateTime($from_user_id)
			);
			$id= $this->ws_model->insert_direct_endorse($direct_endorse_data);
			
			if($id){
				$response = array(
					'status' => 'success',
				);
				$to_user =$to_user_id;
			}
			
		}
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
		
		if($response['status']=="success"){
			
			$from_user_id=$from_user_id;
			$to_user_id=$to_user;
			$action_type =9;
			$event_id =$product_id.':'.$message;
			
            if($from_user_id !=$to_user_id){
				$this->notification($from_user_id,$to_user_id,$action_type,$event_id);
			}			
		}		
		
	}
	public function direct_endorse_list(){
		$from_user_id= $this->input->get_post('from_user_id',true);
		
		if(!$from_user_id){
			$response = array(
				'status' => 'error',
			);
		}
		else{
		
			$endorsedata=array();
			$endorse_data=$this->ws_model->get_direct_endorse($from_user_id);
			if(!empty($endorse_data)){
				foreach($endorse_data as $endors){
					
					$magento_product = $this->bwt_magento->get_product($endors->product_id);
					$user = $this->ion_auth->user($endors->to_user_id)->row();
					$profile_image="";
					if($user->profile_image){
						$profile_image =base_url().$user->profile_image;
					}
					$newDate = date("m-d-Y", strtotime($endors->date));
					$endorsedata[]=array(
					'from_user_id' =>$endors->from_user_id,
					'to_user_id' => $endors->to_user_id,
					'product_id' => $endors->product_id,
					'message' => $endors->message,
					'date' => $newDate,
					'user_name' =>$user->first_name,
					'user_image' =>$profile_image,
					'product_name' => $magento_product->getName(),
					'product_image' => $magento_product->getImageUrl()
					);
					
				}
				
				$response = array(
						'status' => 'success',
						'endorseData'=>$endorsedata
				);
			}
			else{
				$response = array(
						'status' => 'success',
						'endorseData'=>$endorsedata
				);
			}
		}
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function notification($from_user_id,$to_user_id,$action_type,$event_id){
		
		$notificationData= array(
		'from_user_id'=>$from_user_id,
		'to_user_id'=>$to_user_id,
		'action_type'=>$action_type,
		'event_id'=>$event_id,
		'is_view'=>0,
		'created_on'=>$this->dateTime($from_user_id)
		);
		
		$user = $this->ion_auth->user($from_user_id)->row();
		$user_name = $user->first_name;	
		
		$this->common_model->insert_notification($notificationData);
		$device_session= $this->common_model->get_user_session($to_user_id);
		
		if(!empty($device_session)){
			foreach($device_session as $session){
				$reg_id= $session->reg_token;
				$user_id=$session->user_id;
				$notifyMessage=$this->push_notification_message($event_id,$action_type);
				
				if(!empty($notifyMessage)){
				$message=$notifyMessage['message'];
				$sub_action_id=$notifyMessage['sub_action_id'];
				$sub_action_type=$notifyMessage['sub_action_type'];
				$title= $user_name;	
				$this->send_fcm_notify($reg_id, $message,$sub_action_id,$sub_action_type,$title,$user_id);
					
				}
				
			}
	    }
		
    }
	
	function push_notification_message($event_id,$action_type){
		$notifyMessage=array();
		if(!empty($event_id)){
			if($action_type==1){
				$table= 'videos';	
				$action= "has added an event";	
				$sub_action_type="watch_event";
			}
			else if($action_type==2){
				$table= 'ads_frame';
				$action='has added a frame';
				$sub_action_type="watch_frame";					
			}
			else if($action_type==3){
				$table= 'ads_frame';
				$action='has edited a frame';	
				$sub_action_type="watch_frame";					
			}
			else if($action_type==4){
				$table1= 'friend_requests';
				$action='followed';
				$sub_action_type="watch_profile";
			}
			else if($action_type==5){
				$table1= 'friend_requests';
				$action='unfollowed';
				$sub_action_type="watch_profile";
			}
			else if($action_type==6){
				$comment_id= strstr("$event_id",",",true);
				$event_id= substr("$event_id", strpos("$event_id", ",") + 1);
				$table= 'videos';
				$action='has commented on an event';
				$sub_action_type="watch_comment";
			}
			else if($action_type==7){
				$comment_id= strstr("$event_id",",",true);
				$event_id= substr("$event_id", strpos("$event_id", ",") + 1);
				$table= 'videos';
				$action='has replyed on a comment';
				$sub_action_type="watch_comment";
			}
			else if($action_type==8){
				$table= 'videos';
				$action='has liked an event ';
				$sub_action_type="watch_event";
			}
			else if($action_type==9){
						
				$table2= 'product';
				$action='has endorsed a product to you';
				$sub_action_type="watch_product";
			}
			else if($action_type==10){
				$table= 'videos';
				$action='has tagged you in an event';
				$sub_action_type="watch_event";
			}
			else{
				$table4= 'Unknown';
				$action='Unknown';
			}
			
			if($table){
				$eventName= $this->common_model->eventName($table,$event_id);
				$event_name=$eventName->title;
				$table="";
			}
			if($table1){
				$eventName= $this->common_model->followUser($event_id);
				$event_name=$eventName->first_name;
				$table1="";
			}
			
			if($table2){
				$magento_product = $this->bwt_magento->get_product($event_id);
				$event_name=$magento_product->getName();
				$table2="";
			}
			if($table3){
				$eventName= $this->common_model->eventName($table3,$event_id);
				$event_name=$eventName->comment;
				$table3="";
			}
			if($table4){
				$table4="";
			}	
			
			$notifyMsg= $action." ".$event_name;
			$notifyMessage=array(
			'message'=>$notifyMsg,
			'sub_action_id'=>$event_id,
			'sub_action_type'=>$sub_action_type
			);
			
		}
		  
			return $notifyMessage;
	}
	
	public function get_notification(){
		$user_id = $this->input->get_post('user_id', true);
		$next_records = $this->input->get_post('next_records', true);
		
		if( ! $user_id) {
			$response = array(
				'status' => 'error',
			);
		}
		else {
		
			if( ! $next_records) {
				$next_records = 0;
			}
			$limit = 10;
			$offset = $next_records; 
			$notifications=array();
			
			$notificationsData = $this->common_model->get_notification($user_id, $limit, $offset);
			
			if(!empty($notificationsData)){
				foreach($notificationsData as $notify ){
					$msg="";
					$event_id= $notify->event_id; 
					if($notify->action_type==1){
						$table= 'videos';	
						$action= "has added an event";	
						$sub_action_type="watch_event";
					}
					else if($notify->action_type==2){
						$table= 'ads_frame';
						$action='has added a frame to an event';
						$sub_action_type="watch_frame";					
					}
					else if($notify->action_type==3){
						$table= 'ads_frame';
						$action='has edited a frame';	
						$sub_action_type="watch_frame";					
					}
					else if($notify->action_type==4){
						$table1= 'friend_requests';
						$action='followed';
						$sub_action_type="watch_profile";
					}
					else if($notify->action_type==5){
						$table1= 'friend_requests';
						$action='unfollowed';
						$sub_action_type="watch_profile";
					}
					else if($notify->action_type==6){
						
						$comment_id= strstr("$event_id",",",true);
						$event_id= substr("$event_id", strpos("$event_id", ",") + 1);
						$table3= 'comments';
						$action='has commented on an event';
						$sub_action_type="watch_comment";
					}
					else if($notify->action_type==7){
						$comment_id= strstr("$event_id",",",true);
						$event_id= substr("$event_id", strpos("$event_id", ",") + 1);
						$table3= 'comments';
						$action='has replyed on a comment';
						$sub_action_type="watch_comment";
					}
				    else if($notify->action_type==8){
						$table= 'videos';
						$action='has liked an event ';
						$sub_action_type="watch_event";
					}
					else if($notify->action_type==9){
						
						if (strpos($event_id, ':') !== false) {
							$notifyMsg =  $event_id;
							$event_id  =  strstr("$notifyMsg",":",true);
							$msg = substr("$notifyMsg", strpos("$notifyMsg", ":") + 1);
					    }
					    
						$table2= 'product';
						$action='has endorsed a product to you';
						$sub_action_type="watch_product";
					}
					else if($notify->action_type==10){
						$table= 'videos';
						$action='has tagged you in an event';
						$sub_action_type="watch_event";
					}
					else{
						$table4= 'Unknown';
					    $action='Unknown';
					}
					
					
					if($table){
						$eventName= $this->common_model->eventName($table,$event_id);
					    $event_name=$eventName->title;
						$table="";
					}
					if($table1){
						$eventName= $this->common_model->followUser($event_id);
						$event_name=$eventName->first_name;
						$table1="";
					}
					if($table2){
						$magento_product = $this->bwt_magento->get_product($event_id);
						$event_name=$magento_product->getName();
						$table2="";
					}
					if($table3){
						$eventName= $this->common_model->eventName($table3,$comment_id);
					    $event_name=$eventName->comment;
						$table3="";
						$comment_id="";
					}
					
					$profile_photo= "";
					if(!empty($notify->profile_image)){
						$profile_photo= base_url().$notify->profile_image;
					}
					
					
					
		            $createdTime= $this->date_to_time($notify->from_user_id,$notify->created_on);
		
					
				    $created_at = $this->humanTiming($notify->from_user_id,$createdTime);
					$notifyData[]=array(
					'id'=> $notify->id,
					'username'=> $notify->first_name,
					'user_id'=> $notify->user_id,
					'action_type'=> $action,
					'profile_pic'=> $profile_photo,
					'sub_action_type'=>$sub_action_type,
					'sub_action_name'=>$event_name,
					'sub_action_id'=>$event_id,
					'sub_action_message'=>$msg,
					'is_read'=>($notify->is_view)?"Yes":"No",
					'created_on'=>$created_at." ago" 
					);
				}
				
				$unread_notifications = $this->common_model->count_unread_notification($user_id);
				$response = array(
				'status' => 'success',
				'notificationData'=>$notifyData,
				'unread_notifications'=>$unread_notifications
			    );
			}
			else{
				$response = array(
				'status' => 'success',
				'notificationData'=>$notifications,
                                'unread_notifications'=>0
			    );
			}
	    }
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	
	
	public function read_notification(){
		
		$notification_id = $this->input->get_post('notification_id');
		
		if( ! $notification_id ) { 
			$response = array(
				'status' => 'error'	
			);
		} 
		else {
		    $notificationData= array(
		    'is_view'=>1
		    );
		
		    $this->common_model->update_notification($notificationData,$notification_id);
		    $response = array(
				'status' => 'success'	
			);
	    }
		
        $this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));		
	} 
	
	public function event_details() {
	
		$video_id = $this->input->get_post('event_id');
		
		if( ! $video_id ) { 
			$response = array(
				'status' => 'error'	
			);
		} 
		else {
			
			$this->load->model('videos/videos_model');
			
			$event = $this->videos_model->get_video('id', $video_id, $kaltura_user_id='', $active=1);
			$media = array();
		    if($event) {
				$kaltura_video_id = $event->kaltura_video_id;
				$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);
				
				$duration = $video['result']->objects[0]->duration;
				$views = $video['result']->objects[0]->views;
				$posted_by = $event->first_name.' '.$event->last_name;
				$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
				$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
				$dataUrl=$this->videoDataUrl($kaltura_video_id);
				
				
				$video_frames = $this->ws_model->get_video_frames($video_id);
				$frames = array();
			
			   if( ! empty($video_frames)) {

					foreach($video_frames as $frame) {
				
						$frameDataUrl = "";
						if($frame->media_type == 'VIDEO'){
							$frm_kaltura_video_id = $frame->kaltura_video_id;
							$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
							$frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
						}
				
						$magento_product = $this->bwt_magento->get_product($frame->product_id);
						if($frame->media_type=="VIDEO"){
							$frame_media_type=111;
						}
						else if($frame->media_type=="IMAGE"){
							$frame_media_type=110;
						}
						$frames[] = array(
							'frame_id' => $frame->id,
							'user_id' => $frame->user_id,
							'product_id' => $frame->product_id,
							'product_image' => $magento_product->getImageUrl(),
							'frame_title' => $frame->title,
							'frame_start_time' => $frame->start_time,
							'frame_end_time' => $frame->end_time,
							'frame_media_type' => $frame_media_type,
							'frame_kmedia_id' => $frame->frame_kaltura_media_id,
							'frame_thumbnail_url' => $frame->thumbnail_url,
							'frame_image_url' => $frame->image_url,
							'frame_data_url' => $frameDataUrl,
							'frame_product_url' => $magento_product->getProductUrl(),
							'frame_resource_type' =>"internet",
							
							
						);
					}
				}
				
				if($event->event_type=="VIDEO"){
							$event_media_type=111;
						}
				else if($event->event_type=="IMAGE"){
							$event_media_type=110;
				}
				/* Tagged users on a events*/
				
				$tagged_user_id=array();
				$taggedUserData = $this->ws_model->get_tagged_users_on_event($video_id);
				
				$profile_pic="";
				if(!empty($taggedUserData)){
					
					foreach($taggedUserData as $taggedUser){
					if(!empty($taggedUser->profile_image)){
						$profile_pic=base_url().$taggedUser->profile_image;
					}
					$tagged_user_id[]=array(
					'name'=>$taggedUser->first_name,
					'user_id'=>$taggedUser->tagged_user_id,
					'profile_pic'=>$profile_pic,
					
					);
					}
					
				}
				$user_id = $event->user_id;
				$num_of_comments= $this->videos_model->num_of_comments_video($video_id);
				$countLike = $this->ws_model->count_like($video_id);
				
				$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);
				
				$liked = $this->ws_model->is_liked($user_id, $video_id);
				if($liked){
					$is_liked = 'Yes';
				} else {
					$is_liked = 'No';
				}
				
				$media = array(
				'data_url' => $dataUrl,
				'title' => $event->title,
				'frames' => $frames,
				'tagged_user_id'=>$tagged_user_id,
				'user_id'=>$user_id,
				'num_of_comments'=>$num_of_comments,
				'is_liked'=>$is_liked,
				'website_video_url'=>$websiteVideoUrl,
				'count_like'=>$countLike
				
			    );
			}
			$response = array(
				'status' => 'success',
				'media' => $media
			);
		   
		  
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function comment_details(){
		
	    $comment_id = $this->input->get_post('comment_id');
		
		if( !$comment_id ) { 
			$response = array(
				'status' => 'error'	
			);
		} 
		else {
			
		    $video_id = $this->ws_model->get_video_id($comment_id);
			$this->load->model('videos/videos_model');
			
			$event = $this->videos_model->get_video('id', $video_id, $kaltura_user_id='', $active=1);
			$media = array();
		    if($event) {
				$kaltura_video_id = $event->kaltura_video_id;
				$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);
				
				$duration = $video['result']->objects[0]->duration;
				$views = $video['result']->objects[0]->views;
				$thumbnailUrl = $video['result']->objects[0]->thumbnailUrl;
				$dataUrl = $video['result']->objects[0]->dataUrl;
				
				$posted_by = $event->first_name.' '.$event->last_name;
				
				
				$video_frames = $this->ws_model->get_video_frames($video_id);
				$frames = array();
			
			    if( ! empty($video_frames)) {

					foreach($video_frames as $frame) {
				
						$frameDataUrl = "";
						if($frame->media_type == 'VIDEO'){
							$frm_kaltura_video_id = $frame->kaltura_video_id;
							$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
							
							$frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
						}
				
						$magento_product = $this->bwt_magento->get_product($frame->product_id);
						if($frame->media_type=="VIDEO"){
							$frame_media_type=111;
						}
						else if($frame->media_type=="IMAGE"){
							$frame_media_type=110;
						}
						$frames[] = array(
							'frame_id' => $frame->id,
							'product_id' => $frame->product_id,
							'product_image' => $magento_product->getImageUrl(),
							'frame_title' => $frame->title,
							'frame_start_time' => $frame->start_time,
							'frame_end_time' => $frame->end_time,
							'frame_media_type' => $frame_media_type,
							'frame_kmedia_id' => $frame->frame_kaltura_media_id,
							'frame_thumbnail_url' => $frame->thumbnail_url,
							'frame_image_url' => $frame->image_url,
							'frame_data_url' => $frameDataUrl,
							'frame_product_url' => $magento_product->getProductUrl(),
							'frame_resource_type' =>"internet",
							
							
						);
					}
				}
				
				if($event->event_type=="VIDEO"){
							$event_media_type=111;
						}
				else if($event->event_type=="IMAGE"){
							$event_media_type=110;
				}
				/* Tagged users on a events*/
				
				$tagged_user_id=array();
				$taggedUserData = $this->ws_model->get_tagged_users_on_event($video_id);
				
				$profile_pic="";
				if(!empty($taggedUserData)){
					
					foreach($taggedUserData as $taggedUser){
					if(!empty($taggedUser->profile_image)){
						$profile_pic=base_url().$taggedUser->profile_image;
					}
					$tagged_user_id[]=array(
					'name'=>$taggedUser->first_name,
					'user_id'=>$taggedUser->tagged_user_id,
					'profile_pic'=>$profile_pic,
					
					);
					}
					
				}
				$user_id = $event->user_id;
				$num_of_comments= $this->videos_model->num_of_comments_video($video_id);
				$countLike = $this->ws_model->count_like($video_id);
				
				$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);
				
				$liked = $this->ws_model->is_liked($user_id, $video_id);
				if($liked){
					$is_liked = 'Yes';
				} else {
					$is_liked = 'No';
				}
				
				$media = array(
				'data_url' => $dataUrl,
				'title' => $event->title,
				'frames' => $frames,
				'tagged_user_id'=>$tagged_user_id,
				'user_id'=>$user_id,
				'num_of_comments'=>$num_of_comments,
				'is_liked'=>$is_liked,
				'website_video_url'=>$websiteVideoUrl,
				'count_like'=>$countLike
				
			    );
			}
			$response = array(
				'status' => 'success',
				'media' => $media
			);
		  
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
    }		
	
	public function product_details()
	{
		$product_id = $this->input->get_post('product_id', true);
        if(!$product_id){
			$response = array(
				'status' => 'error'	
			);
		}
		else {
			$this->load->library('bwt_magento');
			$products = $this->bwt_magento->get_product($product_id);
			$response=array();
			if(!empty($products)){
					$response= array(
						'product_id' => $products->getId(),
						'product_name' => $products->getName(),
						'product_url' => $products->getProductUrl(),
						'product_image' => $products->getImageUrl(),
						'product_price'=>number_format($products->getPrice(),2)
					);
				
			}
			
			
			
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function update_token(){
		$user_id = $this->security->xss_clean($this->input->get_post('user_id'));
		$device_id = $this->security->xss_clean($this->input->get_post('device_id'));
		$reg_token = $this->security->xss_clean($this->input->get_post('reg_token'));
		
		if(!$user_id OR !$device_id){
			$response = array(
			'status' => 'error'	
			);
		}
        else{
			$deviceSession= array(
			'user_id'=>$user_id,
			'device_id'=>$device_id,
			'reg_token'=>$reg_token,
			'created_on'=>$this->dateTime($user_id)
			);
			
			$this->common_model->update_device_session($user_id,$device_id,$deviceSession);
			
			$response = array(
			'status' => 'success'	
			);
	    }
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	function remove_user(){
		
		$user_id = $this->input->get_post('user_id', true);
        if(!$user_id){
			$response = array(
				'status' => 'error'	
			);
		}
		else {
			$this->ws_model->remove_user($user_id);
			$response = array(
				'status' => 'success'	
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
		
	}
	
	function send_fcm_notify($reg_id, $message,$sub_action_id,$sub_action_type,$title,$user_id) {
	
		define("GOOGLE_API_KEY", "AIzaSyDZUBjZfX9vxRZHZguJIWCZH8LEXtqCfcs");
		define("GOOGLE_GCM_URL", "https://fcm.googleapis.com/fcm/send");
	
        $fields = array(
			'to'  			=> $reg_id ,
			'priority'		=> "high",
            'notification'  => array( 
			"title"         =>$title, 
			"body"          =>$message
			),
			'data'			=> array("message" =>$message,"sub_action_id" =>$sub_action_id,"sub_action_type" =>$sub_action_type,"user_id" =>$user_id,),
        );
		
        $headers = array(
			GOOGLE_GCM_URL,
			'Content-Type: application/json',
            'Authorization: key=' . GOOGLE_API_KEY 
        );
		
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, GOOGLE_GCM_URL);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
		
        $result = curl_exec($ch);
        if ($result === FALSE) {
            die('Problem occurred: ' . curl_error($ch));
        }
		
        curl_close($ch);
		$decode_result= json_decode($result);
		if(!empty($decode_result)){
		    if($decode_result->failure==1){
			  foreach($decode_result->results as $res){
			  $err=$res->error;
			  }
			  if($err=="InvalidRegistration"){
				$this->ws_model->remove_session($user_id,$reg_id);
			  }
		    }
		}
    }
	
   
    function humanTiming($user_id,$created_on)
	{
		
		$currentTime= $this->currentTime($user_id);
		$createdTime= $created_on;
		$time = $currentTime - $createdTime; // to get the time since that moment
		$time = ($time<1)? 1 : $time;
		$tokens = array (
			31536000 => 'year',
			2592000 => 'month',
			604800 => 'week',
			86400 => 'day',
			3600 => 'hour',
			60 => 'minute',
			1 => 'second'
		);

		foreach ($tokens as $unit => $text) {
			if ($time < $unit) continue;
			$numberOfUnits = floor($time / $unit);
			return $numberOfUnits.' '.$text.(($numberOfUnits>1)?'s':'');
		}

    }
   
    function delete_frame(){
	   
		
		$frame_id = $this->input->get_post('frame_id', true);
        if(!$frame_id){
			$response = array(
				'status' => 'error'	
			);
		}
		else {
			$notification= $this->ws_model->check_notification($frame_id);
			
			if($notification){
				$this->ws_model->remove_notification($frame_id);
			}

			$frame= $this->ws_model->get_frame_info($frame_id);
			if($frame->frame_kaltura_media_id){
				$entryId = $frame->frame_kaltura_media_id;
				$media = array(
					'user' => $frame->frame_kaltura_user_id,
					'access_type' => 'USER',
				);
				$this->kaltura->delete($media, $entryId);
			}

			$this->ws_model->remove_frame($frame_id);
			 $this->ws_model->removeFrameTagStreams($frame_id);
			$response = array(
				'status' => 'success'	
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	   
    }
	
	function delete_event(){
		$event_id = $this->input->get_post('event_id', true);
        if(!$event_id){
			$response = array(
				'status' => 'error'	
			);
		}
		else {
			$this->load->model('videos/videos_model');
			$video_frames = $this->videos_model->get_video_frames($event_id);
			if( ! empty($video_frames)) {
				foreach($video_frames as $frame) {
					
					$this->ws_model->removeEventFrameNotification($frame->id);
					$this->ws_model->removeEventFrame($frame->id);
					
					if($frame->frame_kaltura_media_id){
						$entryId = $frame->frame_kaltura_media_id;
						$media = array(
							'user' => $frame->frame_kaltura_user_id,
							'access_type' => 'USER',
						);
						$this->kaltura->delete($media, $entryId);
					}
		
				}
			}
			$event_info= $this->videos_model->get_event($event_id);
			//print_r($event_info);
			if(!empty($event_info->kaltura_video_id)){
				$entryId = $event_info->kaltura_video_id;
				$media = array(
					'user' => $event_info->kaltura_user_id,
					'access_type' => 'USER',
				);
				$this->kaltura->delete($media, $entryId);
			}
					
			$this->ws_model->removeEventNotification($event_id);
			$this->ws_model->remove_event($event_id);
			$this->ws_model->remove_video_likes($event_id);
			$this->ws_model->remove_video_comments($event_id);
            $this->ws_model->remove_favourite_video($event_id);	
			 $this->ws_model->remove_tag_streams($event_id);	
			$response = array(
				'status' => 'success'	
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	   
    }
	
	public function frame_details(){
		
		$frame_id = $this->input->get_post('frame_id', true);
		$user_id = $this->input->get_post('user_id', true);
		if(!$frame_id){
			$response= array(
				'status' => 'error'
			);
		} 
		else {
			
			    $frame = $this->ws_model->get_frame_details($frame_id);
			    $frameDetails = array();
			 
			    if( ! empty($frame)) {
			
				   $kaltura_user = $this->ion_auth->get_username($frame->user_id);
				
					$kaltura_video_id = $frame->kaltura_video_id;
					$video = $this->kaltura->videolist($access_type='USER', $kaltura_user, $page='', $kaltura_video_id, $categoriesId = TRUE);
					$duration = $video['result']->objects[0]->duration;
					$views = $video['result']->objects[0]->views;
					
					$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
	                $thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
	                $dataUrl=$this->videoDataUrl($kaltura_video_id);
				
					// Event frames
					$video_id = $frame->video_id;
					$video_frames = $this->ws_model->get_video_frames($video_id);
					$frames = array();
					
					if( ! empty($video_frames)) {

						foreach($video_frames as $vframe) {
							
							$frameDataUrl = "";
							if($vframe->media_type == 'VIDEO'){
								$frm_kaltura_video_id = $vframe->kaltura_video_id;
								$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
								$frameDataUrl= $this->videoDataUrl($frm_kaltura_video_id);
							}
					        if($vframe->media_type=="VIDEO"){
								$frame_media_type=111;
							}
							else if($vframe->media_type=="IMAGE"){
								$frame_media_type=110;
							}
							$magento_product = $this->bwt_magento->get_product($vframe->product_id);
						
							$frames[] = array(
								'frame_id' => $vframe->id,
								'user_id' => $vframe->user_id,
								'product_id' => $vframe->product_id,
		                        'product_image' => $magento_product->getImageUrl(),
								'frame_title' => $vframe->title,
								'frame_start_time' => $vframe->start_time,
								'frame_end_time' => $vframe->end_time,
								'frame_media_type' => $frame_media_type,
								'frame_kmedia_id' => $vframe->frame_kaltura_media_id,
								'frame_thumbnail_url' => $vframe->thumbnail_url,
								'frame_image_url' => $vframe->image_url,
								'frame_data_url' => $frameDataUrl,
								'frame_product_url' => $magento_product->getProductUrl(),
		                        'frame_resource_type' =>"internet",
							);
						}
					}
			        if($frame->media_type=="VIDEO"){
								$frame_media_type=111;
					}
					else if($frame->media_type=="IMAGE"){
								$frame_media_type=110;
					}
					/* Tagged users on a events*/
					
					$tagged_user_id=array();
					$taggedUserData = $this->ws_model->get_tagged_users_on_event($frame->video_id);
					$num_of_comments= $this->videos_model->num_of_comments_video($frame->video_id);
					$countLike = $this->ws_model->count_like($video_id);
					
					$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);
					
					$liked = $this->ws_model->is_liked($user_id, $video_id);
					if($liked){
						$is_liked = 'Yes';
					} else {
						$is_liked = 'No';
					}
					
					$profile_pic="";
					if(!empty($taggedUserData)){
						
						foreach($taggedUserData as $taggedUser){
						if(!empty($taggedUser->profile_image)){
							$profile_pic=base_url().$taggedUser->profile_image;
						}
						$tagged_user_id[]=array(
						'name'=>$taggedUser->first_name,
						'user_id'=>$taggedUser->tagged_user_id,
						'profile_pic'=>$profile_pic,
						
						);
						}
						
					}
			       
					$event_user_id=$this->ws_model->get_event_userId($video_id);
					$magentoProduct = $this->bwt_magento->get_product($frame->product_id);
					$frameDetails = array(
						'frame_id' => $frame->id,
						'event_user_id'=>$event_user_id,
						'video_id' => $frame->video_id,
						'title' => $frame->title,
						'kaltura_video_id' => $frame->kaltura_video_id,
						'product_id' => $frame->product_id,
						'product_url'=>$magentoProduct->getProductUrl(),
						'product_image_url'=>$magentoProduct->getImageUrl(),
						'media_type' => $frame_media_type, 
						'frame_kaltura_media_id' => $frame->frame_kaltura_media_id, 
						'name' => $frame->first_name, 
						'thumbnail_url' => $frame->thumbnail_url,
						'image_url' => $frame->image_url,
						'data_url' => $dataUrl,
						'event_title' => $frame->event_title,
						'event_description' => $frame->event_description,
						'created_on' => $this->humanTiming($frame->user_id,$frame->created_on),
						'frames' => $frames,
						'tagged_user_id' => $tagged_user_id,
						'num_of_comments'=>$num_of_comments,
						'count_like' => $countLike,
						'user_id' => $frame->user_id,
						'website_video_url' => $websiteVideoUrl,
						'is_liked' => $is_liked,
					);
				}
				
				$response = array(
					'status' => 'success',
					'framedata' => $frameDetails
				);
			
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	
		
	}
	
	/* function videoDataUrl($kaltura_video_id){
		$dataUrl="http://cdnapi.kaltura.com/p/2253591/sp/225359100/playManifest/entryId/".$kaltura_video_id."/flavorIds/301991,487041,487051,487061,4870571,4870581,4870591/format/applehttp/protocol/http/a.m3u8";
		return $dataUrl;
	} */
	
	function videoDataUrl($kaltura_video_id){
		$dataUrl="http://14.tagframe.com/p/101/sp/10100/playManifest/entryId/".$kaltura_video_id."/flavorIds/0,2,3,4,5,6,7/format/applehttp/protocol/http/a.m3u8";
		return $dataUrl;
	}
	
	function videoThumbnailUrl($videoThumbnailUrl){
		$thumbnailUrl = $videoThumbnailUrl."/width/600/height/300";
		return $thumbnailUrl;
	}
	
	function kaltura_test(){
		    $media = array(
				'user' => "Alex",
				'access_type' => 'USER',
				'media_type' => 'VIDEO',
				'title' => "Testing",
				'description' => "Kaltura Testing",
				'tags' => "Testing",
				'media_path' => "media/video.mp4"
			);
			$kvideo = $this->kaltura->uploadfile($media);
			echo "<pre>";print_r($kvideo);
			
	}	
    /* Bloked features */
	
	public function blocked(){
		$user_id= $this->input->get_post('user_id');
		$logged_user_id= $this->input->get_post('logged_user_id');
		$blocked= $this->input->get_post('blocked');
		if(!$user_id OR !$logged_user_id){
			$response= array(
				'status' => 'error'
			);
		} 
		else {
			/* operation 1=for block,0=Unblock */
			if($blocked==1){
				$data1=array(
				'is_blocked'=>$blocked,
				'request'=>0
				);
				$data2=array(
				'is_blocked'=>0,
				'request'=>0
				);
				
				$if_friend= $this->ws_model->check_friend($user_id,$logged_user_id);
				if(!$if_friend){
					$friendData1=array(
					'user_from'=>$logged_user_id,
					'user_to'=>$user_id,
					'request'=>0,
					'is_blocked'=>1,
					'created_on'=>$this->currentTime($logged_user_id)
					);
					
					$friendData2=array(
					'user_from'=>$user_id,
					'user_to'=>$logged_user_id,
					'request'=>0,
					'is_blocked'=>0,
					'created_on'=>$this->currentTime($logged_user_id)
					);
					$this->ws_model->insert_friend($friendData1);
					$this->ws_model->insert_friend($friendData2);
				}
				else{
					$this->ws_model->blocked_user_from($user_id,$logged_user_id,$data1);
					$this->ws_model->blocked_user_to($user_id,$logged_user_id,$data2);
					
					$this->ws_model->delete_followers_notification($user_id, $logged_user_id);
					$this->ws_model->delete_following_notification($user_id, $logged_user_id);
				
				}
			}
            if($blocked==0){
				$this->ws_model->delete_user_from($user_id, $logged_user_id);
				$this->ws_model->delete_user_to($user_id, $logged_user_id);
				
			}
			
			$response= array(
				'status' => 'success'
			);
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
  
 
}
