<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');



class Tagstream extends MY_Controller {

	

	var $data;

	

	function __construct()

    {

        parent::__construct();

		

		 if (!$this->ion_auth->logged_in()){

			redirect('auth/login');

        }

		

		$this->load->model('tagstream_model');

		$this->load->model('ws_model');

		$this->load->model('videos/videos_model');

		$this->load->model('friends/friends_model');

    }



	

	public function index(){

		

		

		//$next_records = $this->input->get_post('next_records', true);

		//$this->template->set_title('Tagstream');

		

		

		//$this->template->add_js('modules/notifications.js');

		//$this->template->add_js('modules/videos.js');

		

		$user_id = $this->ion_auth->get_user_id();

		$user = $this->ion_auth->user($user_id)->row();

		$this->data['user'] = $user;

		

		$this->data['followers'] = Modules::run('Tagstream/followers');

		$this->data['following'] = Modules::run('Tagstream/following');

		$this->data['tagstream']=array();

		$limit = 5;

		$offset = 0;

		$this->data['records'] = $limit + $offset;

		

		

		if( ! $user_id) {

			redirect('auth/login');

		}

		else {

		

            $userList=array();			

			$friendList= $this->ws_model->get_freinds($user_id);

			$userList[]=$user_id;

			if(!empty($friendList)){

				foreach($friendList as $row){

					$userList[]=$row->user_to;

				}	

			}

				$tagstreams= $this->ws_model->get_tag_streams($userList, $limit, $offset);

				

				$this->data['totalRows']= $this->tagstream_model->get_total_tag_streams($userList);

				

				$records = array();

				

				if( ! empty($tagstreams))

				{

						foreach($tagstreams as $tagstream)

						{ 

						

							

							if($tagstream->profile_image){

									$profile_picture = base_url().$tagstream->profile_image;

							} 

							else {

								$profile_picture = base_url().'assets/img/no-image.png';

							}

							$name = $tagstream->first_name;

							$created_at = $this->humanTiming($tagstream->user_id,$tagstream->created_on);

							

								if($tagstream->action_type == 'add') {

									$streamtype = "added a new event";

								}

								if($tagstream->action_type == 'edit') {

									$streamtype = "updated event";

								} 

								

								if($tagstream->action_type == 'comment') {

									$streamtype = "commented on event";

								} 

								if($tagstream->action_type == 'subscribe') {

									$streamtype = "subscribed event";

								} 

								if($tagstream->action_type == 'favourite') {

									$streamtype = "liked event";

								} 

								if($tagstream->action_type == 'buyproduct') {

									$streamtype = "purchased product";

								} 

								$videoData= $this->ws_model->get_video_info($tagstream->event_id);

								

								$kaltura_video_id = "";

								$thumbnailUrl = "";

								$dataUrl = "";

								$product = "";

								$product_url = "";

								$product_image = "";

								$product_name = "";

								$title="";

								$description="";

								$product_id="";

								$countLike="";

								$websiteVideoUrl="";

								

								$frame_media_type="";

								$frame_media_url="";

								if($tagstream->action_type != 'buyproduct') 

								{

									$kaltura_video_id = $videoData->kaltura_video_id;

									$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);

									

									$thumbUrl = $video['result']->objects[0]->thumbnailUrl;

									$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);

									$dataUrl=$this->videoDataUrl($kaltura_video_id);

										

									

									$title = $videoData->title;

									$description = $videoData->description;

								} 

								else {

									$product = $this->bwt_magento->get_product($tagstream->product_id);

									$product_url = $product->getProductUrl();

									$product_image = $product->getImageUrl();

									$product_name = $product->getName();

								}

								

								$video_id = $videoData->id;

								$countLike = $this->ws_model->count_like($video_id);

								

								$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);

								

								$liked = $this->ws_model->is_liked($user_id, $video_id);

								if($liked){

									$is_liked = 'Yes';

								} else {

									$is_liked = 'No';

								}

								

								// Event frames

								$video_frames = $this->videos_model->get_video_frames($video_id);

								$num_of_comments= $this->videos_model->num_of_comments_video($video_id);

								$frames = array();

								$myframes =array();

								$otherframes =array();

								

								if( ! empty($video_frames)) {

									

									foreach($video_frames as $frame) {

										//echo "<pre>";print_r($frame);

										$frameDataUrl = "";

										if($frame->media_type == 'VIDEO'){

											$frm_kaltura_video_id = $frame->kaltura_video_id;

											$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);

											$frameDataUrl = $frmvideo['result']->objects[0]->dataUrl;

											

											$frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);

									

										}

										if($frame->media_type=="VIDEO"){

											$frame_media_type=111;

										}

										else if($frame->media_type=="IMAGE"){

											$frame_media_type=110;

										}

										$magento_product = $this->bwt_magento->get_product($frame->product_id);

										$user_name = $this->ion_auth->get_username($frame->user_id);

										

										$ms= $frame->end_time-$frame->start_time;

				                        $s = intval($ms/1000);

										$frameTime = sprintf('%02d:%02d:%02d', ($s / 3600), ($s / 60 % 60), $s % 60);

                                       

										

										$frames[] = array(

											'frame_id' => $frame->id,

											'user_id' => $frame->user_id,

											'user_name' => $user_name,

											'product_id' => $frame->product_id,

											'product_image' => $magento_product->getImageUrl(),

											'frame_title' => $frame->title,

											'frame_start_time' => $frame->start_time,

											'frame_end_time' => $frame->end_time,

											'frame_media_type' => $frame_media_type,

											'frame_kmedia_id' => $frame->frame_kaltura_media_id,

											'frame_thumbnail_url' => $frame->thumbnail_url,

											'frame_image_url' => $frame->image_url,

											'frame_data_url' => $frameDataUrl,

											'frame_product_url' => $magento_product->getProductUrl(),

											'frame_resource_type' =>"internet",

											'frame_time'=>$frameTime

										);

										if($user_id==$frame->user_id){

											

											$myframes[] = array(

												'frame_id' => $frame->id,

												'user_id' => $frame->user_id,

												'user_name' => $user_name,

												'product_id' => $frame->product_id,

												'product_image' => $magento_product->getImageUrl(),

												'frame_title' => $frame->title,

												'frame_start_time' => $frame->start_time,

												'frame_end_time' => $frame->end_time,

												'frame_media_type' => $frame_media_type,

												'frame_kmedia_id' => $frame->frame_kaltura_media_id,

												'frame_thumbnail_url' => $frame->thumbnail_url,

												'frame_image_url' => $frame->image_url,

												'frame_data_url' => $frameDataUrl,

												'frame_product_url' => $magento_product->getProductUrl(),

												'frame_resource_type' =>"internet",

												'frame_time'=>$frameTime

											);

										}

										else{

											$otherframes[] = array(

												'frame_id' => $frame->id,

												'user_id' => $frame->user_id,

												'user_name' => $user_name,

												'product_id' => $frame->product_id,

												'product_image' => $magento_product->getImageUrl(),

												'frame_title' => $frame->title,

												'frame_start_time' => $frame->start_time,

												'frame_end_time' => $frame->end_time,

												'frame_media_type' => $frame_media_type,

												'frame_kmedia_id' => $frame->frame_kaltura_media_id,

												'frame_thumbnail_url' => $frame->thumbnail_url,

												'frame_image_url' => $frame->image_url,

												'frame_data_url' => $frameDataUrl,

												'frame_product_url' => $magento_product->getProductUrl(),

												'frame_resource_type' =>"internet",

												'frame_time'=>$frameTime

											);

										}								

									}

								}

								/* Tagged users on a events*/

								$frame_media_type="";

								$tagged_user_id=array();

								$taggedUserData = $this->ws_model->get_tagged_users_on_event($video_id);

								

								$profile_pic= base_url().'media/default-user.png';

								if(!empty($taggedUserData)){

									

									foreach($taggedUserData as $taggedUser){

									if(!empty($taggedUser->profile_image)){

										$profile_pic=base_url().$taggedUser->profile_image;

									}

									$tagged_user_id[]=array(

									'name'=>$taggedUser->first_name,

									'user_id'=>$taggedUser->tagged_user_id,

									'profile_pic'=>$profile_pic,

									

									);

									}

									

								}

								

								$kvideoInfo = $this->kaltura->kvideo($kaltura_video_id);

								

								$records[] = array(

									'action_type' => $tagstream->action_type,

									'name' => $tagstream->first_name,

									'profile_picture' => $profile_picture,

									'event_user_id'=>$tagstream->user_id,

									'streamtype' => $streamtype,

									'created_at' => $created_at." ago",

									'thumbnail' => $thumbnailUrl,

									'data_url' => $dataUrl,

									'kvideo_id' => $kaltura_video_id,

									'event_id' => $tagstream->event_id,

									'video_duration' => $kvideoInfo->msDuration,

									'title' => $title,

									'description' => $description,

									'product_id' => $product_id,

									'media_type' => $frame_media_type,

									'frame_media_url' => $frame_media_url,

									'product_image' => $product_image,

									'product_name' => $product_name,

									'count_like' => $countLike,

									'website_video_url' => $websiteVideoUrl,

									'is_liked' => $is_liked,

									'frames' => $frames,

									'tagged_user_id' => $tagged_user_id,

									'num_of_comments'=>$num_of_comments,

									'my_frames'=>$myframes,

									'other_frames'=>$otherframes

								);

								//echo "<pre>";print_r($frames);

						}

						

					

			}

			$this->data['tagstream'] = $records;

			$this->data['user_id']= $user_id;

			$this->template->set_title('Tagstream');

		    

		    $this->template->load_view('tagstream/index',$this->data);

		}

		

		

	}

	

	public function ajaxlist() {

		$this->data['user_id']=$user_id = $this->ion_auth->get_user_id();

		$records = $this->input->post('records');

		

		$limit = 5;

		$offset = $records;

		

		$this->data['records'] = $limit + $offset;

		$userList=array();			

		$friendList= $this->ws_model->get_freinds($user_id);

		$userList[]=$user_id;

		if(!empty($friendList)){

			foreach($friendList as $row){

				$userList[]=$row->user_to;

			}	

		}

		$tagstreams= $this->ws_model->get_tag_streams($userList, $limit, $offset);

		$records = array();

		

			if( ! empty($tagstreams))

			{

					foreach($tagstreams as $tagstream)

					{ 

						

							

							if($tagstream->profile_image){

									$profile_picture = base_url().$tagstream->profile_image;

							} 

							else {

								$profile_picture = base_url().'assets/img/no-image.png';

							}

							$name = $tagstream->first_name;

							$created_at = $this->humanTiming($tagstream->user_id,$tagstream->created_on);

							

								if($tagstream->action_type == 'add') {

									$streamtype = "added a new event";

								}

								if($tagstream->action_type == 'edit') {

									$streamtype = "updated event";

								} 

								

								if($tagstream->action_type == 'comment') {

									$streamtype = "commented on event";

								} 

								if($tagstream->action_type == 'subscribe') {

									$streamtype = "subscribed event";

								} 

								if($tagstream->action_type == 'favourite') {

									$streamtype = "liked event";

								} 

								if($tagstream->action_type == 'buyproduct') {

									$streamtype = "purchased product";

								} 

								$videoData= $this->ws_model->get_video_info($tagstream->event_id);

								

								$kaltura_video_id = "";

								$thumbnailUrl = "";

								$dataUrl = "";

								$product = "";

								$product_url = "";

								$product_image = "";

								$product_name = "";

								$title="";

								$description="";

								$product_id="";

								$countLike="";

								$websiteVideoUrl="";

								

								$frame_media_type="";

								$frame_media_url="";

								if($tagstream->action_type != 'buyproduct') 

								{

									$kaltura_video_id = $videoData->kaltura_video_id;

									$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);

									

									$thumbUrl = $video['result']->objects[0]->thumbnailUrl;

									$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);

									$dataUrl=$this->videoDataUrl($kaltura_video_id);

										

									

									$title = $videoData->title;

									$description = $videoData->description;

								} 

								else {

									$product = $this->bwt_magento->get_product($tagstream->product_id);

									$product_url = $product->getProductUrl();

									$product_image = $product->getImageUrl();

									$product_name = $product->getName();

								}

								

								$video_id = $videoData->id;

								$countLike = $this->ws_model->count_like($video_id);

								

								$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);

								

								$liked = $this->ws_model->is_liked($user_id, $video_id);

								if($liked){

									$is_liked = 'Yes';

								} else {

									$is_liked = 'No';

								}

								

								// Event frames

								$video_frames = $this->videos_model->get_video_frames($video_id);

								$num_of_comments= $this->videos_model->num_of_comments_video($video_id);

								$frames = array();

								$myframes =array();

								$otherframes =array();

								

								if( ! empty($video_frames)) {

									

									foreach($video_frames as $frame) {

										

										$frameDataUrl = "";

										if($frame->media_type == 'VIDEO'){

											$frm_kaltura_video_id = $frame->kaltura_video_id;

											$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);

											$frameDataUrl = $frmvideo['result']->objects[0]->dataUrl;

											

											$frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);

									

										}

										if($frame->media_type=="VIDEO"){

											$frame_media_type=111;

										}

										else if($frame->media_type=="IMAGE"){

											$frame_media_type=110;

										}

										$magento_product = $this->bwt_magento->get_product($frame->product_id);

										$user_name = $this->ion_auth->get_username($frame->user_id);

										$frames[] = array(

											'frame_id' => $frame->id,

											'user_id' => $frame->user_id,

											'user_name' => $user_name,

											'product_id' => $frame->product_id,

											'product_image' => $magento_product->getImageUrl(),

											'frame_title' => $frame->title,

											'frame_start_time' => $frame->start_time,

											'frame_end_time' => $frame->end_time,

											'frame_media_type' => $frame_media_type,

											'frame_kmedia_id' => $frame->frame_kaltura_media_id,

											'frame_thumbnail_url' => $frame->thumbnail_url,

											'frame_image_url' => $frame->image_url,

											'frame_data_url' => $frameDataUrl,

											'frame_product_url' => $magento_product->getProductUrl(),

											'frame_resource_type' =>"internet",

										);

										if($user_id==$frame->user_id){

											

											$myframes[] = array(

												'frame_id' => $frame->id,

												'user_id' => $frame->user_id,

												'user_name' => $user_name,

												'product_id' => $frame->product_id,

												'product_image' => $magento_product->getImageUrl(),

												'frame_title' => $frame->title,

												'frame_start_time' => $frame->start_time,

												'frame_end_time' => $frame->end_time,

												'frame_media_type' => $frame_media_type,

												'frame_kmedia_id' => $frame->frame_kaltura_media_id,

												'frame_thumbnail_url' => $frame->thumbnail_url,

												'frame_image_url' => $frame->image_url,

												'frame_data_url' => $frameDataUrl,

												'frame_product_url' => $magento_product->getProductUrl(),

												'frame_resource_type' =>"internet",

											);

										}

										else{

											$otherframes[] = array(

												'frame_id' => $frame->id,

												'user_id' => $frame->user_id,

												'user_name' => $user_name,

												'product_id' => $frame->product_id,

												'product_image' => $magento_product->getImageUrl(),

												'frame_title' => $frame->title,

												'frame_start_time' => $frame->start_time,

												'frame_end_time' => $frame->end_time,

												'frame_media_type' => $frame_media_type,

												'frame_kmedia_id' => $frame->frame_kaltura_media_id,

												'frame_thumbnail_url' => $frame->thumbnail_url,

												'frame_image_url' => $frame->image_url,

												'frame_data_url' => $frameDataUrl,

												'frame_product_url' => $magento_product->getProductUrl(),

												'frame_resource_type' =>"internet",

											);

										}								

									}

								}

								/* Tagged users on a events*/

								$frame_media_type="";

								$tagged_user_id=array();

								$taggedUserData = $this->ws_model->get_tagged_users_on_event($video_id);

								

								$profile_pic= base_url().'media/default-user.png';

								if(!empty($taggedUserData)){

									

									foreach($taggedUserData as $taggedUser){

									if(!empty($taggedUser->profile_image)){

										$profile_pic=base_url().$taggedUser->profile_image;

									}

									$tagged_user_id[]=array(

									'name'=>$taggedUser->first_name,

									'user_id'=>$taggedUser->tagged_user_id,

									'profile_pic'=>$profile_pic,

									

									);

									}

									

								}

								

								$kvideoInfo = $this->kaltura->kvideo($kaltura_video_id);

								

								$records[] = array(

									'action_type' => $tagstream->action_type,

									'name' => $tagstream->first_name,

									'profile_picture' => $profile_picture,

									'event_user_id'=>$tagstream->user_id,

									'streamtype' => $streamtype,

									'created_at' => $created_at." ago",

									'thumbnail' => $thumbnailUrl,

									'data_url' => $dataUrl,

									'kvideo_id' => $kaltura_video_id,

									'event_id' => $tagstream->event_id,

									'video_duration' => $kvideoInfo->msDuration,

									'title' => $title,

									'description' => $description,

									'product_id' => $product_id,

									'media_type' => $frame_media_type,

									'frame_media_url' => $frame_media_url,

									'product_image' => $product_image,

									'product_name' => $product_name,

									'count_like' => $countLike,

									'website_video_url' => $websiteVideoUrl,

									'is_liked' => $is_liked,

									'frames' => $frames,

									'tagged_user_id' => $tagged_user_id,

									'num_of_comments'=>$num_of_comments,

									'my_frames'=>$myframes,

									'other_frames'=>$otherframes

								);

								//echo "<pre>";print_r($frames);

						}

						

					

		}

		

		$this->data['tagstream'] = $records;

			

		$this->load->view('tagstream/ajaxlist', $this->data);

	}

	

	function humanTiming($user_id,$created_on)

	{

		

		$currentTime= $this->currentTime($user_id);

		$createdTime= $created_on;

		$time = $currentTime - $createdTime; // to get the time since that moment

		$time = ($time<1)? 1 : $time;

		$tokens = array (

			31536000 => 'year',

			2592000 => 'month',

			604800 => 'week',

			86400 => 'day',

			3600 => 'hour',

			60 => 'minute',

			1 => 'second'

		);



		foreach ($tokens as $unit => $text) {

			if ($time < $unit) continue;

			$numberOfUnits = floor($time / $unit);

			return $numberOfUnits.' '.$text.(($numberOfUnits>1)?'s':'');

		}



    }

	public function dateTime($user_id){

		$get_time_zone= $this->ws_model->get_time_zone($user_id);

		if($get_time_zone){

			 $time_zone=$get_time_zone->time_zone;

			date_default_timezone_set($time_zone);

		}

		

		$date= date('Y-m-d H:i:s');

		return $date;

	}

	

	public function setTimeZone($user_id,$time){

		$get_time_zone= $this->ws_model->get_time_zone($user_id);

		if($get_time_zone){

			 $time_zone=$get_time_zone->time_zone;

			date_default_timezone_set($time_zone);

		}

		

		//$datetime= date('F d, Y G:i A', $time);

		$datetime= date('F d, Y g:i A', $time);

		return $datetime;

	}

	

	function currentTime($user_id){

		$currentTime= strtotime($this->dateTime($user_id));

		return $currentTime;

	}

	

	function date_to_time($user_id,$date){

		$get_time_zone= $this->ws_model->get_time_zone($user_id);

		if($get_time_zone){

			 $time_zone=$get_time_zone->time_zone;

			date_default_timezone_set($time_zone);

		}

		

		$date_to_time= strtotime($date);

		return $date_to_time;

		

	}

	function videoThumbnailUrl($videoThumbnailUrl){

		$thumbnailUrl = $videoThumbnailUrl."/width/600/height/300";

		return $thumbnailUrl;

	}

	function videoDataUrl($kaltura_video_id){

		$dataUrl="http://14.tagframe.com/p/101/sp/10100/playManifest/entryId/".$kaltura_video_id."/flavorIds/0,2,3,4,5,6,7/format/applehttp/protocol/http/a.m3u8";

		return $dataUrl;

	}

	

	

	function followers()

    {

        $this->template->set_title('Followers');

		

		$user_id = $this->ion_auth->get_user_id();

		$this->data['user_id'] = $user_id;

		

		$this->data['followers'] = $this->friends_model->get_followers($user_id);

		

       $this->load->view('tagstream/followers', $this->data);

    }

	

	function following()

    {

        $this->template->set_title('Following');

		

		$user_id = $this->ion_auth->get_user_id();

		$this->data['user_id'] = $user_id;

		

		$this->data['following'] = $this->friends_model->get_following($user_id);

		

       $this->load->view('tagstream/following', $this->data);

    }

	

   /*  function index()

    {

		$this->template->set_title('Tagstream');

		$this->template->add_js('modules/notifications.js');

		

		$user_id = $this->ion_auth->get_user_id();

		

		$this->data['recent_friends'] = Modules::run('friends/recent_friends');

		$this->data['recent_messages'] = Modules::run('messages/recent_messages');

		

		$limit = 5;

		$offset = 0;

		$this->data['records'] = $limit + $offset;

		$this->data['totalRows'] = $this->notifications_model->count_notifications($user_id);

		$this->data['notifications'] = $this->notifications_model->get_notifications($user_id, $limit, $offset);

	

		$this->template->load_view('notifications/index',$this->data);

    }

	

	public function ajaxlist() {

		$user_id = $this->ion_auth->get_user_id();

		$records = $this->input->post('records');

		

		$limit = 5;

		$offset = $records;

		

		$this->data['records'] = $limit + $offset;

		

		$this->data['notifications'] = $this->notifications_model->get_notifications($user_id, $limit, $offset);

		$this->load->view('notifications/ajaxlist', $this->data);

	} */

}		

