<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');





class Users_model extends CI_Model {





	function count_all_users($user_id){


		$this->db->select('count(id) as num');


		$this->db->where('id !=', $user_id);


		$this->db->where('active', 1);


		$query = $this->db->get('users');


		return $query->row()->num;


	}


	


    function get_all_users($user_id, $limit, $offset){


		$this->db->where('id !=', $user_id);


		$this->db->where('active', 1);


		$this->db->limit($limit, $offset);


		$query = $this->db->get('users');


		return $query->result();


	}


	


	function delete_user($id){


		$this->db->where('id', $id);


		$this->db->update('users', array('active' => 0));


	}


	


	function restore_user($id){


		$this->db->where('id', $id);


		$this->db->update('users', array('active' => 1));


	}


	


	function get_user_detail($id){


		$this->db->where('id', $id);


		$query = $this->db->get('users');


		return $query->row();


	}


	


	function get_all_country(){


		$query = $this->db->get('countries');


		return $query->result();


	}


	


	function get_all_state(){


		$this->db->select('id, state');


		$query = $this->db->get('states');


		return $query->result();


	}


	


	function count_all_trash_users($user_id){


		$this->db->select('count(id) as num');


		$this->db->where('id !=', $user_id);


		$this->db->where('active', 0);


		$query = $this->db->get('users');


		return $query->row()->num;


	}


	


	function get_all_trash_users($user_id, $limit, $offset){


		$this->db->where('id !=', $user_id);


		$this->db->where('active', 0);


		$this->db->limit($limit, $offset);


		$query = $this->db->get('users');


		return $query->result();


	}


	


	function delete_user_permanent($id){


		$this->db->where('id', $id);


		$this->db->delete('users');


		return true;


	}


	


	function get_user_details($id){


		$this->db->where('id', $id);


		$query = $this->db->get('users');


		return $query->row();


	}


	


	function update_user($id, $data){


		$this->db->where('id', $id);


		$this->db->update('users', $data);


	}


	


	//----------------- Ankit


	function get_user_edit_details($id){


		$this->db->select('us.*,cty.country,sta.state');


		$this->db->from('users us');


		$this->db->join('countries cty', 'cty.id = us.country_id', 'left');


		$this->db->join('states sta', 'us.state = sta.id', 'left');


		$this->db->where('us.id', $id);


		$query = $this->db->get();


		return $query->row();


	}


	


	function get_user_view_details($id){


		$this->db->select('us.*,cty.country,sta.state');


		$this->db->from('users us');


		$this->db->join('countries cty', 'cty.id = us.country_id', 'left');


		$this->db->join('states sta', 'us.state = sta.id', 'left');


		$this->db->where('us.id', $id);


		$query = $this->db->get();


		return $query->row();


	}


}