<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');





class Videos_model extends CI_Model {





    function __construct() {


		parent::__construct();


	}


	


	function insert($table, $data){


		$this->db->insert($table, $data);


		return $this->db->insert_id();;


	}


	


	function get_videos($user_id){


		$this->db->where('user_id', $user_id);


		$this->db->where_not_in('video_duration', array(0));


		$this->db->where('active', 1);


		$query = $this->db->get('videos');


		return $query->result();


	}


	


	public function get_video($field, $where, $kaltura_user_id, $active=NULL) {


		if($active != '') {


			$this->db->where('active', $active);


		}


		if($kaltura_user_id) {


			$this->db->where('kaltura_user_id', $kaltura_user_id);


		}


		$this->db->where($field, $where);


		$query = $this->db->get('videos');


		return $query->row();


	}


	


	public function get_latest_video() {


		$this->db->where('active', 1);


		$this->db->order_by('created_on', 'desc');


		$this->db->limit(1);


		$query = $this->db->get('videos');


		return $query->row();


	}





	public function check_video_like($user_id, $video_id){


		$this->db->where('user_id', $user_id);


		$this->db->where('video_id', $video_id);


		$query = $this->db->get('videos_likes'); 


		if($query->num_rows() == 1) {


			return TRUE;


		} 


		else {


			return FALSE;


		}


	} 


	


	public function get_all_like_count($video_id){


		$this->db->select('count(id) as num');


		$this->db->where('video_id', $video_id);


		$query = $this->db->get('videos_likes');


		return $query->row()->num;


	}


	


	public function remove_video_like($user_id, $video_id) {


		$this->db->where('user_id', $user_id);


		$this->db->where('video_id', $video_id);


		$this->db->delete('videos_likes'); 


	}


	


	public function check_favourite($user_id, $video_id){


		$this->db->where('user_id', $user_id);


		$this->db->where('video_id', $video_id);


		$query = $this->db->get('favourite_video');


		if($query->num_rows() == 1){


			return TRUE;


		} else {


			return FALSE;


		}


	}


	


	public function check_subscribe($user_id, $video_id){


		$this->db->where('user_id', $user_id);


		$this->db->where('video_id', $video_id);


		$query = $this->db->get('subscribe_video');


		if($query->num_rows() == 1){


			return TRUE;


		} else {


			return FALSE;


		}


	}


	


	public function insert_comment($data){


		$this->db->insert('comments', $data);


		return $this->db->insert_id();


	}


	


	public function get_video_comments($video_id, $parent_id){


		$this->db->select('c.*, u.username, u.profile_image');


		$this->db->from('comments c');


		$this->db->join('users u', 'u.id=c.user_id', 'left');


		$this->db->where('c.status', 1);


		$this->db->where('c.video_id', $video_id);


		$this->db->where('c.parent_id', $parent_id);


		$this->db->order_by('c.created_on', 'desc');


		//$this->db->limit($limit, $offset);


		$query = $this->db->get();


		return $query->result();


	}


	public function num_of_comments_video($video_id=null){


		$this->db->where('video_id',$video_id);


		$this->db->where('status',1);


		$this->db->where('parent_id',0);


		return $this->db->count_all_results('comments');


	}


	


	public function get_video_comment($id) {


		$this->db->select('c.*, u.username, u.profile_image');


		$this->db->from('comments c');


		$this->db->join('users u', 'u.id=c.user_id', 'left');


		$this->db->where('c.status', 1);


		$this->db->where('c.id', $id);


		$query = $this->db->get();


		return $query->row();


	}


	


	public function get_video_frames($video_id) {


		$this->db->where('video_id', $video_id);


		$query = $this->db->get('ads_frame');


		return $query->result();


	}


	


	function delete_event($user_id, $id){


		$this->db->where('user_id', $user_id);


		$this->db->where('id', $id);


		$this->db->delete('videos');


	}


	


	function update_event($user_id, $id, $video_data){


		$this->db->where('user_id', $user_id);


		$this->db->where('id', $id);


		$this->db->update('videos', $video_data);


		return true;


	}


	


	public function get_subscribed_videos($user_id) {


		$this->db->select('v.*');


		$this->db->from('subscribe_video sv');


		$this->db->join('videos v', 'v.id=sv.video_id');


		$this->db->where('sv.user_id', $user_id);


		$query = $this->db->get();


		return $query->result();


	}


	


	public function unsubscribe($user_id, $video_id) {


		$this->db->where('user_id', $user_id);


		$this->db->where('video_id', $video_id);


		$this->db->delete('subscribe_video');


	}


	


	public function get_favourite_videos($user_id) {


		$this->db->select('v.*');


		$this->db->from('favourite_video fv');


		$this->db->join('videos v', 'v.id=fv.video_id');


		$this->db->where('fv.user_id', $user_id);


		$query = $this->db->get();


		return $query->result();


	}


	


	public function delete_favourite($user_id, $video_id) {


		$this->db->where('user_id', $user_id);


		$this->db->where('video_id', $video_id);


		$this->db->delete('favourite_video');


	}


}