<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');





class Webservice extends MX_Controller {





	function __construct() {


		parent::__construct();


		$this->load->model('ws_model');		


		$this->load->library('ion_auth');


	}


	


	public function login() {


		


		$username = $this->security->xss_clean($this->input->get_post('username'));


		$password = $this->security->xss_clean($this->input->get_post('password'));


		


		//$username = 'jack5';


		//$password = 123456;





		$result = $this->ion_auth->login($username, $password, $remember=FALSE);


		


		if( ! $result) {


			$response = array(


				'status' => 'Invalid username or password.'.$username.$password


			);


		} 


		else {


			$user_id = $this->ion_auth_model->get_user_id('username', $username);


			


			$user = $this->ion_auth->user($user_id)->row();


			


			$profile_image = "";


			if($user->profile_image) {


				$profile_image = base_url().$user->profile_image;


			}


			


			$date_of_birth = '';


			if($user->date_of_birth !== 0) {


				$date_of_birth = date('Y-m-d', strtotime($user->date_of_birth));


			}


			


			


			$events = $this->ws_model->count_user_events($user_id);


			$frames = $this->ws_model->count_user_frames($user_id);


			$number_of_following = $this->ws_model->count_following($user_id);


			$number_of_followers = $this->ws_model->count_followers($user_id);


			


			$userdata = array(


				'user_id' => $user->id,


				'username' => $user->username,


				'email' => $user->email,


				'first_name' => $user->first_name,


				'last_name' => $user->last_name,


				'address' => $user->address,


				'city' => $user->city,


				'state' => $user->state,


				'country' => $user->country,


				'date_of_birth' => $date_of_birth,


				'phone' => $user->phone,


				'profile_image' => $profile_image,


				'total_events' => $events,


				'description' => $user->description,


				'total_frames' => COUNT($frames),


				'number_of_following' => $number_of_following,


				'number_of_followers' => $number_of_followers,


			);


			


			$response = array(


				'status' => 'success',


				'userinfo' => $userdata


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function signup() {


		


		$username = $this->input->get_post('username');


		$password = $this->input->get_post('password');


		$email = $this->input->get_post('email');


	


		$first_name = $this->input->get_post('first_name');


		$zipcode = $this->input->get_post('zipcode');


		$phone = $this->input->get_post('phone');


		


		/*$username = "jack22";


		$password = "123456";


		$email = "jack22@tagframe.com";


		$first_name = "jack";


		$zipcode = 201301;


		$phone = 9999999999;*/


		


		if(!$username && !$password && !$email) {


			$response = array(


				'status' => 'error'


			);


		}


		else if($this->ion_auth_model->email_check($email)) { 


			$response = array(


				'status' => $email.' email id already registered.'


			);


		} 


		else if($this->ion_auth_model->username_check($username)) {


			$response = array(


				'status' => $username.' username id already registered.'


			);


		}


		else {


		


			$additional_data = array(


				'first_name' => $first_name,


				'zipcode' => $zipcode,


				'phone' => $phone


			);


		


			$user_id = $this->ion_auth->register($username, $password, $email, $additional_data);


			


			//Signup on magento


			$this->load->library('bwt_magento');


			$fields = array(


				'email' => strtolower($email),


				'password' => $password,


				'first_name' => $first_name,


                'last_name'  => NULL


			);


			$this->bwt_magento->signup($fields);


			


			$user = $this->ion_auth->user($user_id)->row();


			


			$date_of_birth = '';


			if($user->date_of_birth !== 0) {


				$date_of_birth = date('Y-m-d', strtotime($user->date_of_birth));


			}


			


			$userdata = array(


				'user_id' => $user_id,


				'username' => $username,


				'email' => $email,


				'first_name' => $first_name,


				'last_name' => $last_name,


				'address' => $address,


				'city' => $city,


				'state' => $state,


				'country' => $user->country,


				'date_of_birth' => $date_of_birth,


				'description' => $user->description,


				'phone' => $phone


			);


			


			$response = array(


				'status' => 'success',


				'userinfo' => $userdata


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function countries() {


		$countries = $this->ws_model->get_countries();


		


		if(empty($countries)) {


			$response = array(


				'status' => 'no records'


			);


		} 


		else {


			$response = array(


				'status' => 'success',


				'countries' => $countries


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function forgot_password() {


		$email = $this->input->get_post('email');


		


		if(!$email) {


			$response = array(


				'status' => 'error'


			);


		}


		else if($this->ion_auth_model->email_check($email)) { 


			$response = array(


				'status' => $email.' not exist user records.'


			);


		}


		else { 


			$identity = $this->ion_auth->where('email', strtolower($email))->users()->row();


			 //run the forgotten password method to email an activation code to the user


            $forgotten = $this->ion_auth->forgotten_password($identity->{$this->config->item('identity', 'ion_auth')});


			


			if ($forgotten)


            { 


				$response = array(


					'status' => 'success'


				);


			} 


			else {


				$response = array(


					'status' => 'error'


				);


			}


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	function changepassword()


    {


		$user_id = $this->input->get_post('user_id');


		$old_password = $this->input->get_post('old_password');


		$new_password = $this->input->get_post('new_password');


		


		if( ! $user_id) {


			$response = array(


				'status' => 'error'


			);


		}


		else {


			$user = $this->ion_auth->user($user_id)->row();


			


			if(empty($user)) { 


				$response = array(


					'status' => 'user does not exist'


				);


			}


			else { 


				$identity = $user->email;


				


				$change = $this->ion_auth->change_password($identity, $old_password, $new_password);





				if ($change){


					$response = array(


						'status' => 'success'


					);


				}


				else {


					$response = array(


						'status' => 'old password does not match.'


					);


				}


			}


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


    }


	


	public function upload_profile_photo() {


		$user_id = $this->input->get_post('user_id');


		if( ! $user_id) {


			$response = array(


				'status' => 'error'


			);


		} 


		else { 


			$upload_path = 'media/user_image/';


			$config['upload_path'] = $upload_path;


			$config['allowed_types'] = 'gif|jpg|jpeg|png';


			$config['max_size'] = '5120';


			$config['encrypt_name'] = TRUE;


			


			$this->load->library('upload', $config);


			


			if( ! $this->upload->do_upload('profile_photo')) {


				$response = array(


					'status' => $this->upload->display_errors()


				);


			} 


			else {


				


				$description = $this->input->get_post('description');


				


				$user = $this->ion_auth->user($user_id)->row();


				if($user->profile_image && file_exists($user->profile_image)) {


					unlink($user->profile_image);


				}


				


				$imagedata = $this->upload->data();


				$profile_photo = $upload_path.$imagedata['file_name'];


				


				$userdata = array(


					'profile_image' => $profile_photo,


					'description' => $description,


				);


				


				$this->ion_auth->update($user_id, $userdata);


				


				$response = array(


					'status' => 'success'


				);


			}


		}


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function user_events() {


	


		$user_id = $this->input->get_post('user_id', true);


		$next_records = $this->input->get_post('next_records', true);


		


		if( ! $user_id) {


			$response['events'] = array(


				'status' => 'error'


			);


		} 


		else {


			


			if( ! $next_records) {


				$next_records = 0;


			}


			$limit = 10;


			$offset = $next_records;


			 


			$events = $this->ws_model->get_user_events($user_id, $limit, $offset); 


		


			$number_of_event = $this->ws_model->count_user_events($user_id);


			 


			$eventlist = array();


			


			if( ! empty($events)) {


			


				$kaltura_user = $this->ion_auth->get_username($user_id);


			


				foreach($events as $event) {


				


					$kaltura_video_id = $event->kaltura_video_id;


					$video = $this->kaltura->videolist($access_type='USER', $kaltura_user, $page='', $kaltura_video_id, $categoriesId = TRUE);


					


					$duration = $video['result']->objects[0]->duration;


					$views = $video['result']->objects[0]->views;


					$thumbnailUrl = $video['result']->objects[0]->thumbnailUrl;


					$dataUrl = $video['result']->objects[0]->dataUrl;


					


					$this->load->helper('datetime');


					$eventlist[] = array(


						'event_id' => $event->id,


						'kuser_id' => $event->kaltura_user_id,


						'kvideo_id' => $event->kaltura_video_id,


						'type' => $event->type,


						'event_type' => $event->event_type,


						'title' => $event->title,


						'description' => $event->description,


						'tags' => $event->tag_keyword,


						'is_paid' => $event->is_paid,


						'price' => $event->price,


						'duration' => $duration,


						'views' => $views,


						'thumbnail' => ($event->event_type == 'VIDEO')?$thumbnailUrl:$event->thumbnail_url,


						'data_url' => $dataUrl,


						'number_of_event' => $number_of_event,


						'created_on' => humanTiming($event->created_on) 


					);


				}


				


				$response['events'] = array(


					'status' => 'success',


					'eventdata' => $eventlist


				);


			}


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function user_frames() {


	


		$user_id = $this->input->get_post('user_id', true);


		$next_records = $this->input->get_post('next_records', true);


		


		if( ! $user_id) {


			$response['frames'] = array(


				'status' => 'error'


			);


		} 


		else {


			


			if( ! $next_records) {


				$next_records = 0;


			}


			$limit = 10;


			$offset = $next_records;


			 


			$frames = $this->ws_model->get_user_frames($user_id, $limit, $offset);


			


			$frames = $this->ws_model->count_user_frames($user_id);


			$number_of_frames = COUNT($frames);


			


			$framelist = array();


			 


			if( ! empty($frames)) {


			


				$kaltura_user = $this->ion_auth->get_username($user_id);


			


				foreach($frames as $frame) {


					 


					$kaltura_video_id = $event->kaltura_video_id;


					$video = $this->kaltura->videolist($access_type='USER', $kaltura_user, $page='', $kaltura_video_id, $categoriesId = TRUE);


					


					$duration = $video['result']->objects[0]->duration;


					$views = $video['result']->objects[0]->views;


					$thumbnailUrl = $video['result']->objects[0]->thumbnailUrl;


					$dataUrl = $video['result']->objects[0]->dataUrl;


					


					$this->load->helper('datetime');


					$framelist[] = array(


						'frame_id' => $frame->id,


						'video_id' => $frame->video_id,


						'title' => $frame->title,


						'kaltura_video_id' => $frame->kaltura_video_id,


						'product_id' => $frame->product_id,


						'media_type' => $frame->media_type, 


						'frame_kaltura_media_id' => $frame->frame_kaltura_media_id, 


						'name' => $frame->first_name, 


						'thumbnail_url' => $frame->thumbnail_url,


						'data_url' => $dataUrl,


						'number_of_frames' => $number_of_frames,


						'created_on' => humanTiming($frame->created_on) 


					);


				}


				


				$response['frames'] = array(


					'status' => 'success',


					'framedata' => $framelist


				);


			}


			 


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	


	public function favourites() {


	


		$user_id = $this->input->get_post('user_id', true);


		


		if( ! $user_id) {


			$response['favourites'] = array(


				'status' => 'error'


			);


		} 


		else {


			


			$favourites = $this->ws_model->get_user_favourites($user_id);


			


			$eventlist = array();


			


			if( ! empty($favourites)) {


			


				foreach($favourites as $event) {


				


					$kaltura_video_id = $event->kaltura_video_id;


					$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);


					


					$duration = $video['result']->objects[0]->duration;


					$views = $video['result']->objects[0]->views;


					$thumbnailUrl = $video['result']->objects[0]->thumbnailUrl;


					$dataUrl = $video['result']->objects[0]->dataUrl;


					


					$posted_by = $event->first_name.' '.$event->last_name;


					


					$eventlist[] = array(


						'event_id' => $event->id,


						'kuser_id' => $event->kaltura_user_id,


						'kvideo_id' => $event->kaltura_video_id,


						'type' => $event->type,


						'title' => $event->title,


						'description' => $event->description,


						'tags' => $event->tag_keyword,


						'is_paid' => $event->is_paid,


						'price' => $event->price,


						'duration' => $duration,


						'views' => $views,


						'thumbnail' => $thumbnailUrl,


						'data_url' => $dataUrl,


						'posted_by' => $posted_by


					);


				}


				


				$response['favourites'] = array(


					'status' => 'success',


					'favouritedata' => $eventlist


				);


			}


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function subscribes() {


	


		$user_id = $this->input->get_post('user_id', true);


		


		if( ! $user_id) {


			$response['subscribes'] = array(


				'status' => 'error'


			);


		} 


		else {


			


			$subscribes = $this->ws_model->get_user_subscribed_event($user_id);


			


			$eventlist = array();


			


			if( ! empty($subscribes)) {


				foreach($subscribes as $event) {


				


					$kaltura_video_id = $event->kaltura_video_id;


					$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);


					


					$duration = $video['result']->objects[0]->duration;


					$views = $video['result']->objects[0]->views;


					$thumbnailUrl = $video['result']->objects[0]->thumbnailUrl;


					$dataUrl = $video['result']->objects[0]->dataUrl;


					


					$posted_by = $event->first_name.' '.$event->last_name;


					


					$eventlist[] = array(


						'event_id' => $event->id,


						'kuser_id' => $event->kaltura_user_id,


						'kvideo_id' => $event->kaltura_video_id,


						'type' => $event->type,


						'title' => $event->title,


						'description' => $event->description,


						'tags' => $event->tag_keyword,


						'is_paid' => $event->is_paid,


						'price' => $event->price,


						'duration' => $duration,


						'views' => $views,


						'thumbnail' => $thumbnailUrl,


						'data_url' => $dataUrl,


						'posted_by' => $posted_by


					);


				}


				


				$response['subscribes'] = array(


					'status' => 'success',


					'subscribedata' => $eventlist


				);


			}


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function user_products() {


		


		$user_id = $this->input->get_post('user_id', true);


	


		if( ! $user_id ) { 


			$response['products'] = array(


				'status' => 'error'


			);


		} 


		else {


			$user = $this->ion_auth->user($user_id)->row();


			$email = $user->email;


			


			$productlist = array();


			


			$collection = $this->bwt_magento->get_seller_products($email);


	


			foreach($collection as $products){


			


				$productlist[] = array(


					'product_id' => $products->getEntityId(),


					'product_name' => $products->getName(),


					'product_image' => $products->getImageUrl(),


					'product_url' => $products->getProductUrl(),


				);


			}


			


			$response['products'] = array(


				'status' => 'success',


				'product_data' => $productlist


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function event() {


	


		$event_id = $this->input->get_post('event_id');


		


		if( ! $event_id ) { 


			$response['event'] = array(


				'status' => 'error'	


			);


		} 


		else {


			


			$this->load->model('videos/videos_model');


			


			$event = $this->videos_model->get_video('id', $event_id, $kaltura_user_id='', $active=1);


			


			$kaltura_video_id = $event->kaltura_video_id;


			$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);


			


			$duration = $video['result']->objects[0]->duration;


			$views = $video['result']->objects[0]->views;


			$thumbnailUrl = $video['result']->objects[0]->thumbnailUrl;


			$dataUrl = $video['result']->objects[0]->dataUrl;


			


			$posted_by = $event->first_name.' '.$event->last_name;


			


			$video_frames = $this->videos_model->get_video_frames($event_id);


			$frames = array();


			if( ! empty($video_frames)) {





				foreach($video_frames as $frame) {


			


					$magento_product = $this->bwt_magento->get_product($frame->product_id);


				


					$frames[] = array(


						'frame_id' => $frame->id,


						'frame_start_time' => $frame->start_time,


						'frame_end_time' => $frame->end_time,


						'frame_media_type' => $frame->media_type,


						'frame_kmedia_id' => $frame->frame_kaltura_media_id,


						'frame_thumbnail_url' => $frame->thumbnail_url,


						'frame_product_url' => $magento_product->getProductUrl(),


					);


				}


			}


			


			$media = array(


				'event_id' => $event->id,


				'kuser_id' => $event->kaltura_user_id,


				'kvideo_id' => $event->kaltura_video_id,


				'type' => $event->type,


				'title' => $event->title,


				'description' => $event->description,


				'tags' => $event->tag_keyword,


				'is_paid' => $event->is_paid,


				'price' => $event->price,


				'duration' => $duration,


				'views' => $views,


				'thumbnail' => $thumbnailUrl,


				'data_url' => $dataUrl,


				'posted_by' => $posted_by,


				'frames' => $frames


			);


			


			$response['event'] = array(


				'status' => 'success',


				'media' => $media


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	function upload_video(){


	


		$this->load->model('videos/videos_model');


		


		$user_id = $this->input->get_post('user_id');


		


		$access_type = $this->input->get_post('access_type');


		$title = $this->input->get_post('title');


		$description = $this->input->get_post('description');


		$tags_keywords = $this->input->get_post('tags_keywords');


		$price = $this->input->get_post('price');


		$is_paid = $this->input->get_post('is_paid');


		$duration = $this->input->get_post('duration');


		


		$event_type = $this->input->get_post('event_type');


		


		$tagged_user_id = $this->input->get_post('tagged_user_id', true);


	


		if ( ! $user_id) {


			$response['upload'] = array(


				'status' => 'error',


			);


		} 


		else {


		


			if($event_type == 'VIDEO'){


				


				$this->load->library('upload');


				


				$uploadPath = 'media/temp/';


				$config['upload_path'] = $uploadPath;


				$config['allowed_types'] = 'mp4|mov';


				$config['encrypt_name'] = TRUE;


				$this->upload->initialize($config);


				


				if( ! $this->upload->do_upload('media_file')) {


					$response['upload'] = array(


						'status' => $this->upload->display_errors()


					);


				} 


				else {


					$upload_data = $this->upload->data();


					$videofile = $upload_data['file_name'];


					


					$kaltura_user = $this->ion_auth->get_username($user_id);


					$video_file_path = $uploadPath.$videofile;


					


					// Kaltura data


					$media = array(


						'user' => $kaltura_user,


						'access_type' => 'USER',


						'media_type' => 'VIDEO',


						'title' => $title,


						'description' => $description,


						'tags' => $tags_keywords,


						'media_path' => $video_file_path


					);


					


					$kvideo = $this->kaltura->uploadfile($media);


					


					$video_data =array(


						'user_id' => $user_id,


						'kaltura_user_id' => $kvideo->userId,


						'kaltura_video_id' => $kvideo->id,


						'type' => $access_type,


						'title' => $title,


						'event_type' => 'VIDEO',


						'description' => $description,


						'tag_keyword' => $tags_keywords,


						'video_duration' => $duration,


						'price' => $price,


						'is_paid' => $is_paid,


						'created_on' =>  time()


					);


					


					$video_id = $this->videos_model->insert('videos', $video_data);


					


					// Tag Streams


					$streams_data = array(


						'user_id' => $user_id,


						'stream_type' => 'event',


						'event_id' => $video_id,


						'action_type' => 'add',


						'created_on' => time() 


					);


					$this->common_model->insert_tag_stream($streams_data);


					


					// Tagged User


					if($tagged_user_id) 


					{


						$taggedUserData = array(


							'user_id' => $user_id,


							'tagged_user_id' => $tagged_user_id,


							'video_id' => $video_id,


							'type' => 'Event',


							'created_at' => date('Y-m-d H:i:s', time())


						);


						


						$this->ws_model->insert_tagged_user($taggedUserData);


					}


					


					unlink($video_file_path);


					


					$response['upload'] = array(


						'status' => 'success',


						'event_id' => $video_id


					);


				}


			}





			if($event_type == 'IMAGE'){


				


				$this->load->library('upload');


				


				$uploadPath = 'media/temp/';


				$config['upload_path'] = $uploadPath;


				$config['allowed_types'] = 'gif|jpg|jpeg|png';


				$config['encrypt_name'] = TRUE;


				$this->upload->initialize($config);


				


				if( ! $this->upload->do_upload('media_file')) {


					$response['upload'] = array(


						'status' => $this->upload->display_errors()


					);


				} 


				else {


					$upload_data = $this->upload->data();


					$imgfile = $upload_data['file_name'];


					


					$kaltura_user = $this->ion_auth->get_username($user_id);


					$imgfile_path = $uploadPath.$imgfile;


					


					// Kaltura data


					$media = array(


						'user' => $kaltura_user,


						'access_type' => 'USER',


						'media_type' => 'IMAGE',


						'title' => $title,


						'description' => $description,


						'tags' => $tags_keywords,


						'media_path' => $imgfile_path


					);


					


					$kvideo = $this->kaltura->uploadfile($media);


					


					$image_data =array(


						'user_id' => $user_id,


						'kaltura_user_id' => $kvideo->userId,  


						'kaltura_video_id' => $kvideo->id, 


						'type' => $access_type,


						'title' => $title,


						'event_type' => 'IMAGE',


						'thumbnail_url' => $kvideo->thumbnailUrl,


						'description' => $description,


						'tag_keyword' => $tags_keywords, 


						'price' => $price,


						'is_paid' => $is_paid,


						'created_on' =>  time()


					);


					


					$video_id = $this->videos_model->insert('videos', $image_data);


					


					// Tag Streams


					$streams_data = array(


						'user_id' => $user_id,


						'stream_type' => 'event',


						'event_id' => $video_id,


						'action_type' => 'add',


						'created_on' => time() 


					);


					$this->common_model->insert_tag_stream($streams_data);


					


					// Tagged User


					if($tagged_user_id) 


					{


						$taggedUserData = array(


							'user_id' => $user_id,


							'tagged_user_id' => $tagged_user_id,


							'video_id' => $video_id,


							'type' => 'Event',


							'created_at' => date('Y-m-d H:i:s', time())


						);


						


						$this->ws_model->insert_tagged_user($taggedUserData);


					}


					


					unlink($imgfile_path);


					


					$response['upload'] = array(


						'status' => 'success',


						'event_id' => $video_id


					);


				}


			}	


				


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function create_frame()


	{


		$user_id = $this->input->get_post('user_id', true);


		$video_id = $this->input->get_post('video_id', true);


		$title = $this->input->get_post('title', true);


		$media_type = $this->input->get_post('media_type', true);


		$product_id = $this->input->get_post('product_id', true);


		$start_time = $this->input->get_post('start_time', true);


		$end_time = $this->input->get_post('end_time', true);


		


		$tagged_user_id = $this->input->get_post('tagged_user_id', true);


		


		if( ! $video_id) {


			$response = array(


				'status' => 'error',


			);


		}


		else {


		


			$framestatus = $this->frameslot($video_id, $start_time, $end_time);


			


			if( ! $framestatus)


			{ 


				$response = array(


					'status' => 'no space available'


				);


			} 


			else{


			


				$this->load->model('frame/frame_model');


				$this->load->model('videos/videos_model');


				


				$this->load->library('upload');


			


				$uploadPath = 'media/temp/';


				$config['upload_path'] = $uploadPath;


				if($media_type == 'IMAGE') {


					$config['allowed_types'] = 'gif|jpg|jpeg|png';


				}


				else {


					$config['allowed_types'] = 'mp4';


				}


				$config['encrypt_name'] = TRUE;


				$this->upload->initialize($config);


				


				if( ! $this->upload->do_upload('media_file')) {


					$response = array(


						'status' => $this->upload->display_errors()


					);


				} 


				else {


				


					$upload_data = $this->upload->data();


					$mediafile = $upload_data['file_name'];


					


					$kaltura_user = $this->ion_auth->get_username($user_id);


					$media_file_path = $uploadPath.$mediafile;


					


					// Kaltura data


					$media = array(


						'user' => $kaltura_user,


						'access_type' => 'USER',


						'media_type' => $media_type,


						'title' => "Advertisement",


						'description' => NULL,


						'tags' => NULL,


						'media_path' => $media_file_path


					);


					$kmedia = $this->kaltura->uploadfile($media, $frame = TRUE);


			


					//Magento product


					$this->load->library('bwt_magento');


					$magento_product = $this->bwt_magento->get_product($product_id);


					


					$frame_data = array(


						'video_id' => $video_id,


						'product_id' => $this->input->get_post('product_id'),


						'title' => $this->input->get_post('title'),


						'start_time' => $start_time,


						'end_time' => $end_time,


						'media_type' => $media_type,


						'frame_kaltura_media_id' => $kmedia->id,


						'frame_kaltura_user_id' => $kmedia->userId,


						'thumbnail_url' => $kmedia->thumbnailUrl,


						'product_url' => $magento_product->getProductUrl(),


						'created_on' => time()


					);


					


					$frame_id = $this->frame_model->insert('ads_frame', $frame_data);


					$video = $this->videos_model->get_video('id', $video_id, $kaltura_user_id=NULL);





					// Tag Streams


					$streams_data = array(


						'user_id' => $user_id,


						'stream_type' => 'event',


						'event_id' => $video_id,


						'action_type' => 'frame',


						'created_on' => time() 


					);


					$this->common_model->insert_tag_stream($streams_data);


					


					// Tagged User


					if($tagged_user_id) 


					{


						$taggedUserData = array(


							'user_id' => $user_id,


							'tagged_user_id' => $tagged_user_id,


							'frame_id' => $frame_id,


							'video_id' => $video_id,


							'type' => 'Frame',


							'created_at' => date('Y-m-d H:i:s', time())


						);


						


						$this->ws_model->insert_tagged_user($taggedUserData);


					}


					


					$response = array(


						'status' => 'success'


					);


					


					unlink($media_file_path);


				}


			}


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function frameslot($video_id, $start_time, $end_time)


	{


		$this->load->model('frame/frame_model');


		


		$this->load->model('videos/videos_model');


		$video = $this->videos_model->get_video('id', $video_id, $kaltura_user_id='', $active=1);


		$video_duration = $video->video_duration;


		


		$frames = $this->frame_model->get_video_frames($video_id);


		


		$noframes = array();


		


		if( ! empty($frames))


		{


			$k = 0;


			foreach($frames as $key => $frame)


			{


				if($key == 0) 


				{


					$nf_start_time = '0';


					$nf_end_time = $frame->start_time;


				} 


				else {


					$nf_start_time = $frames[$key-1]->end_time;


					$nf_end_time = $frames[$key]->start_time;


				}


				


				$noframes[] = array(


					'nfst' => $nf_start_time,


					'nfet' => $nf_end_time


				);


			}


			


			$count = count($frames);


			


			$lastspace = array(


				'nfst' => $frames[$count-1]->end_time,


				'nfet' => $video_duration


			);


		} 


		else{


			$lastspace = array(


				'nfst' => 0,


				'nfet' => $video_duration


			);


		}


		


		array_push($noframes, $lastspace);


		


		foreach($noframes as $nframe)


		{


			$nfst = $nframe['nfst'];


			$nfet = $nframe['nfet'];


			if($start_time >= $nfst && $end_time <= $nfet) {


				$status = true;


				break;


			}


			else{


				$status = false;


			}


		}


		return $status;


	}


	


	public function tagstreams()


	{


		$user_id = $this->input->get_post('user_id', true);


		$next_records = $this->input->get_post('next_records', true);


		


		if( ! $user_id) {


			$response = array(


				'status' => 'error',


			);


		}


		else {


		


			if( ! $next_records) {


				$next_records = 0;


			}


			$limit = 10;


			$offset = $next_records;


			


			$tagstreams = $this->ws_model->get_tag_streams($user_id, $limit, $offset);


			$records = array();


			 


			if( ! empty($tagstreams))


			{


				foreach($tagstreams as $tagstream)


				{ 


					if($tagstream->profile_image){


						$profile_picture = base_url().$tagstream->profile_image;


					} 


					else {


						$profile_picture = base_url().'assets/img/no-image.png';


					}


					


					$name = $tagstream->first_name.' '.$tagstream->last_name;


					if($tagstream->action_type == 'add') {


						$streamtype = "added new event";


					}


					if($tagstream->action_type == 'edit') {


						$streamtype = "updated event";


					} 


					if($tagstream->action_type == 'frame') {


						$streamtype = "added new frame";


					} 


					if($tagstream->action_type == 'comment') {


						$streamtype = "commented on event";


					} 


					if($tagstream->action_type == 'subscribe') {


						$streamtype = "subscribed event";


					} 


					if($tagstream->action_type == 'favourite') {


						$streamtype = "liked event";


					} 


					if($tagstream->action_type == 'buyproduct') {


						$streamtype = "purchased product";


					} 


					


					$this->load->helper('datetime');


					$created_at = humanTiming($tagstream->created_on);


					


					$title = "";


					$kaltura_video_id = "";


					$thumbnailUrl = "";


					$dataUrl = "";


					$product = "";


					$product_url = "";


					$product_image = "";


					$product_name = "";


					


					if($tagstream->action_type != 'buyproduct') 


					{


						$kaltura_video_id = $tagstream->kaltura_video_id;


						$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);


						$thumbnailUrl = $video['result']->objects[0]->thumbnailUrl;


						$dataUrl = $video['result']->objects[0]->dataUrl;


						$title = $tagstream->title;


						$description = $tagstream->description;


					} 


					else {


						$product = $this->bwt_magento->get_product($tagstream->product_id);


						$product_url = $product->getProductUrl();


						$product_image = $product->getImageUrl();


						$product_name = $product->getName();


					}


					


					$records[] = array(


						'action_type' => $tagstream->action_type,


						'name' => $name,


						'profile_picture' => $profile_picture,


						'streamtype' => $streamtype,


						'created_at' => $created_at,


						'thumbnail' => $thumbnailUrl,


						'data_url' => $dataUrl,


						'kvideo_id' => $kaltura_video_id,


						'event_id' => $tagstream->id,


						'title' => $title,


						'description' => $description,


						'product_url' => $product_url,


						'product_image' => $product_image,


						'product_name' => $product_name


					);


				}


				


				$response = array(


					'status' => 'success',


					'records' => $records


				);


			}


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function searching() {


		


		$search = $this->input->get_post('search', true);


	


		if( ! $search ) { 


			$response = array(


				'status' => 'error',


			);


		} 


		else {


		


			$collections = $this->ws_model->get_search_record($search);


			 


			if(!empty($collections))	


			foreach($collections as $collection){


				


				if($collection->profile_image){


					$profile_picture = base_url().$collection->profile_image;


				} 


				else {


					$profile_picture = base_url().'assets/img/no-image.png';


				}


				


				$this->load->helper('datetime');


				$created_at = humanTiming($collection->created_on);


					


				if($collection->action_type != 'buyproduct') 


				{


					$kaltura_video_id = $collection->kaltura_video_id;


					$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);


					$thumbnailUrl = $video['result']->objects[0]->thumbnailUrl;


					$dataUrl = $video['result']->objects[0]->dataUrl;


					$title = $collection->title;


					$description = $collection->description;


				} 	


			  


				$records[] = array( 


					'name' => $collection->first_name.' '.$collection->last_name,


					'profile_picture' => $profile_picture, 


					'created_at' => $created_at,


					'thumbnail' => $thumbnailUrl,


					'data_url' => $dataUrl,


					'kvideo_id' => $kaltura_video_id,


					'event_id' => $collection->id,


					'title' => $title,


					'description' => $description 


				);  


			}


			  


			$response = array(


				'status' => 'success',


				'records' => $records


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function subscribe(){


	


		$user_id = $this->input->get_post('user_id', true);


		$video_id = $this->input->get_post('video_id', true); 


	


		if ( !$video_id && !$user_id ) {


			$response = array(


				'status' => 'error',


			);


		}


		else {


			 


			$result = $this->ws_model->check_subscribe($user_id, $video_id);


			


			if($result){ 


				$message = "Already subscribed.";


				$response = array(


					'status' => 'success',


					'message' => $message 


				);


			} 


			else {


				$subscribe_data = array(


					'user_id'  => $user_id,


					'video_id' => $video_id,


					'created_on' => time()


				);


				


				$subscribe_video_id = $this->ws_model->insert('subscribe_video', $subscribe_data);	


				


				// Tag Streams


				$streams_data = array(


					'user_id' => $user_id,


					'stream_type' => 'event',


					'event_id' => $video_id,


					'action_type' => 'subscribe',


					'created_on' => time() 


				);


				$this->ws_model->insert_tag_stream($streams_data);


				


				$message = "Subscription successfully.";


				$response = array(


					'status' => 'success',


					'message' => $message 


				);


			}


			 


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	  


	public function user_timeline() {


		


		$user_id = $this->input->get_post('user_id', true);


	


		if( ! $user_id ) { 


			$response = array(


				'status' => 'error',


			);


		} 


		else {


			


			$collections = $this->ws_model->get_timelines($user_id);


			


			//echo'<pre>'; print_r($collections);die; 


			


			$kaltura_user = $this->ion_auth->get_username($user_id);


			


				foreach($collections as $event) {


					


					$kaltura_video_id = $event->kaltura_video_id;


					$video = $this->kaltura->videolist($access_type='USER', $kaltura_user, $page='', $kaltura_video_id, $categoriesId = TRUE);


					


					$duration = $video['result']->objects[0]->duration;


					$views = $video['result']->objects[0]->views;


					$thumbnailUrl = $video['result']->objects[0]->thumbnailUrl;


					$dataUrl = $video['result']->objects[0]->dataUrl;


					


					$this->load->helper('datetime');


					


					if(!empty($event->event_id)){


				 


						$timelinedata[] = array(


							'event_id' => $event->event_id,


							'kuser_id' => $event->kaltura_user_id,


							'kvideo_id' => $event->kaltura_video_id,


							'type' => $event->type,


							'title' => $event->title,


							'description' => $event->description,


							'tags' => $event->tag_keyword,


							'is_paid' => $event->is_paid,


							'price' => $event->price,


							'duration' => $duration,


							'views' => $views,


							'thumbnail' => $thumbnailUrl,


							'data_url' => $dataUrl,


							'created_on' => humanTiming($event->event_date) 


						);


					}


					if(!empty($event->frame_id)){


						 


						$timelinedata[] = array(


							'frame_id' => $event->frame_id,


							'video_id' => $event->video_id,


							'product_id' => $event->product_id,


							'media_type' => $event->media_type, 


							'frame_kaltura_media_id' => $event->frame_kaltura_media_id, 


							'thumbnail_url' => $event->thumbnail_url,


							'created_on' => humanTiming($event->frame_date) 


						);


						


					}	


				}


			 


			$response = array(


				'status' => 'success',


				'timelineinfo' => $timelinedata


			);


			


		}


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function like_video(){


		


		$user_id = $this->input->get_post('user_id', true);


		$video_id = $this->input->get_post('video_id', true);


	


		if( !$user_id ) { 


			$response = array(


				'status' => 'error',


			);


		}


		else if(!$video_id)	{


			$response = array(


				'status' => 'error',


			);


		}


		else {


			


			$data = array( 


				'user_id' => $user_id,


				'video_id' => $video_id,


				'created_on' => time()


			);


			


			$this->ws_model->insert('videos_likes', $data);


			


			$count_like = $this->ws_model->get_all_like_count($video_id);


			


			$response = array(


				'status' => 'success',


				'count_like' => $count_like


			);


		}


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response)); 


	}


	


	public function unlike_video(){


		


		$user_id = $this->input->get_post('user_id', true);


		$video_id = $this->input->get_post('video_id', true);


	


		if( !$user_id ) { 


			$response = array(


				'status' => 'error',


			);


		}


		else if(!$video_id)	{


			$response = array(


				'status' => 'error',


			);


		}


		else {


			


			$this->ws_model->remove_video_like($user_id, $video_id);


			$count_like = $this->ws_model->get_all_like_count($video_id);


			


			$response = array(


				'status' => 'success',


				'count_like' => $count_like


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response)); 


			


		


	}


	


	public function testing() {


	


		$apikey = $this->input->get_post('apikey');


		$method = $this->input->get_post('method');


		$data = $this->input->get_post('data');


	


		$name = $this->input->get_post('name');


		$esr_name = $this->input->get_post('esr_name');


		$time = $this->input->get_post('time');


		$date = $this->input->get_post('date');


		


		$media_file = $this->input->get_post('media_file');


		$media_file_esr = $this->input->get_post('media_file_esr');


		 


		if(!$apikey && !$method) {


			$response = array(


				'status' => 'error'


			);


		} 


		else { 


		


		//-----------------------------


		


			$upload_path = 'media/user_image/';


			$config['upload_path'] = $upload_path;


			$config['allowed_types'] = 'gif|jpg|jpeg|png';


			$config['max_size'] = '5120';


			$config['encrypt_name'] = TRUE;


			


			$this->load->library('upload', $config);


			


			if( ! $this->upload->do_upload('media_file')) {


				


				$media_file  =  $this->upload->display_errors();


				


			}


			else {


				$media_file_data = $this->upload->data();


				$media_file = base_url().$upload_path.$media_file_data['file_name'];


				 


			}


			


		//------------------------------


		


			$upload_path = 'media/user_image/';


			$config['upload_path'] = $upload_path;


			$config['allowed_types'] = 'gif|jpg|jpeg|png';


			$config['max_size'] = '5120';


			$config['encrypt_name'] = TRUE;


			


			$this->load->library('upload', $config);


			


			if( ! $this->upload->do_upload('media_file_esr')) {


				 


				$media_file_esr  =  $this->upload->display_errors();


				 


			}


			else {


				$imagedata = $this->upload->data();


				$media_file_esr = base_url().$upload_path.$imagedata['file_name']; 


			}





			$userdata = array(


				'apikey' => $apikey,


				'method' => $method,


				'data' => $data,


				'name' => $name,


				'esr_name' => $esr_name,


				'time' => $time,


				'date' => $date, 


				'media_file' => $media_file ,


				'media_file_esr' => $media_file_esr 


			);


			


			$response = array(


				'status' => 'success',


				'userinfo' => $userdata


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	function follow($to_user_id){


		


		$user_id = $this->input->get_post('user_id', true);


		$to_user_id = $this->input->get_post('to_user_id', true);


	


		if( ! $user_id && (!$to_user_id)) { 


			$response['follow'] = array(


				'status' => 'user id not exists'


			);


		} 


		else {


			


			$check_request = $this->ws_model->check_request($user_id, $to_user_id);


			


			if( ! empty($check_request)){ 


				$response['follow'] = array(


					'status' => 'user already followed'


				);


			}


			else {


			


				$this->load->model('ion_auth_model');


				$result = $this->ion_auth_model->check_viewer_privacy($to_user_id);


				


				$request = 0;


				if( ! $result) {


					$request = 1;


				}


				


				$requestData = array(


					'user_from' => $user_id,


					'user_to' => $to_user_id,


					'request' => $request,


					'created_on' => time()


				);


				


				$id = $this->ws_model->insert_friends($requestData);


				


				// Notifications


				$notifydata = array(


					'from_user_id' => $user_id,


					'to_user_id' => $to_user_id,


					'action_type' => 'sendRequest',


					'created_on' => time() 


				);


				$this->common_model->insert_notification($notifydata);


				


				$response['follow'] = array(


					'status' => 'success',


				);


			}


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	function unfollow(){





		$user_id = $this->input->get_post('user_id', true);


		$to_user_id = $this->input->get_post('to_user_id', true);


		$type = $this->input->get_post('type', true);


	


		if( ! $user_id && (!$to_user_id)) { 


			$response['unfollow'] = array(


				'status' => 'user id not exists'


			);


		} 


		else {


			if($type == 'follower') {


				$this->ws_model->delete_followers($user_id, $to_user_id);


			} 


			else {


				$this->ws_model->delete_following($user_id, $to_user_id);


			}


			


			$response['unfollow'] = array(


				'status' => 'success'


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function followers() {


		


		$user_id = $this->input->get_post('user_id', true);


		$next_records = $this->input->get_post('next_records', true);


	


		if( ! $user_id ) { 


			$response['followers'] = array(


				'status' => 'user id not exists'


			);


		} 


		else {


			


			if( ! $next_records) {


				$next_records = 0;


			}


			$limit = 10;


			$offset = $next_records;


			


			$followers = $this->ws_model->get_followers($user_id, $limit, $offset);


			


			$number_of_followers = $this->ws_model->count_followers($user_id);


			


			$followerList = array();


			


			if( ! empty($followers))


			{


				foreach($followers as $row){


				


					$profile_image = "";


					if($row->profile_image) {


						$profile_image = base_url().$row->profile_image;


					}


				


					$followerList[] = array(


						'user_id' => $row->id,


						'first_name' => $row->first_name,


						'last_name' => $row->last_name,


						'username' => $row->username,


						'email' => $row->email,


						'image' => $profile_image,


						'number_of_followers' => $number_of_followers,


					);


				}


			}


			


			$response['followers'] = array(


				'status' => 'success',


				'userinfo' => $followerList


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function following() {


		


		$user_id = $this->input->get_post('user_id', true);


		$next_records = $this->input->get_post('next_records', true);


		


		if( ! $user_id ) { 


			$response['following'] = array(


				'status' => 'user id not exists'


			);


		} 


		else {


		


			if( ! $next_records) {


				$next_records = 0;


			}


			$limit = 10;


			$offset = $next_records;


			


			$following = $this->ws_model->get_following($user_id, $limit, $offset);


			


			$number_of_following = $this->ws_model->count_following($user_id);


			


			$followingList = array();


			


			if( ! empty($following))


			{


				foreach($following as $row){


				


					$profile_image = "";


					if($row->profile_image) {


						$profile_image = base_url().$row->profile_image;


					}


				


					$followingList[] = array(


						'user_id' => $row->id,


						'first_name' => $row->first_name,


						'last_name' => $row->last_name,


						'username' => $row->username,


						'email' => $row->email,


						'image' => $profile_image,


						'number_of_following' => $number_of_following,


					);


				}


			}


			


			$response['following'] = array(


				'status' => 'success',


				'userinfo' => $followingList


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function search() {


		


		$user_id = $this->input->get_post('user_id', true);


		$keyword = $this->input->get_post('keyword', true);


		


		if( ! $user_id ) { 


			$response['search'] = array(


				'status' => 'user id not exists'


			);


		} 


		else {


			


			$results = $this->ws_model->get_search_user($user_id, $keyword);


			


			$resultList = array();


			


			if( ! empty($results))


			{


				foreach($results as $row){


				


					$profile_image = "";


					if($row->profile_image) {


						$profile_image = base_url().$row->profile_image;


					}


				


					$resultList[] = array(


						'user_id' => $user_id,


						'to_user_id' => $row->id,


						'first_name' => $row->first_name,


						'last_name' => $row->last_name,


						'username' => $row->username,


						'email' => $row->email,


						'image' => $profile_image,


					);


				}


			}


			


			$response['search'] = array(


				'status' => 'success',


				'userinfo' => $resultList


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function profile() {


		


		$user_id = $this->input->get_post('user_id', true);


		


		if( ! $user_id ) { 


			$response['profile'] = array(


				'status' => 'user id not exists'


			);


		}


		else {


			


			$user = $this->ion_auth->user($user_id)->row();


			


			$frames = $this->ws_model->count_user_frames($user_id);


			


			$number_of_frames = COUNT($frames);


			


			$number_of_event = $this->ws_model->count_user_events($user_id);


			$number_of_following = $this->ws_model->count_following($user_id);


			$number_of_followers = $this->ws_model->count_followers($user_id);


			


			$profile_image = "";


			if($row->profile_image) {


				$profile_image = base_url().$row->profile_image;


			}


		


			$resultList = array(


				'user_id' => $user_id,


				'username' => $user->username,


				'realname' => $user->first_name.' '.$user->last_name,


				'description' => $user->description,


				'profile_image' => $profile_image,


				'number_of_event' => $number_of_event,


				'number_of_frame' => $number_of_frames,


				'number_of_following' => $number_of_following,


				'number_of_followers' => $number_of_followers,


			);


			


			$response['profile'] = array(


				'status' => 'success',


				'userinfo' => $resultList


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	function update_identity(){





		$user_id = $this->input->get_post('user_id', true);


		$email = $this->input->get_post('email', true);


		$username = $this->input->get_post('username', true);


		$first_name = $this->input->get_post('first_name', true);


		$last_name = $this->input->get_post('last_name', true);


		$description = $this->input->get_post('description');


		


		/*$user_id = 35;


		$username = 'jack';


		$email = 'jack@tagframe.com';


		$first_name = 'Jack';


		$last_name = 'Torson';*/


	


		if( ! $user_id) { 


			$response = array(


				'status' => 'user id not exists'


			);


		} 


		else if( ! $username && ! $email) { 


			$response = array(


				'status' => 'error'


			);


		} 


		else {


	


			$user = $this->ion_auth->user($user_id)->row();


			


			if($user->email != $email && $this->ion_auth_model->email_check($email) ) {


				


				$response = array(


					'status' => $email.' email id already exists.'


				);


				


			} 


			else if($user->username != $username && $this->ion_auth_model->username_check($username)) {





				$response = array(


					'status' => $username.' username id already exists.'


				);





			} 


			


			else {


				


				if($_FILES['profile_photo']['name']){


						


					$upload_path = 'media/user_image/';


					$config['upload_path'] = $upload_path;


					$config['allowed_types'] = 'gif|jpg|jpeg|png';


					$config['max_size'] = '5120';


					$config['encrypt_name'] = TRUE;


					


					$this->load->library('upload', $config);


					


					if( ! $this->upload->do_upload('profile_photo')) {


						$response = array(


							'status' => $this->upload->display_errors()


						);


					} 


					else {


						


						//$user = $this->ion_auth->user($user_id)->row();


						if($user->profile_image && file_exists($user->profile_image)) {


							unlink($user->profile_image);


						}


						


						$imagedata = $this->upload->data();


						$profile_photo = $upload_path.$imagedata['file_name'];


						


						$userdata = array(


							'username' => $username,


							'email' => $email,


							'first_name' => $first_name,


							'last_name' => $last_name,


							'profile_image' => $profile_photo,


							'description' => $description


						);


						


						$this->ion_auth->update($user_id, $userdata);


						


						$response = array(


							'status' => 'success'


						);


					}


						


				}


				else{


					


					$userdata = array(


					'username' => $username,


					'email' => $email,


					'first_name' => $first_name,


					'last_name' => $last_name,


					'description' => $description,


				    );


				   


					$this->ion_auth->update($user_id, $userdata);


					$response = array(


						'status' => 'success'


					);


				   


				}


			}


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	public function timeline()


	{


		$user_id = $this->input->get_post('user_id', true);


		$next_records = $this->input->get_post('next_records', true);


		


		if( ! $user_id) {


			$response = array(


				'status' => 'error',


			);


		}


		else {


		


			if( ! $next_records) {


				$next_records = 0;


			}


			$limit = 10;


			$offset = $next_records;


			


			$tagstreams = $this->ws_model->get_tagged_users($user_id, $limit, $offset);


			$records = array();


			 


			if( ! empty($tagstreams))


			{


				foreach($tagstreams as $tagstream)


				{ 


					if($tagstream->profile_image){


						$profile_picture = base_url().$tagstream->profile_image;


					} 


					else {


						$profile_picture = base_url().'assets/img/no-image.png';


					}


					


					$name = $tagstream->first_name.' '.$tagstream->last_name;


					


					$this->load->helper('datetime');


					$created_at = humanTiming(strtotime($tagstream->created_at));


					


					$title = "";


					$kaltura_video_id = "";


					$thumbnailUrl = "";


					$dataUrl = "";


					$product = "";


					$product_url = "";


					$product_image = "";


					$product_name = "";


					


					if($tagstream->type == 'Event') 


					{


						$kaltura_video_id = $tagstream->kaltura_video_id;


						$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);


						$thumbnailUrl = $video['result']->objects[0]->thumbnailUrl;


						$dataUrl = $video['result']->objects[0]->dataUrl;


						$title = $tagstream->title;


						$description = $tagstream->description;


					} 


					else if($tagstream->product_id) {


					


						$product = $this->bwt_magento->get_product($tagstream->product_id);


						$product_url = $product->getProductUrl();


						$product_image = $product->getImageUrl();


						$product_name = $product->getName();


					}


					


					$records[] = array(


						'tag_type' => $tagstream->type,


						'name' => $name,


						'profile_picture' => $profile_picture,


						'created_at' => $created_at,


						'thumbnail' => $thumbnailUrl,


						'data_url' => $dataUrl,


						'kvideo_id' => $kaltura_video_id,


						'event_id' => $tagstream->id,


						'title' => $title,


						'description' => $description,


						'product_url' => $product_url,


						'product_image' => $product_image,


						'product_name' => $product_name


					);


				}


				


				$response = array(


					'status' => 'success',


					'records' => $records


				);


			}


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


	


	


	public function search_user()


	{


		$keyword = $this->input->get_post('keyword', true);


		$next_records = $this->input->get_post('next_records', true);


		


		if( ! $keyword) {


			$response = array(


				'status' => 'error',


			);


		}


		else {


		


			if( ! $next_records) {


				$next_records = 0;


			}


			$limit = 10;


			$offset = $next_records;


			


			$users = $this->ws_model->search_user($keyword, $limit, $offset);


			


			if( ! empty($users))


			{


				foreach($users as $user) {


					


					if($user->profile_image){


						$profile_picture = base_url().$user->profile_image;


					} 


					else {


						$profile_picture = base_url().'assets/img/no-image.png';


					}


					


					$name = $user->first_name.' '.$user->last_name;


					


					$records[] = array(


						'user_id' => $user->id,


						'name' => $name,


						'profile_picture' => $profile_picture,


					);


				}


			}


			


			$response = array(


				'status' => 'success',


				'records' => $records


			);


		}


		


		$this->output


			->set_content_type('application/json')


			->set_output(json_encode($response));


	}


}


