<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Events extends MY_Controller {
	
	 public $data;
      
      //$player_fullscreen= $abs(crc32(uniqid()));
      
	
	function __construct() {
           
      
		parent::__construct();
		
        //$config['fullScreenPlayer'] = abs(crc32(uniqid()));
		
		//$this->load->language('videos');
		$this->load->model('videos/videos_model');
		$this->load->library('kaltura/kaltura');
		$this->load->library('form_validation');
		$this->load->helper('text');
		$this->load->helper('datetime');
		$this->load->helper('media');
		$this->load->model('ws_model');
		$this->load->model('events/event_model');
		$this->load->model('frame/frame_model');
		$this->load->library('common_lib');
	}
	
	public function index()
    {
        //$this->template->set_title('Videos');
		//$this->data['videos'] = "videos";
        //$this->template->load_view('videos/listing', $this->data);
    }
	
	function upload(){
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login');
		}
		
		$user_id = $this->ion_auth->get_user_id();
		
		$this->template->set_title('Create Event');
		
		$this->template->add_js('modules/videos.js');
		
		$this->load->library('upload');
		
		$this->data['followers'] = Modules::run('tagstream/followers');
		$this->data['following'] = Modules::run('tagstream/following');
		
		$this->template->load_view('events/upload_event', $this->data);
	}
	
	
	function upload_event(){
	
		$this->load->model('videos/videos_model');
		
		$user_id = $this->ion_auth->get_user_id();
		
		$access_type = $this->input->get_post('access_type');
		$title = $this->input->get_post('title');
		$description = $this->input->get_post('description');
		$tags_keywords = $this->input->get_post('tags_keywords');
		$price = $this->input->get_post('price');
		$is_paid = $this->input->get_post('is_paid');
		$duration = $this->input->get_post('duration');
		
		$event_type = $this->input->get_post('event_type');
		
		$TaggedUserIds = $this->input->get_post('TaggedUserIds');
		$taggedUser= explode(",",$TaggedUserIds);
		
		if ( ! $user_id) {
			$response = array(
				'status' => 'error',
			);
		} 
		else {
		
			if($event_type == 'VIDEO'){
				
				$this->load->library('upload');
				
				$uploadPath = 'media/temp/';
				$config['upload_path'] = $uploadPath;
				$config['max_size']	= "2048000000000";
				$config['allowed_types'] = 'mp4|mov|mkv';
				$config['encrypt_name'] = TRUE;
				$this->upload->initialize($config);
				
				if( ! $this->upload->do_upload('video_file')) {
					$response = array(
						'status' => $this->upload->display_errors()
					);
				} 
				else {
					$upload_data = $this->upload->data();
					$videofile = $upload_data['file_name'];
					
					$kaltura_user = $this->ion_auth->get_username($user_id);
					$video_file_path = $uploadPath.$videofile;
					
					// Kaltura data
					$media = array(
						'user' => $kaltura_user,
						'access_type' => 'USER',
						'media_type' => 'VIDEO',
						'title' => $title,
						'description' => $description,
						'tags' => $tags_keywords,
						'media_path' => $video_file_path
					);
					
					$kvideo = $this->kaltura->uploadfile($media);
					$kvideoInfo = $this->kaltura->kvideo($kvideo->id);
					$video_data =array(
						'user_id' => $user_id,
						'kaltura_user_id' => $kvideo->userId,
						'kaltura_video_id' => $kvideo->id,
						'type' => $access_type,
						'title' => $title,
						'event_type' => 'VIDEO',
						'description' => $description,
						'tag_keyword' => $tags_keywords,
						'video_duration' => $kvideoInfo->msDuration,
						'price' => $price,
						'is_paid' => $is_paid,
						'created_on' =>  $this->currentTime($user_id)
					);
					
					$video_id = $this->videos_model->insert('videos', $video_data);
					
					// Tag Streams
					$streams_data = array(
						'user_id' => $user_id,
						'stream_type' => 'event',
						'event_id' => $video_id,
						'action_type' => 'add',
						'created_on' => $this->currentTime($user_id) 
					);
					$this->common_model->insert_tag_stream($streams_data);
					
					// Tagged User
					
					if($taggedUser) 
					{
						foreach ($taggedUser as $tag_user) {
							$taggedUserData = array(
								'user_id' => $user_id,
								'tagged_user_id' => $tag_user,
								'video_id' => $video_id,
								'type' => 'Event',
								'created_at' => $this->dateTime($user_id)
							);			
							$this->ws_model->insert_tagged_user($taggedUserData);
							
							$from_user_id=$user_id;
							$to_user_id=$tag_user;
							$action_type =10;
							$event_id =$video_id;
							
                            if($from_user_id !=$to_user_id){
								$this->common_lib->notification($from_user_id,$to_user_id,$action_type,$event_id);
							}						
																					
						}						
					}
					
					unlink($video_file_path);
					$response = array(
						'status' => 'success',
						'event_id' => $video_id,
						'kevent_id'=>$kvideo->id
					);
				}
			}
			if($event_type == 'IMAGE'){
				
				$this->load->library('upload');
				
				$uploadPath = 'media/temp/';
				$config['upload_path'] = $uploadPath;
				$config['allowed_types'] = 'gif|jpg|jpeg|png';
				$config['encrypt_name'] = TRUE;
				$this->upload->initialize($config);
				
				if( ! $this->upload->do_upload('video_file')) {
					
					$response = array(
						'status' => $this->upload->display_errors()
					);
				} 
				else {
					$upload_data = $this->upload->data();
					$imgfile = $upload_data['file_name'];
					
					$kaltura_user = $this->ion_auth->get_username($user_id);
					$imgfile_path = $uploadPath.$imgfile;
					
					// Kaltura data
					$media = array(
						'user' => $kaltura_user,
						'access_type' => 'USER',
						'media_type' => 'IMAGE',
						'title' => $title,
						'description' => $description,
						'tags' => $tags_keywords,
						'media_path' => $imgfile_path
					);
					
					$kvideo = $this->kaltura->uploadfile($media);
					//$kvideoInfo = $this->kaltura->kvideo($kvideo->id);
					$image_data =array(
						'user_id' => $user_id,
						'kaltura_user_id' => $kvideo->userId,  
						'kaltura_video_id' => $kvideo->id, 
						'type' => $access_type,
						'title' => $title,
						'event_type' => 'IMAGE',
						'thumbnail_url' => $kvideo->dataUrl,
						'description' => $description,
						'tag_keyword' => $tags_keywords, 
						'price' => $price,
						'is_paid' => $is_paid,
						'created_on' =>  $this->currentTime($user_id)
					);
					
					$video_id = $this->videos_model->insert('videos', $image_data);
					
					// Tag Streams
					$streams_data = array(
						'user_id' => $user_id,
						'stream_type' => 'event',
						'event_id' => $video_id,
						'action_type' => 'add',
						'created_on' => $this->currentTime($user_id) 
					);
					$this->common_model->insert_tag_stream($streams_data);
					
					if($taggedUser) 
					{
						foreach ($taggedUser->tag_array as $tag_user) {
							$taggedUserData = array(
								'user_id' => $user_id,
								'tagged_user_id' => $tag_user,
								'video_id' => $video_id,
								'type' => 'Event',
								'created_at' => $this->dateTime($user_id)
							);			
							$this->ws_model->insert_tagged_user($taggedUserData);
							
							$from_user_id=$user_id;
							$to_user_id=$tag_user;
							$action_type =10;
							$event_id =$video_id;
							
							if($from_user_id !=$to_user_id){
								$this->notification($from_user_id,$to_user_id,$action_type,$event_id);	
							}														
						}						
					}
					
					unlink($imgfile_path);
					
					$response = array(
						'status' => 'success',
						'event_id' => $video_id,
						'kevent_id'=>$kvideo->id
					);
					
				}
			}	
			
		} 
		
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response)); 
		
		
	}
	
	function get_video_status(){
		$kaltura_video_id=$this->input->get_post('kevent_id');
		$kvideoInfo = $this->kaltura->kvideo($kaltura_video_id);
		$status='';
		if($kvideoInfo){
			$status= $kvideoInfo->status;
		}
		$response=array(
		'status'=>$status
		);
        
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response)); 
		
	}
	
	
	
	function event($event_id){
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login');
		}
		
		$this->data['user_id']= $user_id = $this->ion_auth->get_user_id();
		
		$this->template->set_title('Create Event');
		
		//$this->template->add_js('moment-with-locales.js');
		
		$this->load->library('upload');
		
		$this->data['followers'] = Modules::run('tagstream/followers');
		$this->data['following'] = Modules::run('tagstream/following');
		
		$this->load->model('videos/videos_model');
			
		$event = $this->videos_model->get_video('id', $event_id, $kaltura_user_id='', $active=1);
		
		$kaltura_video_id = $event->kaltura_video_id;
		$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);
		
		$duration = $video['result']->objects[0]->duration;
		$views = $video['result']->objects[0]->views;
		
		$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
		$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
		$dataUrl=$this->videoDataUrl($kaltura_video_id);
		
		
		$video_id = $event->id;
		$countLike = $this->ws_model->count_like($video_id);
		
		$liked = $this->ws_model->is_liked($user_id, $video_id);
		if($liked){
			$is_liked = 'Yes';
		} else {
			$is_liked = 'No';
		}
		
		// Event frames
		
		$video_frames = $this->videos_model->get_video_frames($video_id);
		$frames = array();
		
		if( ! empty($video_frames)) {
			foreach($video_frames as $frame) {
		
				$frameDataUrl = "";
				if($frame->media_type == 'VIDEO'){
					$frm_kaltura_video_id = $frame->kaltura_video_id;
					$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
					
					$frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
				}
		
				$magento_product = $this->bwt_magento->get_product($frame->product_id);
				if($frame->media_type=="VIDEO"){
					$frame_media_type=111;
				}
				else if($frame->media_type=="IMAGE"){
					$frame_media_type=110;
				}
				
				$ms= $frame->end_time-$frame->start_time;
				$s = intval($ms/1000);
				$frameTime = sprintf('%02d:%02d:%02d', ($s / 3600), ($s / 60 % 60), $s % 60);
				
				$frames[] = array(
					'frame_id' => $frame->id,
					'user_id' => $frame->user_id,
					'product_id' => $frame->product_id,
					'product_image' => $magento_product->getImageUrl(),
					'frame_title' => $frame->title,
					'frame_start_time' => $frame->start_time,
					'frame_end_time' => $frame->end_time,
					'frame_media_type' => $frame_media_type,
					'frame_kmedia_id' => $frame->frame_kaltura_media_id,
					'frame_thumbnail_url' => $frame->thumbnail_url,
					'frame_image_url' => $frame->image_url,
					'frame_data_url' => $frameDataUrl,
					'frame_product_url' => $magento_product->getProductUrl(),
					'frame_resource_type' =>"internet",
					'frame_time'=>$frameTime
				);
			}
		}
		
		//$this->load->helper('datetime');
		if($event->event_type=="VIDEO"){
					$event_media_type=111;
				}
		else if($event->event_type=="IMAGE"){
					$event_media_type=110;
		}
		/* Tagged users on a events*/
		$tagged_user_id=array();
		$taggedUserData = $this->event_model->get_tagged_users_on_event($video_id);
		$num_of_comments= $this->videos_model->num_of_comments_video($video_id);
		
		$profile_pic= base_url().'media/default-user.png';
		if(!empty($taggedUserData)){
			
			foreach($taggedUserData as $taggedUser){
			if(!empty($taggedUser->profile_image)){
				$profile_pic=base_url().$taggedUser->profile_image;
			}
			$tagged_user_id[]=array(
			'tag_id'=>$taggedUser->tag_id,
			'name'=>$taggedUser->first_name,
			'user_id'=>$taggedUser->tagged_user_id,
			'profile_pic'=>$profile_pic,
			
			);
			}
			
		}
		
		
		$kvideoInfo = $this->kaltura->kvideo($kaltura_video_id);
		$this->data['frames']=$frames;
		$this->data['video_duration']= $kvideoInfo->msDuration;
		$this->data['event_id']=$event->id;
		$this->data['kvideo_id']=$event->kaltura_video_id;
		
		$this->data['title']= $event->title;
		$this->data['description']= $event->description;
		$this->data['tags']=$event->tag_keyword;
		
		$this->data['thumbnail']=$thumbnailUrl;
		$this->data['data_url']=$dataUrl;
		$this->data['video_id'] = $event->id;
		$this->data['is_liked'] = $is_liked;
		
		$this->data['count_like'] = $countLike;
		$this->data['tagged_user_id']=$tagged_user_id;
		
		$this->data['comment_open']=$this->input->get_post('comment');
		$this->data['comment_id']=$this->input->get_post('com');
        $this->data['num_of_comments']=$num_of_comments;
		$this->data['frame_permission']=$this->common_lib->frame_permission($video_id);
		$this->data['event_user_id']=$event->user_id;;
		$this->template->load_view('events/event_info', $this->data);
		
	}
	
	
	
	public function ajax_search_magento_product() {
		$keyword = $this->input->post('keyword', true);
		$this->load->library('bwt_magento');
		$products = $this->bwt_magento->product_search($keyword);
		$this->data['products'] = $products;
		//echo "<pre>";print_r($this->data['products']);
		$this->load->view('events/product_search_result', $this->data);
	}
	
	
	public function product_info(){
		$this->load->library('bwt_magento');
		$product_id = $this->input->get_post('product_id', true);
		$this->data['magento_product']= $this->bwt_magento->get_product($product_id);
		$this->data['product_id']=$product_id;
		$this->data['frame_id']= abs(crc32(uniqid()));
		$this->load->view('events/product_info',$this->data);
	}
	
	public function products()
	{
		$this->load->library('bwt_magento');
	    $products = $this->bwt_magento->product_search_all();
        
		
		$records = array();
		if( count($products) > 0){
			foreach($products as $product){
				$records[] = array(
					'product_id' => $product->getId(),
					'product_name' => $product->getName(),
					'product_url' => $product->getProductUrl(),
					'product_image' => $product->getImageUrl(),
					'product_price'=>number_format($product->getPrice(),2)
				);  
			}
		}
		
		$this->data['listing']=$records;
		
		$isEndrose= $this->input->get_post('endrose');
		
        if($isEndrose==1){
			
			$this->load->view('events/endroseListing', $this->data);
		}
		else{
			$this->load->view('events/listing', $this->data);
		}
        
		  	 
	}
	
   /* public function search_product()
	{
		$keyword = $this->input->get_post('keyword', true);
        $page_number = $this->input->get_post('page_number', true);
        if(!$page_number){
           $page_number=1;                
        }    
		$this->load->library('bwt_magento');
		if($keyword){
			$products = $this->bwt_magento->product_search($keyword,$page_number);
            $last_page_number = $this->bwt_magento->product_count_for_search();
		}
		else{
		    $products = $this->bwt_magento->product_search_all($page_number);
            $last_page_number = $this->bwt_magento->product_count();
		}
		  
		$records = array();
		if( count($products) > 0){
			foreach($products as $product){
				$records[] = array(
					'product_id' => $product->getId(),
					'product_name' => $product->getName(),
					'product_url' => $product->getProductUrl(),
					'product_image' => $product->getImageUrl(),
					'product_price'=>number_format($product->getPrice(),2)
				);  
			}
		}
		
	} */
	
	
	public function user_events($user_id=null) {
	     //$this->load->library('pagination');	
		if(!$user_id){
			$user_id = $this->ion_auth->get_user_id();
		}
		$this->data['user_id']=$user_id;
		$limit = 5;
		$offset = 0;
		$this->data['records'] = $limit + $offset;
		
		if( ! $user_id) {
			redirect('auth/login');
		} 
		else {
			
			
			$this->data['totalRows'] = $this->ws_model->count_user_events($user_id);
			
			$events = $this->ws_model->get_user_events($user_id, $limit, $offset); 
		
			$eventlist = array();
			
			if( ! empty($events)) {
			
				$kaltura_user = $this->ion_auth->get_username($user_id);
				$user = $this->ion_auth->user($user_id)->row();
			
				$profile_image = "";
				if($user->profile_image) {
					$profile_image = base_url().$user->profile_image;
				}
				foreach($events as $event) {
				
					$kaltura_video_id = $event->kaltura_video_id;
					$video = $this->kaltura->videolist($access_type='USER', $kaltura_user, $page='', $kaltura_video_id, $categoriesId = TRUE);
					
					$duration = $video['result']->objects[0]->duration;
					$views = $video['result']->objects[0]->views;
					
					$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
					$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
					$dataUrl=$this->videoDataUrl($kaltura_video_id);
					
					
					$video_id = $event->id;
					$countLike = $this->ws_model->count_like($video_id);
					
					$kaltura_video_id = $event->kaltura_video_id;
					$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);
					
					$liked = $this->ws_model->is_liked($user_id, $video_id);
					if($liked){
						$is_liked = 'Yes';
					} else {
						$is_liked = 'No';
					}
					
					// Event frames
					
					$video_frames = $this->videos_model->get_video_frames($video_id);
					$frames = array();
					
					if( ! empty($video_frames)) {
						foreach($video_frames as $frame) {
					
							$frameDataUrl = "";
							if($frame->media_type == 'VIDEO'){
								$frm_kaltura_video_id = $frame->kaltura_video_id;
								$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
								
								$frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
							}
					
							$magento_product = $this->bwt_magento->get_product($frame->product_id);
						    if($frame->media_type=="VIDEO"){
								$frame_media_type=111;
							}
							else if($frame->media_type=="IMAGE"){
								$frame_media_type=110;
							}
							
							$ms= $frame->end_time-$frame->start_time;
							$s = intval($ms/1000);
							$frameTime = sprintf('%02d:%02d:%02d', ($s / 3600), ($s / 60 % 60), $s % 60);
										
							$frames[] = array(
								'frame_id' => $frame->id,
								'user_id' => $frame->user_id,
								'product_id' => $frame->product_id,
								'product_image' => $magento_product->getImageUrl(),
								'frame_title' => $frame->title,
								'frame_start_time' => $frame->start_time,
								'frame_end_time' => $frame->end_time,
								'frame_media_type' => $frame_media_type,
								'frame_kmedia_id' => $frame->frame_kaltura_media_id,
								'frame_thumbnail_url' => $frame->thumbnail_url,
								'frame_image_url' => $frame->image_url,
								'frame_data_url' => $frameDataUrl,
								'frame_product_url' => $magento_product->getProductUrl(),
								'frame_resource_type' =>"internet",
								'frame_time'=>$frameTime
								
								
							);
						}
					}
					
					//$this->load->helper('datetime');
					if($event->event_type=="VIDEO"){
								$event_media_type=111;
							}
					else if($event->event_type=="IMAGE"){
								$event_media_type=110;
					}
					/* Tagged users on a events*/
					$tagged_user_id=array();
					$taggedUserData = $this->ws_model->get_tagged_users_on_event($video_id);
					$num_of_comments= $this->videos_model->num_of_comments_video($video_id);
					
					$profile_pic= base_url().'media/default-user.png';
					if(!empty($taggedUserData)){
						
						foreach($taggedUserData as $taggedUser){
						if(!empty($taggedUser->profile_image)){
							$profile_pic=base_url().$taggedUser->profile_image;
						}
						$tagged_user_id[]=array(
						'name'=>$taggedUser->first_name,
						'user_id'=>$taggedUser->tagged_user_id,
						'profile_pic'=>$profile_pic,
						
						);
					    }
						
					}
					$kvideoInfo = $this->kaltura->kvideo($event->kaltura_video_id);
					//unset($tagged_user_id);
					$eventlist[] = array(
						'event_id' => $event->id,
						'kuser_id' => $event->kaltura_user_id,
						'event_user_id'=>$event->user_id,
						'kvideo_id' => $event->kaltura_video_id,
						'video_duration' => $kvideoInfo->msDuration,
						'type' => $event->type,
						'event_type' => $event_media_type,
						'title' => $event->title,
						'description' => $event->description,
						'tags' => $event->tag_keyword,
						'is_paid' => $event->is_paid,
						'price' => $event->price,
						'duration' => $duration,
						'views' => $views,
						'thumbnail' =>($event->event_type == 'VIDEO')?$thumbnailUrl:$event->thumbnail_url,
						'data_url' => $dataUrl,
						'created_at' => $this->humanTiming($user_id,$event->created_on)." ago",
						'count_like' => $countLike,
						'website_video_url' => $websiteVideoUrl,
						'is_liked' => $is_liked,
						'name'=>$user->first_name,
						'profile_picture'=>$profile_image,
						'user_id'=>$user_id,
						'frames' => $frames,
						'tagged_user_id'=>$tagged_user_id,
						'num_of_comments'=>$num_of_comments
					);
				}
			}
		}
		
		$this->data['tagstream'] = $eventlist;
		$this->template->set_title('Events');
		
		$this->data['total_followers'] = Modules::run('tagstream/followers');
		$this->data['total_following'] = Modules::run('tagstream/following');
		
		$this->data['profileData'] = Modules::run("friends/get_profile",$user_id);
		
		$this->template->load_view('events/user_events/user_events',$this->data);
	}
	
	public function ajax_user_events($user_id) {
	     //$this->load->library('pagination');
        if(!$user_id){
			redirect('auth/login');
		}		 
		$this->data['user_id']= $user_id;
		$records = $this->input->post('records');
		
		$limit = 5;
		$offset = $records;
		
		$this->data['records'] = $limit + $offset;
		if( ! $user_id) {
			redirect('auth/login');
		} 
		else {
			
			
			$totalRows = $this->ws_model->count_user_events($user_id);
			$this->data['total_rows']=$totalRows;
			
			$events = $this->ws_model->get_user_events($user_id, $limit, $offset); 
		
			$number_of_event = $this->ws_model->count_user_events($user_id);
			 
			$eventlist = array();
			
			if( ! empty($events)) {
			
				$kaltura_user = $this->ion_auth->get_username($user_id);
				$user = $this->ion_auth->user($user_id)->row();
			
				$profile_image = "";
				if($user->profile_image) {
					$profile_image = base_url().$user->profile_image;
				}
				foreach($events as $event) {
				
					$kaltura_video_id = $event->kaltura_video_id;
					$video = $this->kaltura->videolist($access_type='USER', $kaltura_user, $page='', $kaltura_video_id, $categoriesId = TRUE);
					
					$duration = $video['result']->objects[0]->duration;
					$views = $video['result']->objects[0]->views;
					
					$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
					$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
					$dataUrl=$this->videoDataUrl($kaltura_video_id);
					
					
					$video_id = $event->id;
					$countLike = $this->ws_model->count_like($video_id);
					
					$kaltura_video_id = $event->kaltura_video_id;
					$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);
					
					$liked = $this->ws_model->is_liked($user_id, $video_id);
					if($liked){
						$is_liked = 'Yes';
					} else {
						$is_liked = 'No';
					}
					
					// Event frames
					
					$video_frames = $this->videos_model->get_video_frames($video_id);
					$frames = array();
					
					if( ! empty($video_frames)) {
						foreach($video_frames as $frame) {
					
							$frameDataUrl = "";
							if($frame->media_type == 'VIDEO'){
								$frm_kaltura_video_id = $frame->kaltura_video_id;
								$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
								
								$frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
							}
					
							$magento_product = $this->bwt_magento->get_product($frame->product_id);
						    if($frame->media_type=="VIDEO"){
								$frame_media_type=111;
							}
							else if($frame->media_type=="IMAGE"){
								$frame_media_type=110;
							}
							
							$ms= $frame->end_time-$frame->start_time;
							$s = intval($ms/1000);
							$frameTime = sprintf('%02d:%02d:%02d', ($s / 3600), ($s / 60 % 60), $s % 60);
							
							$frames[] = array(
								'frame_id' => $frame->id,
								'user_id' => $frame->user_id,
								'product_id' => $frame->product_id,
								'product_image' => $magento_product->getImageUrl(),
								'frame_title' => $frame->title,
								'frame_start_time' => $frame->start_time,
								'frame_end_time' => $frame->end_time,
								'frame_media_type' => $frame_media_type,
								'frame_kmedia_id' => $frame->frame_kaltura_media_id,
								'frame_thumbnail_url' => $frame->thumbnail_url,
								'frame_image_url' => $frame->image_url,
								'frame_data_url' => $frameDataUrl,
								'frame_product_url' => $magento_product->getProductUrl(),
								'frame_resource_type' =>"internet",
								'frame_time'=>$frameTime
								
								
							);
						}
					}
					
					//$this->load->helper('datetime');
					if($event->event_type=="VIDEO"){
								$event_media_type=111;
							}
					else if($event->event_type=="IMAGE"){
								$event_media_type=110;
					}
					/* Tagged users on a events*/
					$tagged_user_id=array();
					$taggedUserData = $this->ws_model->get_tagged_users_on_event($video_id);
					$num_of_comments= $this->videos_model->num_of_comments_video($video_id);
					
					$profile_pic= base_url().'media/default-user.png';
					
					if(!empty($taggedUserData)){
						
						foreach($taggedUserData as $taggedUser){
						if(!empty($taggedUser->profile_image)){
							$profile_pic=base_url().$taggedUser->profile_image;
						}
						$tagged_user_id[]=array(
						'name'=>$taggedUser->first_name,
						'user_id'=>$taggedUser->tagged_user_id,
						'profile_pic'=>$profile_pic,
						
						);
					    }
						
					}
					$kvideoInfo = $this->kaltura->kvideo($event->kaltura_video_id);
					//unset($tagged_user_id);
					$eventlist[] = array(
						'event_id' => $event->id,
						'kuser_id' => $event->kaltura_user_id,
						'event_user_id'=>$event->user_id,
						'kvideo_id' => $event->kaltura_video_id,
						'video_duration' => $kvideoInfo->msDuration,
						'type' => $event->type,
						'event_type' => $event_media_type,
						'title' => $event->title,
						'description' => $event->description,
						'tags' => $event->tag_keyword,
						'is_paid' => $event->is_paid,
						'price' => $event->price,
						'duration' => $duration,
						'views' => $views,
						'thumbnail' =>($event->event_type == 'VIDEO')?$thumbnailUrl:$event->thumbnail_url,
						'data_url' => $dataUrl,
						'number_of_event' => $number_of_event,
						'created_at' => $this->humanTiming($user_id,$event->created_on)." ago",
						'count_like' => $countLike,
						'website_video_url' => $websiteVideoUrl,
						'is_liked' => $is_liked,
						'name'=>$user->first_name,
						'profile_picture'=>$profile_image,
						'user_id'=>$user_id,
						'frames' => $frames,
						'tagged_user_id'=>$tagged_user_id,
						'num_of_comments'=>$num_of_comments
					);
				}
			}
		}
		
		$this->data['tagstream'] = $eventlist;
		
		$this->load->view('events/user_events/ajaxlist',$this->data);
	}
	
	
	public function timeline($user_id=null)
	{
		
		if(!$user_id){
			$user_id = $this->ion_auth->get_user_id();
		}
		$this->data['user_id']=$user_id;
		$records = $this->input->post('records');
		
		$limit = 5;
		$offset = $records;
		$this->data['records'] = $limit + $offset;
		
		if( ! $user_id) {
			redirect('auth/login');
		}
		else {
		
			$this->data['totalRows']= $this->event_model->get_tagged_events($user_id);
			
			$tagstreams = $this->ws_model->get_tagged_users($user_id, $limit, $offset);
			$records = array();
			
			if( ! empty($tagstreams))
			{
				foreach($tagstreams as $tagstream)
				{ 
				    //echo "<pre>";print_r($tagstream);
					
					if($tagstream->profile_image){
						$profile_picture = base_url().$tagstream->profile_image;
					} 
					else {
						$profile_picture = base_url().'assets/img/no-image.png';
					}
					
					$name = $tagstream->first_name;
					
					$createdTime= $this->date_to_time($tagstream->tuuserId,$tagstream->created_at);
					
					$created_at = $this->humanTiming($tagstream->tuuserId,$createdTime);
							
					$title = "";
					$kaltura_video_id = "";
					$thumbnailUrl = "";
					$dataUrl = "";
					$product = "";
					$product_url = "";
					$product_image = "";
					$product_name = "";
					
					if($tagstream->type == 'Event') 
					{
						$kaltura_video_id = $tagstream->kaltura_video_id;
						$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);
						
						$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
						$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
						$dataUrl=$this->videoDataUrl($kaltura_video_id);
							
						$title = $tagstream->title;
						$description = $tagstream->description;
					} 
					else if($tagstream->product_id) {
					
						$product = $this->bwt_magento->get_product($tagstream->product_id);
						$product_url = $product->getProductUrl();
						$product_image = $product->getImageUrl();
						$product_name = $product->getName();
					}
					
					$video_id = $tagstream->id;
					$countLike = $this->ws_model->count_like($video_id);
					
					$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);
					
					$liked = $this->ws_model->is_liked($user_id, $video_id);
					if($liked){
						$is_liked = 'Yes';
					} else {
						$is_liked = 'No';
					}
					// Event frames
					
					$video_frames = $this->videos_model->get_video_frames($video_id);
					$num_of_comments= $this->videos_model->num_of_comments_video($video_id);
					$frames = array();
	
					if(!empty($video_frames)) {
						
						foreach($video_frames as $frame) {
							
							$frameDataUrl = "";
							if($frame->media_type == 'VIDEO'){
								$frm_kaltura_video_id = $frame->kaltura_video_id;
								$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
								
							    $frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
							
							}
					        if($frame->media_type=="VIDEO"){
								$frame_media_type=111;
							}
							else if($frame->media_type=="IMAGE"){
								$frame_media_type=110;
							}
							$magento_product = $this->bwt_magento->get_product($frame->product_id);
							
						    $ms= $frame->end_time-$frame->start_time;
							$s = intval($ms/1000);
							$frameTime = sprintf('%02d:%02d:%02d', ($s / 3600), ($s / 60 % 60), $s % 60);
							
							$frames[] = array(
								'frame_id' => $frame->id,
								'user_id' => $frame->user_id,
								'product_id' => $frame->product_id,
								'product_image' => $magento_product->getImageUrl(),
								'frame_title' => $frame->title,
								'frame_start_time' => $frame->start_time,
								'frame_end_time' => $frame->end_time,
								'frame_media_type' => $frame_media_type,
								'frame_kmedia_id' => $frame->frame_kaltura_media_id,
								'frame_thumbnail_url' => $frame->thumbnail_url,
								'frame_image_url' => $frame->image_url,
								'frame_data_url' => $frameDataUrl,
								'frame_product_url' => $magento_product->getProductUrl(),
								'frame_resource_type' =>"internet",
								'frame_time'=>$frameTime
							);
						}
					}
					
					$taggedUserData = $this->ws_model->get_tagged_users_on_event($video_id);
					
					$profile_pic= base_url().'media/default-user.png';
                    $tagged_user_id=array(); 
					foreach($taggedUserData as $taggedUser){
						if(!empty($taggedUser->profile_image)){
							$profile_pic=base_url().$taggedUser->profile_image;
						}
						$tagged_user_id[]=array(
						'name'=>$taggedUser->first_name,
						'user_id'=>$taggedUser->tagged_user_id,
						'profile_pic'=>$profile_pic,
						
						);
					}
					
					$kvideoInfo = $this->kaltura->kvideo($kaltura_video_id);
					$records[] = array(
						'tag_type' => $tagstream->type,
						'tuuserId'=>$tagstream->tuuserId,
						'thumbnail' => $thumbnailUrl,
						'data_url' => $dataUrl,
						'kvideo_id' => $kaltura_video_id,
						'event_user_id'=>$tagstream->user_id,
						'streamtype' => $streamtype,
						'video_duration' => $kvideoInfo->msDuration,
						'event_id' => $tagstream->id,
						'title' => $title,
						'description' => $description,
						'product_url' => $product_url,
						'product_image' => $product_image,
						'product_name' => $product_name,
						'created_at' => $created_at." ago",
						'count_like' => $countLike,
						'website_video_url' => $websiteVideoUrl,
						'is_liked' => $is_liked,
						'name' => $name,
						'profile_picture' => $profile_picture,
						'user_id'=>$tagstream->user_id,
						'frames' => $frames,
						'tagged_user_id'=>$tagged_user_id,
						'num_of_comments'=>$num_of_comments
					);
									
				}
				
			}
		}
		
		$this->data['tagstream'] = $records;
		
		
		$this->data['total_followers'] = Modules::run('tagstream/followers');
		$this->data['total_following'] = Modules::run('tagstream/following');
		
		$this->data['profileData'] = Modules::run("friends/get_profile",$user_id);
		
		$this->template->set_title('Timelines');
		$this->template->load_view('events/user_timelines/index',$this->data);
	}
	
	public function ajax_timeline($user_id)
	{
		
		
		if(!$user_id){
			redirect('auth/login');
		}
		
		$this->data['user_id'] = $user_id;
		$records = $this->input->post('records');
		
		$limit = 5;
		$offset = $records;
		
		$this->data['records'] = $limit + $offset;
		
		if( ! $user_id) {
			redirect('auth/login');
		}
		else {
		    
			$totalRows = $this->event_model->get_tagged_events($user_id);
			$this->data['total_rows']=$totalRows;
			
			$tagstreams = $this->ws_model->get_tagged_users($user_id, $limit, $offset);
			$records = array();
			
			if( ! empty($tagstreams))
			{
				foreach($tagstreams as $tagstream)
				{   
				    //echo "<pre>";print_r($tagstream);
					if($tagstream->profile_image){
						$profile_picture = base_url().$tagstream->profile_image;
					} 
					else {
						$profile_picture = base_url().'assets/img/no-image.png';
					}
					
					$name = $tagstream->first_name;
					
					$createdTime= $this->date_to_time($tagstream->tuuserId,$tagstream->created_at);
					
					$created_at = $this->humanTiming($tagstream->tuuserId,$createdTime);
					
					$title = "";
					$kaltura_video_id = "";
					$thumbnailUrl = "";
					$dataUrl = "";
					$product = "";
					$product_url = "";
					$product_image = "";
					$product_name = "";
					
					if($tagstream->type == 'Event') 
					{
						$kaltura_video_id = $tagstream->kaltura_video_id;
						$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);
						
						$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
						$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
						$dataUrl=$this->videoDataUrl($kaltura_video_id);
							
						$title = $tagstream->title;
						$description = $tagstream->description;
					} 
					else if($tagstream->product_id) {
					
						$product = $this->bwt_magento->get_product($tagstream->product_id);
						$product_url = $product->getProductUrl();
						$product_image = $product->getImageUrl();
						$product_name = $product->getName();
					}
					
					$video_id = $tagstream->id;
					$countLike = $this->ws_model->count_like($video_id);
					
					$websiteVideoUrl = site_url('home/index/'.$kaltura_video_id);
					
					$liked = $this->ws_model->is_liked($user_id, $video_id);
					if($liked){
						$is_liked = 'Yes';
					} else {
						$is_liked = 'No';
					}
					// Event frames
					
					$video_frames = $this->videos_model->get_video_frames($video_id);
					$num_of_comments= $this->videos_model->num_of_comments_video($video_id);
					$frames = array();
	
					if(!empty($video_frames)) {
						
						foreach($video_frames as $frame) {
							
							$frameDataUrl = "";
							if($frame->media_type == 'VIDEO'){
								$frm_kaltura_video_id = $frame->kaltura_video_id;
								$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
								
							    $frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
							
							}
					        if($frame->media_type=="VIDEO"){
								$frame_media_type=111;
							}
							else if($frame->media_type=="IMAGE"){
								$frame_media_type=110;
							}
							$magento_product = $this->bwt_magento->get_product($frame->product_id);
						
						    $ms= $frame->end_time-$frame->start_time;
							$s = intval($ms/1000);
							$frameTime = sprintf('%02d:%02d:%02d', ($s / 3600), ($s / 60 % 60), $s % 60);
							
							$frames[] = array(
								'frame_id' => $frame->id,
								'user_id' => $frame->user_id,
								'product_id' => $frame->product_id,
								'product_image' => $magento_product->getImageUrl(),
								'frame_title' => $frame->title,
								'frame_start_time' => $frame->start_time,
								'frame_end_time' => $frame->end_time,
								'frame_media_type' => $frame_media_type,
								'frame_kmedia_id' => $frame->frame_kaltura_media_id,
								'frame_thumbnail_url' => $frame->thumbnail_url,
								'frame_image_url' => $frame->image_url,
								'frame_data_url' => $frameDataUrl,
								'frame_product_url' => $magento_product->getProductUrl(),
								'frame_resource_type' =>"internet",
								'frame_time'=>$frameTime
							);
						}
					}
					
					$taggedUserData = $this->ws_model->get_tagged_users_on_event($video_id);
					$tagged_user_id=array();
					$profile_pic= base_url().'media/default-user.png';
					foreach($taggedUserData as $taggedUser){
						if(!empty($taggedUser->profile_image)){
							$profile_pic=base_url().$taggedUser->profile_image;
						}
						$tagged_user_id[]=array(
						'name'=>$taggedUser->first_name,
						'user_id'=>$taggedUser->tagged_user_id,
						'profile_pic'=>$profile_pic,
						
						);
					}
					
					$kvideoInfo = $this->kaltura->kvideo($kaltura_video_id);
					$records[] = array(
						'tag_type' => $tagstream->type,
						'thumbnail' => $thumbnailUrl,
						'tuuserId'=>$tagstream->tuuserId,
						'data_url' => $dataUrl,
						'event_user_id'=>$tagstream->user_id,
						'streamtype' => $streamtype,
						'kvideo_id' => $kaltura_video_id,
						'video_duration' => $kvideoInfo->msDuration,
						'event_id' => $tagstream->id,
						'title' => $title,
						'description' => $description,
						'product_url' => $product_url,
						'product_image' => $product_image,
						'product_name' => $product_name,
						'created_at' => $created_at." ago",
						'count_like' => $countLike,
						'website_video_url' => $websiteVideoUrl,
						'is_liked' => $is_liked,
						'name' => $name,
						'profile_picture' => $profile_picture,
						'user_id'=>$tagstream->user_id,
						'frames' => $frames,
						'tagged_user_id'=>$tagged_user_id,
						'num_of_comments'=>$num_of_comments
					);
									
				}
				
			}
		}
		
		$this->data['tagstream'] = $records;
		
		$this->template->set_title('Timelines');
		
		$this->load->view('events/user_timelines/ajaxlist',$this->data);
	}
	
	
	public function search_users()
	{
		
		$user_id = $this->input->get_post('user_id', true);
		
		$user = $this->event_model->search_user($user_id);
		$record=array();
		if( ! empty($user))
		{
		   if($user->profile_image){
				$profile_picture = base_url().$user->profile_image;
			} 
			else {
				$profile_picture = base_url().'assets/img/no-image.png';
			}
			
			$name = $user->first_name.' '.$user->last_name;
			
			$record = array(
				'id' => $user->id,
				'name' => $name,
				'profile_picture' => $profile_picture,
			);
			
			
		}
		
		$response = array(
			'status' => 'success',
			'records' => $record
		);
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	
	public function remove_tag_user(){
		
		$tag_id= $this->input->get_post('tag_id');
		if(!$tag_id){
			$response=array(
			'status'=>'error'
			);
		}
		else{
			$this->event_model->remove_tag_user($tag_id);
			$response=array(
			'status'=>'success'
			);
		}
		$this->output
		    ->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function update_event(){
		$event_id= $this->input->get_post('event_id');
		$e_title= $this->input->get_post('e_title');
		if(!$event_id){
			$response=array(
			'status'=>'error'
			);
		}
		else{
			$data=array('title'=>$e_title);
			
			$this->event_model->update_event($event_id,$data);
			$response=array(
			'status'=>'success'
			);
		}
		$this->output
		    ->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function update_frame(){
		$frame_id= $this->input->get_post('frame_id');
		$f_title= $this->input->get_post('f_title');
		if(!$frame_id){
			$response=array(
			'status'=>'error'
			);
		}
		else{
			$data=array('title'=>$f_title);
			
			$this->event_model->update_frame($frame_id,$data);
			$response=array(
			'status'=>'success'
			);
		}
		$this->output
		    ->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	
	
	public function ajax_event_frames($video_id) {
	    
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login');
		}
		$this->data['user_id'] = $this->ion_auth->get_user_id();
		$this->data['video_duration']= $video_duration= $this->input->get_post('video_duration');
		$this->data['event_user_id']= $event_user_id= $this->input->get_post('event_user_id');
		
		$video_frames = $this->videos_model->get_video_frames($video_id);
		$frames = array();
		
		if( ! empty($video_frames)) {
			foreach($video_frames as $frame) {
		
				$frameDataUrl = "";
				if($frame->media_type == 'VIDEO'){
					$frm_kaltura_video_id = $frame->kaltura_video_id;
					$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
					
					$frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
				}
		
				$magento_product = $this->bwt_magento->get_product($frame->product_id);
				if($frame->media_type=="VIDEO"){
					$frame_media_type=111;
				}
				else if($frame->media_type=="IMAGE"){
					$frame_media_type=110;
				}
				
				$ms= $frame->end_time-$frame->start_time;
				$s = intval($ms/1000);
				$frameTime = sprintf('%02d:%02d:%02d', ($s / 3600), ($s / 60 % 60), $s % 60);
				
				$frames[] = array(
					'frame_id' => $frame->id,
					'user_id' => $frame->user_id,
					'product_id' => $frame->product_id,
					'product_image' => $magento_product->getImageUrl(),
					'frame_title' => $frame->title,
					'frame_start_time' => $frame->start_time,
					'frame_end_time' => $frame->end_time,
					'frame_media_type' => $frame_media_type,
					'frame_kmedia_id' => $frame->frame_kaltura_media_id,
					'frame_thumbnail_url' => $frame->thumbnail_url,
					'frame_image_url' => $frame->image_url,
					'frame_data_url' => $frameDataUrl,
					'frame_product_url' => $magento_product->getProductUrl(),
					'frame_resource_type' =>"internet",
					'frame_time'=>$frameTime
				);
			}
		}
		
		$this->data['frames']=$frames;
		$this->load->view('events/frames_edit', $this->data);
		
	
	}
	
	
	public function ajax_frames($video_id) {
	    
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login');
		}
		$this->data['user_id'] = $this->ion_auth->get_user_id();
		//$this->data['video_duration']= $video_duration= $this->input->get_post('video_duration');
		//$this->data['event_user_id']= $event_user_id= $this->input->get_post('event_user_id');
		
		$event = $this->videos_model->get_video('id', $video_id, $kaltura_user_id='', $active=1);
		$kaltura_video_id = $event->kaltura_video_id;
		
		$kvideoInfo = $this->kaltura->kvideo($kaltura_video_id);
		
		$this->data['video_duration']= $kvideoInfo->msDuration;
		$this->data['event_user_id']=$event->user_id;
		$this->data['event_id']=$event->id;
		$this->data['player_id']=$this->input->get_post('player_id');
		$video_frames = $this->videos_model->get_video_frames($video_id);
		$frames = array();
		
		if( ! empty($video_frames)) {
			foreach($video_frames as $frame) {
		
				$frameDataUrl = "";
				if($frame->media_type == 'VIDEO'){
					$frm_kaltura_video_id = $frame->kaltura_video_id;
					$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
					
					$frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
				}
		
				$magento_product = $this->bwt_magento->get_product($frame->product_id);
				if($frame->media_type=="VIDEO"){
					$frame_media_type=111;
				}
				else if($frame->media_type=="IMAGE"){
					$frame_media_type=110;
				}
				
				$ms= $frame->end_time-$frame->start_time;
				$s = intval($ms/1000);
				$frameTime = sprintf('%02d:%02d:%02d', ($s / 3600), ($s / 60 % 60), $s % 60);
				
				$frames[] = array(
					'frame_id' => $frame->id,
					'user_id' => $frame->user_id,
					'product_id' => $frame->product_id,
					'product_image' => $magento_product->getImageUrl(),
					'frame_title' => $frame->title,
					'frame_start_time' => $frame->start_time,
					'frame_end_time' => $frame->end_time,
					'frame_media_type' => $frame_media_type,
					'frame_kmedia_id' => $frame->frame_kaltura_media_id,
					'frame_thumbnail_url' => $frame->thumbnail_url,
					'frame_image_url' => $frame->image_url,
					'frame_data_url' => $frameDataUrl,
					'frame_product_url' => $magento_product->getProductUrl(),
					'frame_resource_type' =>"internet",
					'frame_time'=>$frameTime
				);
			}
		}
		
		$this->data['frames']=$frames;
		$this->load->view('events/user_events/frames', $this->data);
		
	
	}
	
	public function remove_media(){
		$media= $this->input->get_post('media');
		
		if(!$media){
			$response=array(
			'status'=>'error'
			);
		}
		else{
			$url= 'media/temp/'.$media;
			if(file_exists($url)){
				unlink($url);
			}
			$response=array(
			'status'=>'success',
			);
		}
		$this->output
		    ->set_content_type('application/json')
			->set_output(json_encode($response));
	}
	
	public function frame_player(){
		$this->data['kvideo_id']= $kvideo_id= $this->input->get_post('kvideo_id');
		
		if($kvideo_id){
			$this->load->view('events/player',$this->data);
		}
	}
	public function frame_player_fullscreen(){
		$this->data['kvideo_id']= $kvideo_id= $this->input->get_post('kvideo_id');
		if($kvideo_id){
			$this->load->view('events/player_fullscreen',$this->data);
		}
	}
	
	public function video_frame_player(){
		$this->data['kvideo_id']= $kvideo_id= $this->input->get_post('kvideo_id');
		
		if($kvideo_id){
			$this->load->view('events/user_events/player2',$this->data);
		}
	}
	
	public function multi_frame_player(){
		$this->data['kvideo_id']= $kvideo_id= $this->input->get_post('kvideo_id');
		
		if($kvideo_id){
			$this->load->view('events/user_events/player2',$this->data);
		}
	}
	
	public function set_endrose_product(){
		$product_id= $this->input->get_post('product_id');
		$frame_id= $this->input->get_post('frame_id');
		
		
		if(!$frame_id OR !$product_id) {
			$response = array(
				'status' => 'error',
			);
		}
		else{
			$frame_data=array(
				'product_id' => $product_id,
			);
				
			$this->ws_model->edit_frame($frame_id,$frame_data);
			$response = array(
				'status' => 'success'
			);
		}
		//echo "<pre>"; print_r($response);
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response));
			
		
	}
	
	function humanTiming($user_id,$created_on)
	{
		
		$currentTime= $this->currentTime($user_id);
		$createdTime= $created_on;
		$time = $currentTime - $createdTime; // to get the time since that moment
		$time = ($time<1)? 1 : $time;
		$tokens = array (
			31536000 => 'year',
			2592000 => 'month',
			604800 => 'week',
			86400 => 'day',
			3600 => 'hour',
			60 => 'minute',
			1 => 'second'
		);
		foreach ($tokens as $unit => $text) {
			if ($time < $unit) continue;
			$numberOfUnits = floor($time / $unit);
			return $numberOfUnits.' '.$text.(($numberOfUnits>1)?'s':'');
		}
    }
	
	
	function videoDataUrl($kaltura_video_id){
		$dataUrl="http://14.tagframe.com/p/101/sp/10100/playManifest/entryId/".$kaltura_video_id."/flavorIds/0,2,3,4,5,6,7/format/applehttp/protocol/http/a.m3u8";
		return $dataUrl;
	}
	
	function videoThumbnailUrl($videoThumbnailUrl){
		$thumbnailUrl = $videoThumbnailUrl."/width/600/height/300";
		return $thumbnailUrl;
	}
	
	public function dateTime($user_id){
		$get_time_zone= $this->ws_model->get_time_zone($user_id);
		if($get_time_zone){
			 $time_zone=$get_time_zone->time_zone;
			date_default_timezone_set($time_zone);
		}
		
		$date= date('Y-m-d H:i:s');
		return $date;
	}
	
	public function setTimeZone($user_id,$time){
		$get_time_zone= $this->ws_model->get_time_zone($user_id);
		if($get_time_zone){
			 $time_zone=$get_time_zone->time_zone;
			date_default_timezone_set($time_zone);
		}
		
		//$datetime= date('F d, Y G:i A', $time);
		$datetime= date('F d, Y g:i A', $time);
		return $datetime;
	}
	
	function currentTime($user_id){
		$currentTime= strtotime($this->dateTime($user_id));
		return $currentTime;
	}
	
	function date_to_time($user_id,$date){
		$get_time_zone= $this->ws_model->get_time_zone($user_id);
		if($get_time_zone){
			 $time_zone=$get_time_zone->time_zone;
			date_default_timezone_set($time_zone);
		}
		
		$date_to_time= strtotime($date);
		return $date_to_time;
		
	}
    function player_fullscreen(){
        $event_id= $this->input->get_post('event_id');
		$video_duration =$this->input->get_post('video_duration');
		$kvideo_id =$this->input->get_post('kvideo_id');
		$partner_id= $this->input->get_post('partner_id');
		$video_id= $event_id;
		$this->data['user_id']= $user_id = $this->ion_auth->get_user_id();
		/* $this->template->set_title('Create Event');
		
		$this->load->library('upload');
		$this->load->model('videos/videos_model');
		$event = $this->videos_model->get_video('id', $event_id, $kaltura_user_id='', $active=1);
		$kaltura_video_id = $event->kaltura_video_id;
		$video = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $kaltura_video_id, $categoriesId = TRUE);
		$duration = $video['result']->objects[0]->duration;
		$views = $video['result']->objects[0]->views;
		$thumbUrl = $video['result']->objects[0]->thumbnailUrl;
		$thumbnailUrl=$this->videoThumbnailUrl($thumbUrl);
		$dataUrl=$this->videoDataUrl($kaltura_video_id);
		$video_id = $event->id;
		 */
		$video_frames = $this->videos_model->get_video_frames($video_id);
		$frames = array();
		if( ! empty($video_frames)) {
			foreach($video_frames as $frame) {
				$frameDataUrl = "";
				if($frame->media_type == 'VIDEO'){
					$frm_kaltura_video_id = $frame->kaltura_video_id;
					$frmvideo = $this->kaltura->videolist($access_type='ADMIN', $kaltura_user='', $page='', $frm_kaltura_video_id, $catId = TRUE);
					$frameDataUrl=$this->videoDataUrl($frm_kaltura_video_id);
				}
				$magento_product = $this->bwt_magento->get_product($frame->product_id);
				if($frame->media_type=="VIDEO"){
					$frame_media_type=111;
				}
				else if($frame->media_type=="IMAGE"){
					$frame_media_type=110;
				}
				$ms= $frame->end_time-$frame->start_time;
				$s = intval($ms/1000);
				$frameTime = sprintf('%02d:%02d:%02d', ($s / 3600), ($s / 60 % 60), $s % 60);
				$frames[] = array(
					'frame_id' => $frame->id,
					'user_id' => $frame->user_id,
					'product_id' => $frame->product_id,
					'product_image' => $magento_product->getImageUrl(),
					'frame_title' => $frame->title,
					'frame_start_time' => $frame->start_time,
					'frame_end_time' => $frame->end_time,
					'frame_media_type' => $frame_media_type,
					'frame_kmedia_id' => $frame->frame_kaltura_media_id,
					'frame_thumbnail_url' => $frame->thumbnail_url,
					'frame_image_url' => $frame->image_url,
					'frame_data_url' => $frameDataUrl,
					'frame_product_url' => $magento_product->getProductUrl(),
					'frame_resource_type' =>"internet",
					'frame_time'=>$frameTime
				);
			}
		}
		$kvideoInfo = $this->kaltura->kvideo($kaltura_video_id);
		$this->data['frames']=$frames;
		//$this->data['player_id']= abs(crc32(uniqid()));
		$this->data['video_duration']= $video_duration;
		$this->data['event_id']=$event_id;
		$this->data['kvideo_id']=$kvideo_id;
		$this->data['partner_id']=$partner_id;
		/* $this->data['thumbnail']=$thumbnailUrl;
		$this->data['data_url']=$dataUrl; */
		
		$this->data['video_id'] = $video_id;
		
		
		
		if(!isset($_COOKIE['player_id'])) {
			$this->data['player_id']= $cookie_value = abs(crc32(uniqid()));
		    setcookie('player_id', $cookie_value, time() + (86400 * 30), "/");
		} else {
			$this->data['player_id']= $_COOKIE['player_id'];
		}
		
		$this->load->view('events/event_fullscreen_info', $this->data);
	}
	
}		