<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Event_model extends CI_Model {
    function __construct() {
		parent::__construct();
	}
	
	public function get_notifications($user_id, $limit, $offset) {
		$this->db->select('n.*, u.first_name, u.last_name, u.profile_image');
		$this->db->from('notifications n');
		$this->db->join('users u', 'u.id=n.from_user_id');
		$this->db->where('n.to_user_id', $user_id);
		$this->db->order_by('n.created_on', 'desc');
		$this->db->limit($limit, $offset);
		$query = $this->db->get();
		return $query->result();
	}
	
	public function count_notifications($user_id) {
		$this->db->select('n.*');
		$this->db->from('notifications n');
		$this->db->join('users u', 'u.id=n.from_user_id');
		$this->db->where('n.to_user_id', $user_id);
		return $this->db->count_all_results();
	}
	
	public function get_tagged_events($user_id) {
		
		$this->db->select('v.id');
		$this->db->from('tagged_users tu');
		$this->db->join('videos v', 'v.id=tu.video_id', 'left');
		$this->db->join('ads_frame f', 'f.id=tu.frame_id', 'left');
		$this->db->join('users u', 'u.id=tu.user_id');
		$this->db->where('tu.tagged_user_id', $user_id);
		
		return $this->db->count_all_results();
	}
	
	public function search_user($user_id)
	{
		$this->db->select('*');
		$this->db->from('users');
		$this->db->where('active', 1);
		$this->db->where('id',$user_id);
		$query = $this->db->get();
		return $query->row();
	}
	
	public function remove_tag_user($tag_id){
		$this->db->where('id',$tag_id);
		$this->db->delete('tagged_users');
	}
	
	public function get_tagged_users_on_event($video_id) {
		$this->db->select('u.id,u.first_name,u.profile_image,tu.id as tag_id,tu.tagged_user_id');
		$this->db->from('tagged_users tu');
		$this->db->join('videos v', 'v.id=tu.video_id', 'left');
		$this->db->join('users u', 'u.id= tu.tagged_user_id');
		$this->db->where('tu.video_id', $video_id);
		$this->db->order_by('tu.created_at', 'desc');
		$query = $this->db->get();
		return $query->result();
	}
	public function update_event($event_id,$data){
		$this->db->where('id',$event_id);
		$this->db->update('videos',$data);
	}
	public function update_frame($frame_id,$data){
		$this->db->where('id',$frame_id);
		$this->db->update('ads_frame',$data);
	}
	
	
}