<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');





class Frame_model extends CI_Model {





    function __construct() {


		parent::__construct();


	}


	


	public function get_video_frames($video_id) {


		$this->db->select('f.*, v.title');


		$this->db->from('ads_frame f');


		$this->db->join('videos v', 'v.id=f.video_id', 'left');


		if($video_id) {


			$this->db->where('f.video_id', $video_id);


		}
        $this->db->order_by('f.start_time','ASC');
		

		$query = $this->db->get();


		return $query->result();


	}


	


	public function get_frame($frame_id) {


		$this->db->where('id', $frame_id);


		$query = $this->db->get('ads_frame');


		return $query->row();


	}


	


	function insert($table, $data){


		$this->db->insert($table, $data);


		return $this->db->insert_id();


	}


	


	function update($table, $data, $where){


		$this->db->where($where);


		$this->db->update($table, $data); 


		return true;


	}


	


	function frame_update($frame_id, $frame_data){


		$this->db->where('id',$frame_id);


		$this->db->update('ads_frame',$frame_data);


	}


	


	function delete($table, $where){


		$this->db->where($where);


		$this->db->delete($table);


	}


	


	function get_product_name($user_id){


		$this->db->select('id, name');


		$this->db->where('user_id', $user_id);


		$query = $this->db->get('products');


		return $query->result();


	}


	


	function get_startTime_status($id, $video_id, $start_time, $end_time){


		$this->db->select('p.name, af.start_time, af.end_time');


		$this->db->from('ads_frame af');


		$this->db->join('products p', 'p.id=af.product_id', 'left');


		$this->db->where("((af.start_time <= '$start_time' AND af.end_time >= '$start_time') or (af.start_time <= '$end_time' AND af.end_time >= '$end_time')) and af.end_time!=0");


		$this->db->where('af.video_id', $video_id);


		$this->db->where('af.id !=', $id);


		$query = $this->db->get(); 


		return $query->result();


	}


	


	function get_all_frames_bytime($video_id){


		$this->db->select('start_time, end_time');


		$this->db->from('ads_frame');


		$this->db->where('video_id', $video_id);


		$this->db->where('active', 1);


		$this->db->order_by('end_time', 'ASC');


		$query = $this->db->get();


		return $query->result();


	}


	


	function get_video_duration($video_id){


		$this->db->select('video_duration');


		$this->db->from('videos');


		$this->db->where('active', 1);


		$this->db->where('id', $video_id);


		$query = $this->db->get();


		return $query->row()->video_duration;


	}





	


	//--------------------Ankit


	function get_frame_videos($user_id, $video_id=null){


		$this->db->select('vs.title, af.*');


		$this->db->from('videos vs');


		$this->db->join('ads_frame af', 'vs.id = af.video_id', 'right');


		$this->db->where('vs.user_id', $user_id);


		


		if(!empty($video_id))


			$this->db->where('vs.id', $video_id);


		


		$query = $this->db->get();


		return $query->result();


	}


	


	function get_frame_detail($frame_id){


		$this->db->select('af.*, vds.title, vds.id as vid_id');


		$this->db->from('ads_frame af');


		$this->db->join('videos vds', 'vds.id = af.video_id', 'right');


		$this->db->where('af.id', $frame_id);


		$query = $this->db->get('ads_frame');


		return $query->row();


	}


	


	function get_video_id($frame_id){


		$this->db->select('video_id');


		$this->db->where('id',$frame_id);


		$query = $this->db->get('ads_frame');


		return $query->row();


	}


}