<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Friends extends MY_Controller {
    public $data;
	
	function __construct() {
		parent::__construct();
		
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login');
		}
		
		$this->load->language('friends');
		$this->load->model('friends_model');
		$this->load->library('contacts');
		$this->load->library('form_validation');
		$this->load->library('common_lib');
	}
	
	function followers()
    {
        $this->template->set_title('Followers');
		
		$user_id = $this->ion_auth->get_user_id();
		$this->data['user_id'] = $user_id;
		
		$this->data['followers'] = $this->friends_model->get_followers($user_id);
		
		// get friends pending request
		$this->data['pending_request'] = $this->friends_model->get_friend_pending_lists($user_id);
		
		// get friends waiting request
		$this->data['waiting_request'] = $this->friends_model->get_friend_waiting_lists($user_id);
	
        $this->template->load_view('friends/followers', $this->data);
    }
	
	function following()
    {
        $this->template->set_title('Following');
		
		$user_id = $this->ion_auth->get_user_id();
		$this->data['user_id'] = $user_id;
		
		$this->data['following'] = $this->friends_model->get_following($user_id);
		
		// get friends pending request
		$this->data['pending_request'] = $this->friends_model->get_friend_pending_lists($user_id);
		
		// get friends waiting request
		$this->data['waiting_request'] = $this->friends_model->get_friend_waiting_lists($user_id);
	
        $this->template->load_view('friends/following', $this->data);
    }
	
	public function recent_followers() {
		$user_id = $this->ion_auth->get_user_id();
		$data['total_followers'] = $this->friends_model->count_followers($user_id);
		$data['followers'] = $this->friends_model->get_recent_followers($user_id);
		$this->load->view('friends/recent_followers', $data);
	}
	
	function request_unfollow($type, $user_to){
	
		$user_id = $this->ion_auth->get_user_id();
	
		$this->session->set_flashdata('message', 'Unfollow successfully.');
		
		if($type == 'follower') {
		
			$this->friends_model->delete_followers($user_id, $user_to);
			redirect('friends/followers');
		} 
		else {
			$this->friends_model->delete_following($user_id, $user_to);
			redirect('friends/following');
		}
	}
	
	function search(){
		$this->template->set_title('Friends Search');
		
		$email = $this->input->get_post('search');
		$this->data['headsearch']= $headsearch = $this->input->get_post('headsearch');
		$user_id = $this->session->userdata('user_id');
		$this->data['user_id'] = $user_id;
	
		if($email) { 
			
			if(strlen(strrchr($this->input->post('search'), '@')) > 0){
				$this->data['searchs'] = $this->friends_model->get_search_users($user_id, $email);
			} else { 
				$this->data['searchs'] = $this->friends_model->get_search_users_byusername($user_id, $email);
			}
			
			foreach($this->data['searchs'] as $k => $search_user){
				
				$check_request = $this->friends_model->get_request_value($user_id, $search_user->id);
				
				if(!empty($check_request)){
					if($check_request->user_from == $search_user->id and $check_request->user_to == $user_id and $check_request->request == 0){
						
						$this->data['searchs'][$k]->action = 'Accept';
					
					} elseif($check_request->user_from == $user_id and $check_request->user_to == $search_user->id and $check_request->request == 0) {
						$this->data['searchs'][$k]->action = 'Pending';
					} elseif($check_request->request == 1) {
						$this->data['searchs'][$k]->action = 'Friend';
					} else {
						$this->data['searchs'][$k]->action = 'Add';
					}
				} else {
					$this->data['searchs'][$k]->action = 'Add';
				}
			}
		} else { 
			$this->data['searchs'] = '';
		}
		
		// get friends pending request
		$this->data['pending_request'] = $this->friends_model->get_friend_pending_lists($user_id);
		
		// get friends waiting request
		$this->data['waiting_request'] = $this->friends_model->get_friend_waiting_lists($user_id);
		
		$this->template->load_view('friends/friend_search', $this->data);
	}
	
	
	function request_sent($to_user_id){
		
		$user_id = $this->ion_auth->get_user_id();
		
		$this->load->model('ion_auth_model');
		$result = $this->ion_auth_model->check_viewer_privacy($to_user_id);
		
		$request = 0;
		if( ! $result) {
			$request = 1;
		}
		
		$arr = array(
			'user_from' => $user_id,
			'user_to' => $to_user_id,
			'request' => $request,
			'created_on' => time()
		);
		
		$id = $this->friends_model->insert('friend_requests', $arr);
		
		// Notifications
		/* $notifydata = array(
			'from_user_id' => $user_id,
			'to_user_id' => $to_user_id,
			'action_type' => 'sendRequest',
			'created_on' => time() 
		);
		$this->common_model->insert_notification($notifydata); */
		
		$to_user= $to_user_id;
		
		if($id){
			$from_user_id=$user_id;
			$to_userid=$to_user;
			$action_type =4;
			$event_id =$to_user;
			
			if($from_user_id !=$to_user_id){
			 $this->common_lib->notification($from_user_id,$to_userid,$action_type,$event_id);
			}
				
		}
		
		redirect('friends/following');
	}
	
	function request_unfriend($user_to){
	
		$user_id = $this->ion_auth->get_user_id();
		
		$this->friends_model->remove_friends_list($user_id, $user_to);
		
		$this->friends_model->remove_friend_requests($user_id, $user_to);
		
		$this->session->set_flashdata('message', 'Unfriend successfully.');
		redirect('friends/following/'.$user_id);
	}
	
	function accept_request($user_from){
		
		$user_id = $this->ion_auth->get_user_id();
		
		$update_arr = array(
			'user_from' => $user_from, 
			'user_to' => $user_id
		);
		
		$this->friends_model->update('friend_requests', array('request' => 1), $update_arr);
		
		/*$insert_arr1 = array( 
			'user_id' => $user_from,
			'friend_id' => $user_id,
			'created_on' => time()
		);
		
		$insert_arr2 = array( 
			'user_id' => $user_id,
			'friend_id' => $user_from,
			'created_on' => time()
		);
	
		$this->friends_model->insert('friends_list', $insert_arr1);
		$this->friends_model->insert('friends_list', $insert_arr2);
		*/
		
		// Notifications
		$notifydata = array(
			'from_user_id' => $user_id,
			'to_user_id' => $user_from,
			'action_type' => 'acceptRequest',
			'created_on' => time() 
		);
		$this->common_model->insert_notification($notifydata);
		
		redirect('friends/followers');
	}
	
	function cancel_request($user_to){
	
		$user_id = $this->ion_auth->get_user_id();
		
		$where = array(
			'user_from' => $user_id,
			'user_to' => $user_to,
			'request' => 0
		);
		$this->friends_model->delete('friend_requests', $where);
		
		// Notifications
		$notifydata = array(
			'from_user_id' => $user_id,
			'to_user_id' => $user_to,
			'action_type' => 'cancelRequest',
			'created_on' => time() 
		);
		$this->common_model->insert_notification($notifydata);
		
		redirect('friends/followers');
	}
	
	public function recent_friends() {
		$user_id = $this->ion_auth->get_user_id();
		$data['total_friends'] = $this->friends_model->count_friends($user_id);
		$data['friends'] = $this->friends_model->get_recent_friends($user_id);
		$this->load->view('friends/recent_friends', $data);
	}
	
	public function gmail_contacts() {
	
		$this->template->set_title('Gmail Contacts');
		
		$authcode = $this->input->get('code');
		$data['results'] = $this->contacts->result($authcode);
		
		$this->form_validation->set_rules('contacts[]', 'Contacts', 'required');
		$this->form_validation->set_error_delimiters('<div class="error">', '</div>');
		if($this->form_validation->run() == false) {
			$this->template->load_view('friends/gmail_contacts', $data);
		} 
		else {
			$contacts = $this->input->post('contacts');
			
			$user = $this->ion_auth->user()->row();
			
			$this->load->helper('string');
			$friend_request_code = md5($user->id);
			
			$from = $user->email;
			for($i=0; $i<count($contacts); $i++) {
				
				$to = $contacts[$i];
				
				$email_check = $this->ion_auth->email_check($to);
				
				if( ! $email_check) {
					$message = 'Dear, <br /><br />';
					$message .= 'I am feeling so happy and glad sending you friend request. Please accept and join with TagFrame. <br /><br />';
					$message .= '<a href="'.site_url('auth/signup/'.$friend_request_code).'" style="padding:10px; background:#286090; color:#ffffff; ">Accept</a>';
					$message .= "<br /><br />Team TagFrame";
					
					$config['protocol'] = 'sendmail';
					$config['mailpath'] = '/usr/sbin/sendmail';
					$config['charset'] = 'iso-8859-1';
					$config['wordwrap'] = TRUE;
					$config['mailtype'] = 'html';
					$this->email->initialize($config);
					
					$this->email->clear();
					$this->email->from($from, 'TagFrame');
					$this->email->to($to);
					$this->email->subject("Friend Request");
					$this->email->message($message);
					$this->email->send();
				}
			}
			
			$this->ion_auth->update($user->id, array('friend_request_code' => $friend_request_code));
			
			$this->session->set_flashdata('message', 'Invitation has been send to selected E-mail ID');
			redirect('friends/followers');
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	/* Mahesh */
	
	
	function get_followers($user_id=null)
    {
        $this->template->set_title('Followers');
		
		$this->data['user_id'] = $user_id;
		
		$this->data['total_followers'] = Modules::run('tagstream/followers');
		$this->data['total_following'] = Modules::run('tagstream/following');
		//$this->data['user'] = $this->ion_auth->get_user($user_id);
		$this->data['followers'] = $this->friends_model->get_followers($user_id);
		$this->data['profileData'] = Modules::run('friends/get_profile',$user_id);
		// get friends pending request
		$this->data['pending_request'] = $this->friends_model->get_friend_pending_lists($user_id);
		
		// get friends waiting request
		$this->data['waiting_request'] = $this->friends_model->get_friend_waiting_lists($user_id);
	
         $this->template->load_view('friends/profile/followers', $this->data);
    }
	
	function get_profile($user_id=null){
		
		if (!$user_id)
        {
            redirect('auth/login', 'refresh');
        }
		
       /*  $this->data['recent_friends'] = Modules::run('friends/recent_friends');
		$this->data['recent_messages'] = Modules::run('messages/recent_messages'); */
		$this->load->model('events/event_model');
		
		$this->data['number_of_following'] = $this->ws_model->count_following($user_id);
		$this->data['number_of_followers'] = $this->ws_model->count_followers($user_id);
		$this->data['user'] = $this->ion_auth->get_user($user_id);
		$this->data['frames'] = $this->ws_model->count_user_frames($user_id);
		$this->data['events'] = $this->ws_model->count_user_events($user_id);
		$this->data['timelines']= $this->event_model->get_tagged_events($user_id);
		$this->data['user_id'] =$user_id;
		$this->data['is_following']= $this->friends_model->get_friend($this->session->userdata('user_id'),$user_id);
		$this->load->view('friends/profile/profile_common',$this->data);
	}
	
	function get_following($user_id=null)
    {
        $this->template->set_title('Following');
		
		
		$this->data['user_id'] = $user_id;
		//$this->data['user'] = $this->ion_auth->get_user($user_id);
		
		$this->data['total_followers'] = Modules::run('tagstream/followers');
		$this->data['total_following'] = Modules::run('tagstream/following');
		
		$this->data['following'] = $this->friends_model->get_following($user_id);
		
		$this->data['profileData'] = Modules::run('friends/get_profile',$user_id);
		
		// get friends pending request
		$this->data['pending_request'] = $this->friends_model->get_friend_pending_lists($user_id);
		
		// get friends waiting request
		$this->data['waiting_request'] = $this->friends_model->get_friend_waiting_lists($user_id);
	
        $this->template->load_view('friends/profile/following', $this->data);
    }
	
	function friend_delete($user_to){
	
		$user_id = $this->ion_auth->get_user_id();
		
		$this->friends_model->remove_friends_list($user_id, $user_to);
		
		$this->friends_model->remove_friend_requests($user_id, $user_to);
		
		$this->session->set_flashdata('message', 'Unfriend successfully.');
        
		redirect('friends/get_following/'.$user_id);
	}
   
	
	function search_user($email= null){
		$this->template->set_title('Friends Search');
		
        if(!$email){
			$email = $this->input->post('search');
		}
		$this->data['keyword']=$email;
 
		$user_id = $this->session->userdata('user_id');
		$this->data['user_id'] = $user_id;
		
        $this->data['total_followers'] = Modules::run('tagstream/followers');
		$this->data['total_following'] = Modules::run('tagstream/following');
	    $this->data['profileData'] = Modules::run('friends/get_profile',$user_id);
		if($email) { 
			
			if(strlen(strrchr($this->input->post('search'), '@')) > 0){
				$this->data['searchs'] = $this->friends_model->get_search_users($user_id, $email);
			} else { 
				$this->data['searchs'] = $this->friends_model->get_search_users_byusername($user_id, $email);
			}
			
			foreach($this->data['searchs'] as $k => $search_user){
				
				$check_request = $this->friends_model->get_request_value($user_id, $search_user->id);
				
				if(!empty($check_request)){
					if($check_request->user_from == $search_user->id and $check_request->user_to == $user_id and $check_request->request == 0){
						
						$this->data['searchs'][$k]->action = 'Accept';
					
					} elseif($check_request->user_from == $user_id and $check_request->user_to == $search_user->id and $check_request->request == 0) {
						$this->data['searchs'][$k]->action = 'Pending';
					} elseif($check_request->request == 1) {
						$this->data['searchs'][$k]->action = 'Friend';
					} else {
						$this->data['searchs'][$k]->action = 'Add';
					}
				} else {
					$this->data['searchs'][$k]->action = 'Add';
				}
			}
		} else { 
			$this->data['searchs'] = '';
		}
		
		// get friends pending request
		$this->data['pending_request'] = $this->friends_model->get_friend_pending_lists($user_id);
		
		// get friends waiting request
		$this->data['waiting_request'] = $this->friends_model->get_friend_waiting_lists($user_id);
		
       
		$this->template->load_view('friends/profile/friend_search', $this->data);
	}
	
	function friend_request_sent($to_user_id){
		
		$user_id = $this->ion_auth->get_user_id();
		
		$this->load->model('ion_auth_model');
		$result = $this->ion_auth_model->check_viewer_privacy($to_user_id);
		
		$request = 0;
		if( ! $result) {
			$request = 1;
		}
		
		$arr = array(
			'user_from' => $user_id,
			'user_to' => $to_user_id,
			'request' => $request,
			'created_on' => time()
		);
		
		$id = $this->friends_model->insert('friend_requests', $arr);
		
		// Notifications
		/* $notifydata = array(
			'from_user_id' => $user_id,
			'to_user_id' => $to_user_id,
			'action_type' => 'sendRequest',
			'created_on' => time() 
		);
		$this->common_model->insert_notification($notifydata); */
		
		$to_user= $to_user_id;
		
		if($id){
			$from_user_id=$user_id;
			$to_userid=$to_user;
			$action_type =4;
			$event_id =$to_user;
			
			if($from_user_id !=$to_user_id){
			 $this->common_lib->notification($from_user_id,$to_userid,$action_type,$event_id);
			}
				
		}
		$this->session->set_flashdata('message', 'Successfully Followed');
		redirect('friends/get_following/'.$user_id);
	}
	function profile($user_id){
		
		if (!$this->ion_auth->logged_in())
        {
            redirect('auth/login', 'refresh');
        }
		
		$this->data['followers'] = Modules::run('tagstream/followers');
		$this->data['following'] = Modules::run('tagstream/following');
		$this->data['user'] = $this->ion_auth->get_user($user_id);
		$this->template->load_view('friends/friend_profile',$this->data);
	}
	
	function unfollow(){
		$user_from= $this->input->get_post('user_from');
	    $action= $this->input->get_post('action');
		$user_to= $this->input->get_post('user_to');
		$this->session->set_flashdata('message', 'Unfollow successfully.');
		if(!$user_from or !$user_to){
			$response=array(
			'status'=>'error'
			);
		}
		else{
			if($action == 'follow') {
				
		        $data=array(
				'user_from'=>$user_from,
				'user_to'=>$user_to,
				'request'=>1,
				'created_on'=>time()
				);
				
				$id = $this->friends_model->insert('friend_requests', $data);
				
				$response=array(
				'status'=>'success',
				
				);
				
				if($id){
					$from_user_id=$user_from;
					$to_userid=$user_to;
					$action_type =4;
					$event_id =$user_to;
					
					if($from_user_id !=$user_to){
					 $this->common_lib->notification($from_user_id,$to_userid,$action_type,$event_id);
					}
						
				}
		
			} 
			else {
				$this->friends_model->delete_following($user_from, $user_to);
				 $this->ws_model->delete_following_notification($user_from, $user_to);
				$response=array(
				'status'=>'success'
				);
			}
		}
		
		$this->output
			->set_content_type('application/json')
			->set_output(json_encode($response)); 
	}
	
	
	function friend_action($type, $user_to){
		$user_id = $this->ion_auth->get_user_id();
		$this->session->set_flashdata('message', 'Unfollow successfully.');
		
		if($type == 'follower') {
			$this->friends_model->delete_followers($user_id, $user_to);
			//redirect('friends/followers');
			$this->ws_model->delete_followers_notification($user_id, $user_to);
			redirect('friends/get_followers/'.$user_id);
		} 
		else {
			$this->friends_model->delete_following($user_id, $user_to);
			
            $this->ws_model->delete_following_notification($user_id, $user_to);
			
			redirect('friends/get_following/'.$user_id);
		}
	}
   
   /* Bloked features */
	
	public function blocked($user_id,$blocked){
		//$user_id= $this->input->get_post('user_id');
		$logged_user_id= $this->ion_auth->get_user_id();
		//$blocked= $this->input->get_post('blocked');
		if(!$user_id OR !$logged_user_id){
			$response= array(
				'status' => 'error'
			);
		} 
		else {
			/* operation 1=for block,0=Unblock */
			if($blocked==1){
				$data1=array(
				'is_blocked'=>$blocked,
				'request'=>0
				);
				$data2=array(
				'is_blocked'=>0,
				'request'=>0
				);
				
				$if_friend= $this->ws_model->check_friend($user_id,$logged_user_id);
				if(!$if_friend){
					$friendData1=array(
					'user_from'=>$logged_user_id,
					'user_to'=>$user_id,
					'request'=>0,
					'is_blocked'=>1,
					'created_on'=>$this->common_lib->currentTime($logged_user_id)
					);
					
					$friendData2=array(
					'user_from'=>$user_id,
					'user_to'=>$logged_user_id,
					'request'=>0,
					'is_blocked'=>0,
					'created_on'=>$this->common_lib->currentTime($logged_user_id)
					);
					$this->ws_model->insert_friend($friendData1);
					$this->ws_model->insert_friend($friendData2);
				}
				else{
					$this->ws_model->blocked_user_from($user_id,$logged_user_id,$data1);
					$this->ws_model->blocked_user_to($user_id,$logged_user_id,$data2);
					
					$this->ws_model->delete_followers_notification($user_id, $logged_user_id);
					$this->ws_model->delete_following_notification($user_id, $logged_user_id);
				
				}
			}
            if($blocked==0){
				$this->ws_model->delete_user_from($user_id, $logged_user_id);
				$this->ws_model->delete_user_to($user_id, $logged_user_id);
				
			}
			
			$response= array(
				'status' => 'success'
			);
		}
		
		redirect('friends/get_following/'.$user_id);
	}
  
	
}