<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');





class Messages extends MY_Controller {





    public $data;


	


	function __construct() {


		parent::__construct();


		$this->load->language('messages');


		$this->load->model('messages_model');


		


		if (!$this->ion_auth->logged_in())


        {


            //redirect them to the login page


            redirect('auth/login', 'refresh');


        }


	}


	


	function lists($mail_type){


		$this->template->set_title('Message');


		$user_id = $this->session->userdata('user_id');


		


		if($mail_type == 'inbox'){


			$totalRows = $this->messages_model->get_inbox_total_messages($user_id)->num;


		} else {


			$totalRows = $this->messages_model->get_sent_total_messages($user_id)->num;


		} 





		$this->load->library('pagination');


		$config['base_url'] = base_url().'messages/lists/'.$mail_type;


		$config['total_rows'] = $totalRows;


		$config['per_page'] = 3;


		$config['uri_segment'] = 4;


		$config['num_links'] = 5;


		$config['full_tag_open'] = '<ul class="pagination">';


	        $config['full_tag_close'] = '</ul><!--pagination-->';


		$config['first_link'] = '&laquo; First';


		$config['first_tag_open'] = '<li class="prev page">';


		$config['first_tag_close'] = '</li>';





		$config['last_link'] = 'Last &raquo;';


		$config['last_tag_open'] = '<li class="next page">';


		$config['last_tag_close'] = '</li>';





		$config['next_link'] = '>';


		$config['next_tag_open'] = '<li class="next page">';


		$config['next_tag_close'] = '</li>';





		$config['prev_link'] = '<';


		$config['prev_tag_open'] = '<li class="prev page">';


		$config['prev_tag_close'] = '</li>';





		$config['cur_tag_open'] = '<li class="active"><a href="">';


		$config['cur_tag_close'] = '</a></li>';





		$config['num_tag_open'] = '<li class="page">';


		$config['num_tag_close'] = '</li>';





		$this->pagination->initialize($config);


		


		if( $totalRows >= $config['per_page'] )	{


			$limit = $config['per_page'];


		}else{


			$limit = $totalRows;


		} 


		


		$offset = ($this->uri->segment($config['uri_segment'])) ? $this->uri->segment($config['uri_segment']) : 0; 


		


		$this->data['pagination'] = $this->pagination->create_links(); 


		$this->data['mail_type'] = $mail_type;


		


		if($mail_type == 'inbox'){


			$this->data['messages'] = $this->messages_model->get_inbox_message($user_id, $limit, $offset);


		} elseif($mail_type == 'sent') {


			$this->data['messages'] = $this->messages_model->get_sent_message($user_id, $limit, $offset);


		} 


		


		$this->template->load_view('messages/list', $this->data);


	}


	


	function delete($msg_type, $id){


		$where = array('id' => $id);


		


		if( $msg_type == 'inbox'){


			$udata = array('delete_receiver' => 0);


		} else {


			$udata = array('delete_sender' => 0);


		}


		


		$this->messages_model->update('message', $udata, $where);


		


		$this->session->set_flashdata('message', 'Message removed successfully.');


		redirect('messages/lists/'.$msg_type);


	}


	


	function message_view($id){


		$this->template->set_title('Message View');


		$this->template->set_layout('pagelet');


		


		$this->data['lists'] = $this->messages_model->get_message_details($id);


		//echo "<pre>"; print_r($this->data['lists']); die;


		$this->template->load_view('messages/view', $this->data);


	}


	


	function compose(){


		$this->template->set_title('Compose Message');


		$this->template->set_layout('pagelet');


		$this->template->add_js('modules/message.js');


		


		$user_id = $this->ion_auth->get_user_id();


		


		if($_POST){


			$arr = array(


				'user_from' => $user_id,


				'user_to' => $this->input->post('to_user_id'),


				'subject' => $this->input->post('subject'),


				'message' => $this->input->post('message'),


				'created_on' => time()


			);


			


			$this->messages_model->insert('message', $arr);


			


			// Notifications


			$notifydata = array(


				'from_user_id' => $user_id,


				'to_user_id' => $this->input->post('to_user_id'),


				'action_type' => 'sendMessage',


				'created_on' => time() 


			);


			$this->common_model->insert_notification($notifydata);


			


			redirect('messages/lists/sent');


		}


		


		$this->template->load_view('messages/compose', $this->data);


	}


	


	/*function ajax_check($value){


		$value = $this->messages_model->check_valid_username($value, $this->session->userdata('user_id'));


		


		if(!empty($value->id))


			echo $value->id;


		else


			echo 'null';


	}*/


	


	public function ajax_search_friends() {


		$keyword = $this->input->post('keyword', true);


		


		$user_id = $this->ion_auth->get_user_id();


		


		$this->load->model('friends/friends_model');


		$friends = $this->friends_model->get_friend_lists($user_id, $keyword);


		


		foreach($friends as $friend) {


			$username = str_replace($keyword, '<b>'.$keyword.'</b>', $friend->username);


		


			echo '<li onclick="set_item_id('.$friend->id.'); set_item(\''.str_replace("'", "\'", $friend->username).'\')">'.$username.'</li>';


		}


	}


	


	public function recent_messages() {


		$user_id = $this->ion_auth->get_user_id();


		$data['messages'] = $this->messages_model->get_recent_messages($user_id);


		$this->load->view('messages/recent_messages', $data);


	}





}