<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Product extends MY_Controller {
    public $data;
	
	function __construct() 
	{
		parent::__construct();
		$this->load->library('authentication', NULL, 'ion_auth');
       	$this->load->library('form_validation');
        $this->load->helper('url');
        $this->load->database();
        $this->lang->load('auth');
        $this->load->helper('language');
		$this->load->model('product_model');
	}
	
	public function index()
    {
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login', 'refresh');
		}
        	$this->template->set_title('Products');
		$this->template->add_js('modules/product_add.js');
		$this->template->set_layout('pagelet');
		
		$this->data['products'] = "products";
		
			if($this->input->post('product_name')){ 
			
			if ( $_FILES && $_FILES['video_file']['name'] ) {
		
				$this->load->library('upload');
				$uploadPath = 'media/products/';
				$config['upload_path'] = $uploadPath;
				$config['allowed_types'] = 'jpg|png|jpeg';
				$config['encrypt_name'] = TRUE;
				$this->upload->initialize($config);
				
				if (!$this->upload->do_upload('video_file')) {
					$this->data['error'] = $this->upload->display_errors();
					$this->session->set_flashdata('error',$this->data['error']);
					$imagePath = 'error';
					redirect('product');
				} else {
					$imagedata = $this->upload->data(); 
					$configImageResize = array(
						'source_image' => $config['upload_path'].$imagedata['file_name']
					);
					$video_detail = $configImageResize['source_image'];
					$this->session->set_flashdata('message', 'Your profile image is uploaded successfully...');
				}
				
				$imagedata['new_path']='media/products/thumbnail';
				$config['image_library'] = 'GD2';
				$config['source_image'] = $imagedata['full_path'];
				$config['create_thumb'] = TRUE;
				$config['maintain_ratio'] = TRUE;
				$config['width'] = 140;
				$config['height'] = 160;
				$config['new_image']=$imagedata['new_path'];
				
				$this->load->library('image_lib', $config);
				$this->image_lib->resize();
			
				$arr =array(
					'user_id' => $this->session->userdata('user_id'),
					'name' => $this->input->post('product_name'),
					'description' => $this->input->post('desc_name'),
					'price' => $this->input->post('price'),
					'quantity' => $this->input->post('qty'),
					'active' => 1,
					'created_on' =>  time()
				);
				$product_id=$this->product_model->insert('products',$arr);
				
				$dataArr = array(
					'user_id' => $this->session->userdata('user_id'),
					'type'    => 'products',
					'record_id' => $product_id,
					'title'  =>  $this->input->post('product_name'),
					'created_on' => time()
				);
				$value = $this->product_model->insert('notification', $dataArr);
				
				$category_product=array(
						'category_id' => $this->input->post('category'),
						'product_id' => $product_id,
				);
				
				$cat_id=$this->product_model->insert('category_products',$category_product);
				
				$product_images =array(
					'product_id' => $product_id,
					'file_name' => $imagedata['file_name']
				);
			}
			$image_product_id = $this->product_model->insert('product_images',$product_images);
			$data = array('profile_image' => $image_product_id
					);
			$where = array(
							'id' =>$product_id
			);
			$this->product_model->update('products',$data,$where);
			$this->session->set_flashdata('message', 'Product added successfully.');
			redirect('product/product/listing');
	
			}
		$this->data['category'] = $this->product_model->category_listing();
        $this->template->load_view('product/add_product', $this->data);
    }
	
	public function listing() {
		
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login', 'refresh');
		}
		
		$user_id = $this->session->userdata('user_id');
		
		$this->load->library('pagination');
		$totalRows = $this->product_model->get_total_product($user_id);
		$config['base_url'] = base_url().'product/listing/';
		$config['total_rows'] = $totalRows->num;
		$config['per_page'] = 2;
		$config['uri_segment'] = 3;
		$config['num_links'] = 5;
		$config['full_tag_open'] = '<ul class="pagination">';
        $config['full_tag_close'] = '</ul><!--pagination-->';
		$config['first_link'] = '&laquo; First';
		$config['first_tag_open'] = '<li class="prev page">';
		$config['first_tag_close'] = '</li>';
		$config['last_link'] = 'Last &raquo;';
		$config['last_tag_open'] = '<li class="next page">';
		$config['last_tag_close'] = '</li>';
		$config['next_link'] = '>';
		$config['next_tag_open'] = '<li class="next page">';
		$config['next_tag_close'] = '</li>';
		$config['prev_link'] = '<';
		$config['prev_tag_open'] = '<li class="prev page">';
		$config['prev_tag_close'] = '</li>';
		$config['cur_tag_open'] = '<li class="active"><a href="">';
		$config['cur_tag_close'] = '</a></li>';
		$config['num_tag_open'] = '<li class="page">';
		$config['num_tag_close'] = '</li>';
		$this->pagination->initialize($config);
		
		if($totalRows->num>=2)	{
			$limit = $config['per_page'];
		}else{
			$limit = $totalRows->num;
		} 
		$offset = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0; 
		$this->data['pagination'] = $this->pagination->create_links(); 
		$this->data['product_listing'] = $this->product_model->get_product_listing($user_id, $limit, $offset);
		$this->template->load_view('product/listing', $this->data);
	}
	
	public function product_delete($id) {
		
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login', 'refresh');
		}
		
		$user_id = $this->session->userdata('user_id');
		$where = array('id' => $id ,'user_id'=>$user_id);
		$this->product_model->delete('products',$where);
		
		$where = array('product_id' => $id);
		$this->product_model->delete('product_images',$where);
		
		$where = array('product_id' => $id);
		$this->product_model->delete('category_products',$where);
		$this->session->set_flashdata('message', 'Product removed successfully');
		 redirect('product/listing');
	}
	
	public function product_edit($product_id) {
		
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login', 'refresh');
		}
		$this->template->set_title('Profile');
		$this->template->set_layout('pagelet');
		$user_id =$this->ion_auth->get_user_id();
		
		$this->data['product_id'] = $product_id;
		$this->data['category'] = $this->product_model->category_listing();
		$this->data['products'] = $this->product_model->product_detail($product_id,$user_id);
		$this->data['product_category'] = $this->product_model->product_category($product_id);
		
		$this->form_validation->set_rules('product_name', 'product_name', 'trim|required');
		$this->form_validation->set_rules('category', 'category', 'trim|required');
		$this->form_validation->set_rules('desc_name', 'desc_name', 'trim|required');
		$this->form_validation->set_rules('price', 'price', 'trim|required');
		$this->form_validation->set_rules('qty', 'qty', 'trim|required');
		$this->form_validation->set_error_delimiters('<div class="error">', '</div>');
		
		if($this->form_validation->run() == true) {
			$product_data = array(
				'name' => $this->input->post('product_name', true),
                'description'  => $this->input->post('desc_name', true),
				'price'    => $this->input->post('price', true),
				'quantity'      => $this->input->post('qty', true)
            );
			
			$new_category = $this->input->post('category');
			
			$cat_update = array('category_id' => $new_category);
			$where = array('product_id' => $product_id);
			$id = $this->product_model->update('category_products',$cat_update,$where);
			
			$where = array('id' => $product_id,'user_id' => $user_id);
			$id1 = $this->product_model->update('products',$product_data,$where);
			$this->session->set_flashdata('message', 'Product updated successfully.');
			redirect('product/listing');
		}
		
		$this->template->load_view('product/edit_product', $this->data);
	}
	
	//----------------------Ankit
	public function product_images($id) {
		
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login', 'refresh');
		}
		$this->data['id'] = $id;
		$this->data['image_listing'] = $this->product_model->product_images_list($id);
		if($_POST){ 
			
			if ( $_FILES && $_FILES['image_file']['name'] ) {
		
				$this->load->library('upload');
				$uploadPath = 'media/products/';
				$config['upload_path'] = $uploadPath;
				$config['allowed_types'] = 'jpg|png|jpeg';
				$config['encrypt_name'] = TRUE;
				$this->upload->initialize($config);
				
				if (!$this->upload->do_upload('image_file')) {
					$this->data['error'] = $this->upload->display_errors();
					$this->session->set_flashdata('error',$this->data['error']);
					$imagePath = 'error';
					redirect('product/product_images/'.$id);
				} else {
					$imagedata = $this->upload->data(); 
					$configImageResize = array(
						'source_image' => $imagedata['file_name']
					);
					$video_detail = $configImageResize['source_image'];
				}
				
				$imagedata['new_path']='media/products/thumbnail';
				$config['image_library'] = 'GD2';
				$config['source_image'] = $imagedata['full_path'];
				$config['create_thumb'] = TRUE;
				$config['maintain_ratio'] = TRUE;
				$config['width'] = 140;
				$config['height'] = 160;
				$config['new_image']=$imagedata['new_path'];
				$this->load->library('image_lib', $config);
				$this->image_lib->resize();
				
				$product_images =array(
					'product_id' => $id,
					'file_name' => $video_detail
				);
				$image_product_id = $this->product_model->insert('product_images',$product_images);
			}
			redirect('product/product_images/'.$id);
		}
		$this->template->load_view('product/image_listing', $this->data);
	}
	
	public function product_set_image($id,$product_id) {
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login', 'refresh');
		}
		$default_image = array('profile_image' => $id);
		$where = array('id' => $product_id);
		
		$this->product_model->update('products',$default_image,$where);
		redirect('product/product_images/'.$product_id);
	}
	
	public function product_delete_image($id,$product_id) {
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login', 'refresh');
		}
		$where = array('id' => $id);
		
		$this->product_model->delete('product_images',$where);
		redirect('product/product_images/'.$product_id);
	}
	
	//--------------------End
	
	//Mahesh
	
	
	public function product_details($notification_id, $product_id)
	{
		$response=array();
        if($product_id){
			$productInfo= $this->common_model->notification_info($notification_id);
			
			$this->load->library('bwt_magento');
			$products = $this->bwt_magento->get_product($product_id);
			$mess= stristr($productInfo->event_id,":");
			$message= substr($mess,1);
			if(!empty($products)){
				$response= array(
					'product_id' => $products->getId(),
					'product_name' => $products->getName(),
					'product_url' => $products->getProductUrl(),
					'product_image' => $products->getImageUrl(),
					'message' => $message,
					'username'=>$productInfo->first_name,
					'product_price'=>number_format($products->getPrice(),2)
				);
				
			}
		}
		$this->data['response']=$response;
		 $this->template->load_view('product/product_details', $this->data);
	}
	
}