<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');





class Product_model extends CI_Model {


	


	function count_all_trash_products(){


		$this->db->select('count(*) as num');


		$this->db->where('active', 0);


		$query = $this->db->get('products');


		return $query->row()->num;


	}


	


	function delete_product($id){


		$this->db->where('id', $id);


		$this->db->update('products', array('active' => 0));


	}


	


	function restore_product($id){


		$this->db->where('id', $id);


		$this->db->update('products', array('active' => 1));


	}


	


	function delete_product_permanent($id){


		$this->db->where('id', $id);


		$this->db->delete('products');


		return true;


	}


	


	function delete_product_img_permanent($id){


		$this->db->where('product_id', $id);


		$this->db->delete('product_images');


		return true;


	}


	


	function get_all_trash_products($limit,$offset){


		$this->db->select('ps.*, pi.file_name,us.username');


		$this->db->from('products ps');


		$this->db->join('product_images pi', 'ps.id=pi.product_id', 'left');


		$this->db->join('users us', 'us.id = ps.user_id', 'left');


		$this->db->where('ps.active', 0);


		$this->db->limit($limit,$offset);


		$query = $this->db->get();


		return $query->result();


	}


	


	function get_total_product_byid($user_id)


	{


		$this->db->select('count(*) as num');


		$this->db->where('user_id', $user_id);


		$this->db->where('active', 1);


		$query = $this->db->get('products');


		return $query->row();


	}


	


	function get_all_products_byid($user_id, $limit,$offset)


	{


		$this->db->select('ps.*, pi.file_name,us.username');


		$this->db->from('products ps');


		$this->db->join('product_images pi', 'ps.id=pi.product_id', 'left');


		$this->db->join('users us', 'us.id = ps.user_id', 'left');


		$this->db->where('ps.user_id', $user_id);


		$this->db->where('ps.active', 1);


		$this->db->limit($limit,$offset);


		$query = $this->db->get();


		return $query->result();


	}


	


	//---------------- Ankit


	


	function insert($table, $data)


	{


		$id = $this->db->insert($table, $data);


		return $this->db->insert_id();


	}


	


	function update($table, $data, $where)


	{


		$this->db->where($where);


		$id = $this->db->update($table, $data);


		return $this->db->insert_id();


	}


	


	function delete($table, $where)


	{


		$this->db->where($where);


		$this->db->delete($table);


		return true;


	}


	


	function get_product_detail($product_id)


	{


		$this->db->select('pi.file_name,pi.*,ps.*');


		$this->db->from('products ps');


		$this->db->join('product_images pi', 'ps.id=pi.product_id', 'left');


		$this->db->where('ps.id',$product_id);


		$query = $this->db->get('products');


		return $query->row();


	}


	


	function get_all_products($limit,$offset)


	{


		$this->db->select('p.*, pi.file_name, u.username');


		$this->db->from('products p');


		$this->db->join('product_images pi', 'p.id=pi.product_id', 'left');


		$this->db->join('users u', 'u.id = p.user_id', 'left');


		$this->db->where('u.active', 1);


		$this->db->where('p.active', 1);


		$this->db->limit($limit,$offset);


		$query = $this->db->get();


		return $query->result();


	}


	


	function get_all_category()


	{


		$this->db->where('active', 1);


		$query = $this->db->get('categories');


		return $query->result();


	}


	


	function get_product_details($product_id)


	{


		$this->db->select('pds.*, pi.file_name, cp.category_id');


		$this->db->from('products pds');


		$this->db->join('product_images pi', 'pds.id=pi.product_id', 'left');


		$this->db->join('category_products cp', 'cp.product_id=pi.product_id', 'left');


		$this->db->where('pds.id',$product_id);


		$query = $this->db->get();


		return $query->row();


	}


	


	function get_total_product()


	{


		$this->db->select('count(p.id) as num');


		$this->db->from('products p');


		$this->db->join('users u', 'u.id = p.user_id', 'left');


		$this->db->where('u.active', 1);


		$this->db->where('p.active', 1);


		$query = $this->db->get();


		return $query->row();


	}


	


	function get_product_images($product_id, $pic_id)


	{


		$this->db->where('id !=',$pic_id);


		$this->db->where('product_id',$product_id);


		$query = $this->db->get('product_images');


		return $query->result();


	}


}