<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Users extends MY_Controller {
	public $data;
	function __construct() {
		parent::__construct();
		$this->load->model('users_model');
		
		if (!$this->ion_auth->is_admin())
        {
            //redirect them to the login page
            redirect('auth/admin_login', 'refresh');
        }
	}
	
	function index($offset=null){
		$this->data['title'] = "Users";
		$this->data['offset'] = $offset;
		$user_id = $this->session->userdata('user_id');
		
		$this->load->library('pagination');
		$totalRows = $this->users_model->count_all_users($user_id);
		$config['base_url'] = base_url().'users/index';
		$config['total_rows'] = $totalRows;
		$config['per_page'] = 10;
		$config['uri_segment'] = 3;
		$config['num_links'] = 5;
		$config['full_tag_open'] = '<ul class="pagination list_style">';
		$config['full_tag_close'] = '</ul><!--pagination-->';
		$config['first_link'] = '&laquo; First';
		$config['first_tag_open'] = '<li class="prev page">';
		$config['first_tag_close'] = '</li>';
		$config['last_link'] = 'Last &raquo;';
		$config['last_tag_open'] = '<li class="next page">';
		$config['last_tag_close'] = '</li>';
		$config['next_link'] = '>';
		$config['next_tag_open'] = '<li class="next page">';
		$config['next_tag_close'] = '</li>';
		$config['prev_link'] = '<';
		$config['prev_tag_open'] = '<li class="prev page">';
		$config['prev_tag_close'] = '</li>';
		$config['cur_tag_open'] = '<li class="active"><a href="">';
		$config['cur_tag_close'] = '</a></li>';
		$config['num_tag_open'] = '<li class="page">';
		$config['num_tag_close'] = '</li>';
		$this->pagination->initialize($config);
		
		if($totalRows>=$config['per_page'])	{
			$limit = $config['per_page'];
		}else{
			$limit = $totalRows;
		} 
		$offset = ($this->uri->segment($config['uri_segment'])) ? $this->uri->segment($config['uri_segment']) : 0;  
		
		$this->data['pagination'] = $this->pagination->create_links(); 
		
		$this->data['lists'] = $this->users_model->get_all_users($user_id, $limit, $offset);
		
		$this->load->view('users/admin/index', $this->data);
	}
	
	function edit_user($id){
		$this->data['title'] = "Edit Users";
		$this->data['id'] = $id;
		
		if($this->input->post('submit')){
			if ( $_FILES && $_FILES['profile_image']['name'] ) {
		
				$this->load->library('upload');
				$uploadPath = 'media/user_image/';
				$config['upload_path'] = $uploadPath;
				$config['allowed_types'] = 'jpg|png|jpeg';
				$config['encrypt_name'] = TRUE;
				$this->upload->initialize($config);
				
				if (!$this->upload->do_upload('profile_image')) {
					$this->data['error'] = $this->upload->display_errors();
					$this->session->set_flashdata('error',$this->data['error']);
					$imagePath = 'error';
					redirect('product');
				} else {
					$imagedata = $this->upload->data(); 
					$configImageResize = array(
						'source_image' => $config['upload_path'].$imagedata['file_name']
					);
					$pic_detail = $configImageResize['source_image'];
				}
			} else {
				$pic_detail = $this->input->post('profile_image_old');
			}
			
			$arr = array(
				
				'first_name' => $this->input->post('first_name'),
				'last_name' => $this->input->post('last_name'),
				'address' => $this->input->post('address'),
				'country_id' => $this->input->post('country'),
				'state' => $this->input->post('state'),
				'city' => $this->input->post('city'),
				'phone' => $this->input->post('phone'),
				'date_of_birth' => strtotime($this->input->post('date_of_birth')),
				'profile_image' => $pic_detail
			);
			
			$product_id=$this->users_model->update_user($id, $arr);
			redirect('users');
		}
		
		$this->data['list'] = $this->users_model->get_user_details($id);
		$this->data['state'] = $this->users_model->get_all_state($id);
		$this->data['country'] = $this->users_model->get_all_country($id);
		$this->load->view('users/admin/edit_user', $this->data);
	}
	
	function user_delete($id){
		$this->users_model->delete_user($id);
		redirect('users');
	}
	
	function trash_list($offset=null){
		$this->data['title'] = "Trash Users";
		$this->data['offset'] = $offset;
		$user_id = $this->session->userdata('user_id');
		
		$this->load->library('pagination');
		$totalRows = $this->users_model->count_all_trash_users($user_id);
		$config['base_url'] = base_url().'users/trash_list/';
		$config['total_rows'] = $totalRows;
		$config['per_page'] = 10;
		$config['uri_segment'] = 3;
		$config['num_links'] = 5;
		$config['full_tag_open'] = '<ul class="pagination list_style">';
		$config['full_tag_close'] = '</ul><!--pagination-->';
		$config['first_link'] = '&laquo; First';
		$config['first_tag_open'] = '<li class="prev page">';
		$config['first_tag_close'] = '</li>';
		$config['last_link'] = 'Last &raquo;';
		$config['last_tag_open'] = '<li class="next page">';
		$config['last_tag_close'] = '</li>';
		$config['next_link'] = '>';
		$config['next_tag_open'] = '<li class="next page">';
		$config['next_tag_close'] = '</li>';
		$config['prev_link'] = '<';
		$config['prev_tag_open'] = '<li class="prev page">';
		$config['prev_tag_close'] = '</li>';
		$config['cur_tag_open'] = '<li class="active"><a href="">';
		$config['cur_tag_close'] = '</a></li>';
		$config['num_tag_open'] = '<li class="page">';
		$config['num_tag_close'] = '</li>';
		$this->pagination->initialize($config);
		
		if($totalRows>=$config['per_page'])	{
			$limit = $config['per_page'];
		}else{
			$limit = $totalRows;
		} 
		$offset = ($this->uri->segment($config['uri_segment'])) ? $this->uri->segment($config['uri_segment']) : 0;  
		
		$this->data['pagination'] = $this->pagination->create_links(); 
		
		$this->data['lists'] = $this->users_model->get_all_trash_users($user_id, $limit, $offset);
		//echo "<pre>"; print_r($data['lists']); die;
		$this->load->view('users/admin/trash_list', $this->data);
	}
	
	function restore_user($id){
		$this->users_model->restore_user($id);
		redirect('users/trash_list');
	}
	
	function user_delete_permanent($id){
		$this->users_model->delete_user_permanent($id);
		redirect('users/trash_list');
	}
	
	//----------------Ankit
	function view_user($id){
		$this->data['title'] = "User Details";
		$this->data['id'] = $id;
		
		$this->data['user_details'] = $this->users_model->get_user_view_details($id);
		//echo "<pre>"; print_r($this->data['user_details']); die;
		$this->load->view('users/admin/user_details', $this->data);
	}
}