<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Videos extends MY_Controller {
	public $data;
	function __construct() {
		parent::__construct();
		$this->load->model('admin/videos_model');
	}
	
	public function index($offset = null){	
		$data['title'] = "Events";
	
		$this->load->library('pagination');
		$totalRows = $this->videos_model->get_total_video();
		$config['base_url'] = base_url().'videos/admin/videos/index/';
		$config['total_rows'] = $totalRows->num;
		$config['per_page'] = 10;
		$config['uri_segment'] = 5;
		$config['num_links'] = 5;
		$config['full_tag_open'] = '<ul class="pagination list_style">';
        $config['full_tag_close'] = '</ul><!--pagination-->';
		$config['first_link'] = '&laquo; First';
		$config['first_tag_open'] = '<li class="prev page">';
		$config['first_tag_close'] = '</li>';
		$config['last_link'] = 'Last &raquo;';
		$config['last_tag_open'] = '<li class="next page">';
		$config['last_tag_close'] = '</li>';
		$config['next_link'] = '>';
		$config['next_tag_open'] = '<li class="next page">';
		$config['next_tag_close'] = '</li>';
		$config['prev_link'] = '<';
		$config['prev_tag_open'] = '<li class="prev page">';
		$config['prev_tag_close'] = '</li>';
		$config['cur_tag_open'] = '<li class="active"><a href="">';
		$config['cur_tag_close'] = '</a></li>';
		$config['num_tag_open'] = '<li class="page">';
		$config['num_tag_close'] = '</li>';
		$this->pagination->initialize($config);
		
		if($totalRows->num >= $config['per_page'])	{
			$limit = $config['per_page'];
		}else{
			$limit = $totalRows->num;
		} 
		$offset = ($this->uri->segment($config['uri_segment'])) ? $this->uri->segment($config['uri_segment']) : 0; 
		
		$data['pagination'] = $this->pagination->create_links(); 
       
		$data['lists'] = $this->videos_model->get_all_events($limit,$offset);
		$this->load->view('admin/index',$data);
	}
	
	public function video_edit($video_id) {
		
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login', 'refresh');
		}
		$this->data['title'] = 'Event Edit';
		$this->data['video_id'] = $video_id;
		
		$this->form_validation->set_rules('title', 'title', 'trim|required');
		$this->form_validation->set_rules('tag_keyword', 'tag_keyword', 'trim|required');
		$this->form_validation->set_rules('desc_name', 'desc_name', 'trim|required');
		
		if($this->form_validation->run() == true) {
			
			if ( $_FILES && $_FILES['video_file']['name'] ) {
		
				$this->load->library('upload');
				$uploadPath = 'media/videos/';
				
				$config['upload_path'] = $uploadPath;
				$config['allowed_types'] = 'mp4';
				$config['encrypt_name'] = TRUE;
				$this->upload->initialize($config);
				
				if (!$this->upload->do_upload('video_file')) {
					$data['error'] = $this->upload->display_errors();
					$imagePath = 'error';
				} else {
					$imagedata = $this->upload->data(); 
					$configImageResize = array(
						'source_image' => $config['upload_path'].$imagedata['file_name']
					);
					
					$video_detail = $configImageResize['source_image'];
				}
			} else {
				$video_detail = $this->input->post('old_video_file', true);
			}
			
			$video_data = array(
				'title' => $this->input->post('title', true),
                'description'  => $this->input->post('desc_name', true),
				'tag_keyword'    => $this->input->post('tag_keyword', true),
				'video'    => $video_detail,
				'type'    => $this->input->post('type', true)
            );
			
			$id1 = $this->videos_model->video_update($video_data, $video_id);
			$this->session->set_flashdata('message', 'Event updated successfully.');
			redirect('videos/admin/videos/');
		}
		
		$this->data['video_details'] = $this->videos_model->get_video_detail($video_id);
		$this->load->view('videos/admin/edit_videos', $this->data);
	}
	
	public function video_details($id) {
	
		if (!$this->ion_auth->logged_in()) {
			redirect('auth/login', 'refresh');
		}
		$this->data['title'] = 'Event Details';
		$this->data['videos_details'] = $this->videos_model->get_video_detail_view($id);
		$this->load->view('videos/admin/video_details', $this->data);
	}
	
	function videos_delete($id){
		$this->videos_model->delete_video($id);
		redirect('videos/admin/videos');
	}
	
	
	//-----------------  Praveen
	
	public function event_lists($user_id, $offset = null){
		$data['title'] = "Event Lists";
	
		$this->load->library('pagination');
		$totalRows = $this->videos_model->get_total_video_byid($user_id);
		$config['base_url'] = base_url().'videos/admin/videos/event_lists/'.$user_id.'/';
		$config['total_rows'] = $totalRows->num;
		$config['per_page'] = 10;
		$config['uri_segment'] = 6;
		$config['num_links'] = 5;
		$config['full_tag_open'] = '<ul class="pagination list_style">';
        $config['full_tag_close'] = '</ul><!--pagination-->';
		$config['first_link'] = '&laquo; First';
		$config['first_tag_open'] = '<li class="prev page">';
		$config['first_tag_close'] = '</li>';
		$config['last_link'] = 'Last &raquo;';
		$config['last_tag_open'] = '<li class="next page">';
		$config['last_tag_close'] = '</li>';
		$config['next_link'] = '>';
		$config['next_tag_open'] = '<li class="next page">';
		$config['next_tag_close'] = '</li>';
		$config['prev_link'] = '<';
		$config['prev_tag_open'] = '<li class="prev page">';
		$config['prev_tag_close'] = '</li>';
		$config['cur_tag_open'] = '<li class="active"><a href="">';
		$config['cur_tag_close'] = '</a></li>';
		$config['num_tag_open'] = '<li class="page">';
		$config['num_tag_close'] = '</li>';
		$this->pagination->initialize($config);
		
		if($totalRows->num >= $config['per_page'])	{
			$limit = $config['per_page'];
		}else{
			$limit = $totalRows->num;
		} 
		$offset = ($this->uri->segment($config['uri_segment'])) ? $this->uri->segment($config['uri_segment']) : 0; 
		
		$data['pagination'] = $this->pagination->create_links(); 
       
		$data['lists'] = $this->videos_model->get_all_events_byid($user_id, $limit,$offset);
		$this->load->view('admin/index',$data);
	}
	
	function trash_list($offset=null){
		$this->data['title'] = "Trash Events";
		$this->data['offset'] = $offset;
		
		$this->load->library('pagination');
		$totalRows = $this->videos_model->count_all_trash_videos();
		$config['base_url'] = base_url().'videos/admin/videos/index/';
		$config['total_rows'] = $totalRows;
		$config['per_page'] = 10;
		$config['uri_segment'] = 5;
		$config['num_links'] = 5;
		$config['full_tag_open'] = '<ul class="pagination list_style">';
		$config['full_tag_close'] = '</ul><!--pagination-->';
		$config['first_link'] = '&laquo; First';
		$config['first_tag_open'] = '<li class="prev page">';
		$config['first_tag_close'] = '</li>';
		$config['last_link'] = 'Last &raquo;';
		$config['last_tag_open'] = '<li class="next page">';
		$config['last_tag_close'] = '</li>';
		$config['next_link'] = '>';
		$config['next_tag_open'] = '<li class="next page">';
		$config['next_tag_close'] = '</li>';
		$config['prev_link'] = '<';
		$config['prev_tag_open'] = '<li class="prev page">';
		$config['prev_tag_close'] = '</li>';
		$config['cur_tag_open'] = '<li class="active"><a href="">';
		$config['cur_tag_close'] = '</a></li>';
		$config['num_tag_open'] = '<li class="page">';
		$config['num_tag_close'] = '</li>';
		$this->pagination->initialize($config);
		
		if($totalRows>=$config['per_page'])	{
			$limit = $config['per_page'];
		}else{
			$limit = $totalRows;
		} 
		$offset = ($this->uri->segment($config['uri_segment'])) ? $this->uri->segment($config['uri_segment']) : 0;  
		
		$this->data['pagination'] = $this->pagination->create_links(); 
		
		$this->data['lists'] = $this->videos_model->get_all_trash_videos($limit, $offset);
		
		$this->load->view('admin/trash_list', $this->data);
	}
	
	function restore_event($id){
		$this->videos_model->restore_event($id);
		redirect('videos/admin/videos/trash_list');
	}
	
	function event_delete_permanent($id){
		$this->videos_model->delete_event_permanent($id);
		redirect('videos/admin/videos/trash_list');
	}
	
}